<?php 
//@ini_set( 'display_errors', 1 );
class Appointy_Appointments_Helper {



	/**

     * Initialize the class

     *

     * @since     1.0.0

     */

    public function __construct() {

		add_action('wp_ajax_appointy_get_appointments', array($this, 'get_appointments'));
		
		add_action('wp_ajax_appointy_get_recent_appointments', array($this, 'get_recent_appointments'));

		add_action('wp_ajax_appointy_update_appointment_datetime', array($this, 'update_appointment_datetime'));

		add_action('wp_ajax_appointy_cancel_service', array($this, 'cancel_service'));

		add_action('wp_ajax_appointy_complete_service', array($this, 'complete_service'));

		add_action('wp_ajax_appointy_get_avl_members', array($this, 'get_avl_members'));

		add_action('wp_ajax_appointy_update_staff_member', array($this, 'update_staff_member'));

		add_action('wp_ajax_appointy_delete_appointments', array($this, 'delete_appointments'));
		
		add_action('wp_ajax_appointy_add_feedback', array($this, 'add_feedback'));
		
		add_action( 'wp_ajax_load_booking_feedback',  array($this, 'load_booking_feedback') );
		
		add_action( 'wp_ajax_view_booking_review_details',  array($this, 'view_booking_review_details') );
		
		add_action( 'wp_ajax_load_pagination_appointments', [ $this, 'load_pagination_appointments' ] );
		
		add_action( 'wp_ajax_load_appointment_calendar', [ $this, 'load_appointment_calendar' ] );
		
		add_action('wp_ajax_appointy_load_view_attachments', array($this, 'load_view_attachments'));
		
		add_action('wp_ajax_appointy_mark_received_full_payment', array($this, 'mark_received_full_payment'));
		
		add_action('wp_ajax_appointy_load_repeating_services', array($this, 'load_repeating_services'));
		
		add_action('wp_ajax_appointy_cancel_repeat_service', array($this, 'cancel_repeat_service'));
		
		add_action('wp_ajax_appointy_cancel_all_repeat_service', array($this, 'cancel_all_repeat_service'));
		
		add_action('wp_ajax_appointy_send_payment_reminder', array($this, 'send_payment_reminder'));
		
    }

	

	/**

	 * Delete appointments

	 *

	 * @return array

	 */

	public static function delete_appointments() {

		global $wpdb;

		

		$data_ids = Appointy_Router_Helper::get_request_data( $_POST, 'data_ids' );

		

		$data_id_array = explode(",", $data_ids); 



		if(!empty($data_id_array)) {

			foreach($data_id_array as $appointmentid) {

				$force_delete = true;

				wp_delete_post( $appointmentid, $force_delete );

				

				$wpdb->query($wpdb->prepare('DELETE FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `appointment_id` = %d',$appointmentid));

			}

		}

		

		wp_send_json_success();

		die();

	}

	

	/**

	 * Update appointment date/time

	 *

	 * @return void

	 */

	public static function update_appointment_datetime() {

	    global $wpdb;

		

		$sid = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'id' );
		
		$appointment_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'appointment_id' );

		$service_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'service_id' );

		$booking_date = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'booking_date' );

		$booking_start_time = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'booking_start_time' );

		$booking_end_time = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'booking_end_time' );
		
		$member_id = Appointy_Router_Helper::get_sanitize_data($_POST['booked_service'],'member_id');
		$locationid = Appointy_Router_Helper::get_sanitize_data($_POST['booked_service'],'locationid');

		

		$update_booked_services['booking_date']	= $booking_date;

		$update_booked_services['booking_start_time']	= $booking_start_time;

		$update_booked_services['booking_end_time']	= $booking_end_time;

					

		$where = array(

			'appointment_id' => $appointment_id,

			'service_id' => $service_id

		);

		$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($update_booked_services),$where);
		
		if(!empty($_POST['booked_service']['selected_multiple_dates'])) {
			$selected_multiple_dates = $_POST['booked_service']['selected_multiple_dates'];
			
			$wpdb->query($wpdb->prepare('DELETE FROM `'.$wpdb->prefix.'appointy_multiple_dates` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
			$wpdb->query($wpdb->prepare('DELETE FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
			
			foreach($selected_multiple_dates as $selected_multiple_date){
				$multiple_dates['appointment_id'] 	= $appointment_id;
				$multiple_dates['service_id'] 		= $service_id;
				$multiple_dates['date'] 			= $selected_multiple_date;
				$multiple_dates['time'] 			= $booking_start_time;
				
				$wpdb->insert($wpdb->prefix.'appointy_multiple_dates',wp_unslash($multiple_dates));
				
				$bookingdata['appointment_id'] 		= $appointment_id;
				$bookingdata['service_id'] 		= $service_id;
				
				$bookingdata['type'] 			= 'booking';
				$bookingdata['date'] 			= $selected_multiple_date;
				
				if(Appointy_Router_Helper::get_sanitize_data($_POST['booked_service'],'fullday_timeslots') === 'full_day'){
				$bookingdata['dayoff_type'] 	= 'fullday';	
				}else{
				$bookingdata['start_time'] 		= $booking_start_time;
				$bookingdata['end_time'] 		= $booking_end_time;
				$bookingdata['dayoff_type'] 	= 'timeslot';
				}
				
				if($member_id > 0) {
				$bookingdata['member_id'] 		= $member_id;
				}
				if($locationid > 0) {
				$bookingdata['branch_id'] 		= $locationid;
				}
				
				$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));
			}
		}else{
			$bookingdata['appointment_id'] 		= $appointment_id;
			$bookingdata['service_id'] 		= $service_id;
			$bookingdata['dayoff_type'] 	= 'timeslot';
			$bookingdata['type'] 			= 'booking';
			$bookingdata['date'] 			= $booking_date;
			$bookingdata['start_time'] 		= $booking_start_time;
			$bookingdata['end_time'] 		= $booking_end_time;
			if($member_id > 0) {
			$bookingdata['member_id'] 		= $member_id;
			}
			if($locationid > 0) {
			$bookingdata['branch_id'] 		= $locationid;
			}
			
			$wpdb->insert($wpdb->prefix.'appointy_blocked_schedule',wp_unslash($bookingdata));
		}

		Appointy_Send_Email_Notification_Helper::send_service_reschedule_email_notifications($appointment_id,$sid);
		
		$booked_service = Appointy_Appointments_Helper::get_booked_service( $sid );
		
		$member_id = Appointy_Router_Helper::get_sanitize_data($booked_service,'member_id');
		$google_calendar_event_id = Appointy_Router_Helper::get_sanitize_data($booked_service,'google_calendar_event_id');
		$customer_google_calendar_event_id = Appointy_Router_Helper::get_sanitize_data($booked_service,'customer_google_calendar_event_id');
		$admin_google_calendar_event_id = Appointy_Router_Helper::get_sanitize_data($booked_service,'admin_google_calendar_event_id');
		
		if (PHP_VERSION_ID >= 80100) {
		if($member_id > 0 && $google_calendar_event_id != '') {
			Appointy_Google_Calendar_Helper::updateToGoogleCalendarAppointment($appointment_id,$sid,$member_id,$booked_service);
		}elseif($member_id > 0){
			Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$sid,$member_id,$booked_service);
		}
		}
		
		$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
		$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
		
		$user_roles = Appointy_Misc_Helper::get_user_roles($customer_id);
		if (PHP_VERSION_ID >= 80100) {
		if(in_array('appointy_customer',$user_roles)) {
			if($customer_id > 0 && $customer_google_calendar_event_id != '') {
				Appointy_Google_Calendar_Helper::updateToGoogleCalendarAppointment($appointment_id,$sid,$customer_id,$booked_service);
			}elseif($member_id > 0){
				Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$sid,$customer_id,$booked_service);
			}
		}
		
		$gcal_admin_id = Appointy_Misc_Helper::get_gcal_admin_id();
		if( $gcal_admin_id > 0 ) {
			if($gcal_admin_id > 0 && $admin_google_calendar_event_id != '') {
				Appointy_Google_Calendar_Helper::updateToGoogleCalendarAppointment($appointment_id,$sid,$gcal_admin_id,$booked_service);
			}elseif($gcal_admin_id > 0){
				Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$sid,$gcal_admin_id,$booked_service);
			}
		}
		}


		$response = array(

						'message'   => esc_html__('Appointment date/time updated successfully.','appointy'),

						'booking_date' => Appointy_Misc_Helper::get_date_format($booking_date),

						'booking_start_time' => Appointy_Misc_Helper::get_time_format($booking_start_time),

						'booking_end_time' => Appointy_Misc_Helper::get_time_format($booking_end_time)

					);

		wp_send_json_success($response);

		exit;

	}

	

	/**

	 * Cancel service

	 *

	 * @return void

	 */

	public static function cancel_service() {

	    global $wpdb;

		

		$appointment_id = Appointy_Router_Helper::get_request_data( $_POST, 'bookingid' );

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'serviceid' );

		$reason = Appointy_Router_Helper::get_request_data( $_POST, 'reason' );

		

		$update_booked_services['service_status']	= 'cancelled';

		$update_booked_services['cacellation_reason']	= $reason;

					

		$where = array(

			'id' => $service_id

		);

		

		$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($update_booked_services),$where);

		

		Appointy_Send_Email_Notification_Helper::send_service_cancel_email_notifications($appointment_id,$service_id);

		
		$booked_service = Appointy_Appointments_Helper::get_booked_service( $service_id );
		
		$member_id = Appointy_Router_Helper::get_request_data($booked_service,'member_id');
		
		if (PHP_VERSION_ID >= 80100) {
		if($member_id > 0) {
		Appointy_Google_Calendar_Helper::cancelToGoogleCalendarAppointment($appointment_id,$service_id,$member_id,$booked_service);
		}
		
		$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
		$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
		
		$user_roles = Appointy_Misc_Helper::get_user_roles($customer_id);
		if(in_array('appointy_customer',$user_roles)) {
			Appointy_Google_Calendar_Helper::cancelToGoogleCalendarAppointment($appointment_id,$service_id,$customer_id,$booked_service);
		}
		
		$gcal_admin_id = Appointy_Misc_Helper::get_gcal_admin_id();
		if( $gcal_admin_id > 0 ) {
			Appointy_Google_Calendar_Helper::cancelToGoogleCalendarAppointment($appointment_id,$service_id,$gcal_admin_id,$booked_service);
		}
		}

		$response = array(

			'message'   => esc_html__('Service cancelled successfully.','appointy'),

			'servicestatus'   => Appointy_Misc_Helper::translate_string('cancelled'),

			'statuscolor'   => Appointy_Misc_Helper::get_status_color('cancelled'),

		);

		wp_send_json_success($response);

		exit;

	}

	

	/**

	 * Complete service

	 *

	 * @return void

	 */

	public static function complete_service() {

	    global $wpdb;

		

		$appointment_id = Appointy_Router_Helper::get_request_data( $_POST, 'bid' );

		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'sid' );

		$member_id = Appointy_Router_Helper::get_request_data( $_POST, 'mid' );

		

		$update_booked_services['service_status']	= 'completed';

					

		$where = array(

			'id' => $service_id

		);

		

		$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($update_booked_services),$where);

		

		Appointy_Send_Email_Notification_Helper::send_service_complete_email_notifications($appointment_id,$service_id);

		

		$response = array(

						'message'   => esc_html__('Service completed successfully.','appointy'),

						'servicestatus'   => Appointy_Misc_Helper::translate_string('completed'),

						'statuscolor'   => Appointy_Misc_Helper::get_status_color('completed'),

					);

		wp_send_json_success($response);

		exit;

	}
	
	/**

	 * Send payment reminder

	 *

	 * @return void

	 */

	public static function send_payment_reminder() {

	    global $wpdb;

		

		$appointment_id = Appointy_Router_Helper::get_request_data( $_POST, 'appointment_id' );

		$repeat_service_id = Appointy_Router_Helper::get_request_data( $_POST, 'repeat_service_id' );

		
		Appointy_Send_Email_Notification_Helper::send_repeat_payment_reminder_email_notifications($appointment_id,$repeat_service_id);

		

		$response = array(

						'message'   => esc_html__('Repeat service payment reminder send successfully.','appointy'),

					);

		wp_send_json_success($response);

		exit;

	}


	/**

	 * Get appointments

	 *

	 * @return void

	 */

	public static function get_appointments() {

	    global $wpdb;



		$the_query = self::get_appointments_query();

	

		$data = array();

		if ( $the_query->have_posts() ) {

			$nestedData = array();

			while ( $the_query->have_posts() ) : $the_query->the_post();

				$appointment_id = get_the_id();		

				

				$nestedData['appointment_id'] = $appointment_id;

				$nestedData['delete'] = '<div class="checkbox sf-radio-checkbox">

											<input type="checkbox" id="appointment-'.esc_attr($appointment_id).'" value="'.esc_attr($appointment_id).'" class="delete_row delete_appointments">

											<label for="appointment-'.esc_attr($appointment_id).'"></label>

										</div>';

				

				$nestedData['ref_id'] = '#'.get_post_meta($appointment_id,'appointment_ref_id',true);

				$nestedData['date_n_time'] = Appointy_Misc_Helper::get_date_format(get_the_date('',$appointment_id));

				

				$nestedData['customers_name'] = self::get_appointment_customername( $appointment_id );

				

				$booked_services = self::get_booked_services( $appointment_id );

				$services = '';

				if(!empty($booked_services)) {

					$services = '<ul class="booked-services">';

					foreach($booked_services as $booked_service) {

						$service_id = Appointy_Router_Helper::get_request_data($booked_service,'id');
						
						$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');

						$servicetype = Appointy_Router_Helper::get_request_data($booked_service,'servicetype');

						$variation_name = Appointy_Router_Helper::get_request_data($booked_service,'variation_name');
						
						$multidate_service = Appointy_Router_Helper::get_request_data($booked_service,'multidate_service');
						
						$service_post_id = Appointy_Router_Helper::get_request_data($booked_service,'service_id');

						

						$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;

						

						$booking_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_date');

						$booking_start_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_start_time');

						$service_price = Appointy_Router_Helper::get_request_data($booked_service,'service_price');

						if($multidate_service === 'yes') {
							$multidatedates = Appointy_Appointments_Helper::get_multidate_booking_dates($appointment_id,$service_post_id);
							$services .= sprintf('<li>%s - <a href="javascript:;" class="ap-multidate-dates viewmultidatedates" data-multidatedates="'.esc_attr( $multidatedates ).'">%s</a></li>',$service_name,esc_html__('View Dates','appointy'));
						}else{
							$services .= sprintf('<li>%s - %s</li>',$service_name,$booking_date);
						}

						

					}

					$services .= '</ul>';

				}

				

				$nestedData['booked_services'] = $services;

				

				$nestedData['paymentmode'] = self::get_appointment_payment_method($appointment_id);

				

				$nestedData['paymentstatus'] = Appointy_Misc_Helper::translate_string(get_post_meta($appointment_id,'booking_amount_status',true));

				

				

				$nestedData['totalamount'] = Appointy_Misc_Helper::get_price_format(get_post_meta($appointment_id,'totalamount',true));

				

				$li = '';

				

				$params['appointment_id'] = $appointment_id;

				

				$viewdetailsurl = Appointy_Router_Helper::generate_link( ['appointments', 'view'],$params );

				

				$li .= '<li><a href="'.esc_url( $viewdetailsurl ).'" class="action-btn-admin"><i class="feather-eye"></i> '.esc_html__( 'View Details','appointy' ).'</a></li>';

				

				if( get_post_meta($appointment_id,'order_id',true) != '' && get_post_meta($appointment_id,'order_id',true) > 0 ) {

					$order_id = get_post_meta($appointment_id,'order_id',true);

					

					$adminurl = admin_url('post.php');

					$orderpage = add_query_arg( array('post' => $order_id,'action' => 'edit'), $adminurl );

					

					$li .= '<li><a target="_blank" href="'.esc_url($orderpage).'" class="action-btn-admin"><i class="fa fa-shopping-cart"></i> '.esc_html__( 'View Order','appointy' ).'</a></li>';

				}

				

				$actions = '<div class="dropdown action-dropdown dropdown-left">

							  <button class="action-button btn btn-primary dropdown-toggle" type="button" data-bs-toggle="dropdown"><i class="fa fa-ellipsis-v"></i></button>

							  <ul class="dropdown-menu">

								'.$li.'

							  </ul>

							</div>';

				

				$nestedData['action'] = $actions;

				

				$data[] = $nestedData;

			endwhile;

		}

		

		$json_data = array( 'data' => $data );

		

		echo json_encode( $json_data );

		die();

	}
	
	/**

	 * Get recent appointments

	 *

	 * @return void

	 */

	public static function get_recent_appointments() {

	    global $wpdb;



		$the_query = self::get_appointments_query(10);

	

		$data = array();

		if ( $the_query->have_posts() ) {

			$nestedData = array();

			while ( $the_query->have_posts() ) : $the_query->the_post();

				$appointment_id = get_the_id();		

				

				$nestedData['appointment_id'] = $appointment_id;

				
				$nestedData['ref_id'] = '#'.get_post_meta($appointment_id,'appointment_ref_id',true);

				$nestedData['date_n_time'] = Appointy_Misc_Helper::get_date_format(get_the_date('',$appointment_id));

				

				$nestedData['customers_name'] = self::get_appointment_customername( $appointment_id );

				

				$booked_services = self::get_booked_services( $appointment_id );

				$services = '';

				if(!empty($booked_services)) {

					$services = '<ul class="booked-services">';

					foreach($booked_services as $booked_service) {

						$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');

						$servicetype = Appointy_Router_Helper::get_request_data($booked_service,'servicetype');

						$variation_name = Appointy_Router_Helper::get_request_data($booked_service,'variation_name');

						

						$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;

						

						$booking_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_date');

						$booking_start_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_start_time');

						$service_price = Appointy_Router_Helper::get_request_data($booked_service,'service_price');

						

						$services .= sprintf('<li>%s - %s</li>',$service_name,$booking_date);

					}

					$services .= '</ul>';

				}

				

				$nestedData['booked_services'] = $services;

				

				$nestedData['paymenttype'] = Appointy_Misc_Helper::translate_string(get_post_meta($appointment_id,'payment_type',true));

				

				$nestedData['paymentmode'] = self::get_appointment_payment_method($appointment_id);

				

				$nestedData['paymentstatus'] = Appointy_Misc_Helper::translate_string(get_post_meta($appointment_id,'booking_amount_status',true));

				

				

				$nestedData['totalamount'] = Appointy_Misc_Helper::get_price_format(get_post_meta($appointment_id,'totalamount',true));

				

				$data[] = $nestedData;

			endwhile;

		}

		

		$json_data = array( 'data' => $data );

		

		echo json_encode( $json_data );

		die();

	}
	
	
	/**

	 * Get staff appointments

	 *

	 * @return array

	 */

	public static function get_staff_appointments($user_id = 0,$post_per_page = 10, $start = 0) { 
		global $wpdb;

		$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`date`,`appointment_id`,`service_id`,`service_name`,`servicetype`,`service_period`,`variation_name`,`hours`,`minutes`,`display_service_period`,`show_branches`,`members_available`,`branch_id`,`member_id`,`booking_date`,`booking_start_time`,`booking_end_time`,`parent_category`,`service_status`,`status_update_by`,`service_price`,`booking_amount_status`,`customerid`,`customeremail`,`couponcode`,`oldserviceprice`,`cacellation_reason`,`service_completed_date`,`multidate_service`,`multidate_service_type`,`number_of_dates` FROM `'.$wpdb->prefix.'appointy_booked_services` WHERE `member_id` = %d order by `id` desc limit %d,%d',$user_id,$start,$post_per_page));

		return $results;
	}
	
	/**

	 * Get staff total appointments

	 *

	 * @return array

	 */

	public static function get_staff_total_appointments($user_id = 0,$post_per_page = 10, $start = 0) { 
		global $wpdb;

		$results = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_booked_services` WHERE `member_id` = %d',$user_id));

		return $results;
	}
	
	/**

	 * Get customer appointments

	 *

	 * @return array

	 */

	public static function get_customer_appointments($user_id = 0,$post_per_page = 10, $start = 0) { 

		global $wpdb;

		$args = array(
	
				'post_status' => array( 'cancelled', 'pending', 'processing', 'on-hold', 'completed' ),
	
				'post_type' => 'appointy_appointment',
	
				'orderby' => 'ID',
	
				'order'   => 'DESC',
	
				'posts_per_page' => $post_per_page,
				'offset'  => $start,
				
				'meta_query' => array(
					array(
						'key'     => 'booking_customer_id',
						'value'   => $user_id,
						'compare' => '=',
					),
				)
	
			);

		

		

		$the_query = new \WP_Query( $args );

		

		return $the_query;

	}
	
	/**

	 * Get appointments

	 *

	 * @return array

	 */

	public static function get_appointments_query($number_of_posts = '') { 

		global $wpdb;

		if($number_of_posts === '') {
			$args = array(
	
				'post_status' => array( 'cancelled', 'pending', 'processing', 'on-hold', 'completed' ),
	
				'post_type' => 'appointy_appointment',
	
				'orderby' => 'ID',
	
				'order'   => 'DESC',
	
				'posts_per_page' => -1,
	
			);
		}else{
			$args = array(
	
				'post_status' => array( 'cancelled', 'pending', 'processing', 'on-hold', 'completed' ),
	
				'post_type' => 'appointy_appointment',
	
				'orderby' => 'ID',
	
				'order'   => 'DESC',
	
				'posts_per_page' => $number_of_posts
	
			);
		}

		

		

		$the_query = new \WP_Query( $args );

		

		return $the_query;

	}

	

	/**

	 * Get appointment services

	 *

	 * @return array

	 */

	public static function get_booked_services($appointment_id = 0) { 

		global $wpdb;

		

		$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`date`,`appointment_id`,`has_repeat`,`repeat_service_id`,`repeat_service_payment`,`service_id`,`service_name`,`servicetype`,`service_period`,`variation_name`,`hours`,`minutes`,`display_service_period`,`show_branches`,`members_available`,`branch_id`,`member_id`,`booking_date`,`booking_start_time`,`booking_end_time`,`parent_category`,`service_status`,`status_update_by`,`service_price`,`booking_amount_status`,`customerid`,`customeremail`,`couponcode`,`oldserviceprice`,`cacellation_reason`,`service_completed_date`,`google_calendar_url`,`google_calendar_event_id`,`customer_google_calendar_url`,`customer_google_calendar_event_id`,`admin_google_calendar_url`,`admin_google_calendar_event_id`,`multidate_service`,`multidate_service_type`,`number_of_dates`,`fullday_timeslots` FROM `'.$wpdb->prefix.'appointy_booked_services` WHERE `appointment_id` = %d',$appointment_id));

		

		return $results;

	}
	
	/**

	 * Get multidate appointment dates

	 *

	 * @return array

	 */

	public static function get_multidate_booking_dates($appointment_id = 0,$service_id = 0) { 
		global $wpdb;

		$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`service_id`,`date`,`time` FROM `'.$wpdb->prefix.'appointy_multiple_dates` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
		
		$alldates = array();
		
		if(!empty($results)) {
			foreach($results as $row){
				$alldates[] = Appointy_Misc_Helper::get_date_format(Appointy_Router_Helper::get_sanitize_data($row,'date'));
			}
		}

		return (!empty($alldates)) ? implode(', ',$alldates) : '-';
	}
	
	/**

	 * Get multidate appointment dates

	 *

	 * @return array

	 */

	public static function get_multidate_booking_dates_array($appointment_id = 0,$service_id = 0) { 
		global $wpdb;

		$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`service_id`,`date`,`time` FROM `'.$wpdb->prefix.'appointy_multiple_dates` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
		
		$alldates = array();
		
		if(!empty($results)) {
			foreach($results as $row){
				$alldates[] = Appointy_Misc_Helper::get_date_format(Appointy_Router_Helper::get_sanitize_data($row,'date'));
			}
		}

		return $alldates;
	}
	
	/**

	 * Get multidate appointment min date

	 *

	 * @return array

	 */

	public static function get_multidate_booking_min_date($appointment_id = 0,$service_id = 0) { 
		global $wpdb;

		$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`service_id`,`date`,`time` FROM `'.$wpdb->prefix.'appointy_multiple_dates` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
		
		$alldates = array();
		
		if(!empty($results)) {
			foreach($results as $row){
				$alldates[] = Appointy_Misc_Helper::get_date_format(Appointy_Router_Helper::get_sanitize_data($row,'date'));
			}
		}
		
		$min_date = min($alldates);

		return $min_date;
	}

	

	/**

	 * Get appointment customer name

	 *

	 * @return array

	 */

	public static function get_booked_service($service_id = 0) { 

		global $wpdb;

		

		$row = $wpdb->get_row($wpdb->prepare('SELECT `id`,`date`,`appointment_id`,`service_id`,`service_name`,`servicetype`,`service_period`,`variation_name`,`hours`,`minutes`,`display_service_period`,`show_branches`,`members_available`,`branch_id`,`member_id`,`booking_date`,`booking_start_time`,`booking_end_time`,`parent_category`,`service_status`,`status_update_by`,`service_price`,`booking_amount_status`,`customerid`,`customeremail`,`couponcode`,`oldserviceprice`,`cacellation_reason`,`service_completed_date`,`google_calendar_url`,`google_calendar_event_id`,`customer_google_calendar_url`,`customer_google_calendar_event_id`,`admin_google_calendar_url`,`admin_google_calendar_event_id`,`multidate_service`,`multidate_service_type`,`number_of_dates`,`fullday_timeslots` FROM `'.$wpdb->prefix.'appointy_booked_services` WHERE `id` = %d',$service_id));

		

		return $row;

	}

	

	/**

	 * Get appointment customer name

	 *

	 * @return array

	 */

	public static function get_appointment_customername($appointment_id = 0) { 

		

		$first_name = get_post_meta($appointment_id,'first_name',true);

		$last_name = get_post_meta($appointment_id,'last_name',true);

		

		$fullname = esc_html($first_name).' '.esc_html($last_name);

		

		return $fullname;

	}

	

	/**

	 * Get Payment Method

	 *

	 * @return string

	 */

	public static function get_appointment_payment_method( $appointment_id = 0 ) {

		$paymentmethod = get_post_meta($appointment_id,'payment_method',true);

		

		return self::translate_payment_method($paymentmethod);

	}

	

	/**

	 * Translate payment method

	 *

	 * @return string

	 */

	public static function translate_payment_method( $paymentmethod = '' ){

	

		switch (strtolower($paymentmethod)) {

			case 'bacs':

				$returnstr = esc_html__('Bank transfer','appointy');

				break;

			case 'cod':

				$returnstr = esc_html__('Cash on delivery','appointy');

				break;

			case 'cheque':

				$returnstr = esc_html__('Check payment','appointy');

				break;

			case 'wallet':

				$returnstr = esc_html__('Wallet','appointy');

				break;

			case 'free':

				$returnstr = esc_html__('Free','appointy');

				break;

			case 'giftcard':

				$returnstr = esc_html__('Gift Voucher','appointy');

				break;
				
			case 'offline':

				$returnstr = esc_html__('Offline Payment','appointy');

				break;
				
			case 'shop':

				$returnstr = esc_html__('Shop','appointy');

				break;
			
			case 'home':

				$returnstr = esc_html__('Home','appointy');

				break;							

			default:

				$returnstr = ucfirst($paymentmethod);

				break;												

		}

		

		return $returnstr;

	}

	

	/**

	 * Get appointment status

	 *

	 * @return string

	 */

	public static function get_post_status( $post_id = 0 ) {

		global $appointment_statuses;

		

		if( $post_id > 0) {

			$status_slug = get_post_status( $post_id );

			

			return (!empty($appointment_statuses[$status_slug]['label'])) ? $appointment_statuses[$status_slug]['label'] : Appointy_Misc_Helper::translate_string($status_slug);

		}

	}

	

	/**

	 * Get appointment status by slug

	 *

	 * @return string

	 */

	public static function get_post_status_by_slug( $status_slug = '' ){

		global $appointment_statuses;

		

		if( $status_slug != '' ) {

			return (!empty($appointment_statuses[$status_slug]['label'])) ? $appointment_statuses[$status_slug]['label'] : Appointy_Misc_Helper::translate_string($status_slug);

		}

	}

	

	/**

	 * Get available members

	 *

	 * @return string

	 */

	public static function get_avl_members( $status_slug = '' ){

		global $wpdb;

		

		$appointment_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'appointment_id' );

		$member_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'member_id' );

		$branch_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'branch_id' );

		$service_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'service_id' );

		

		$i = 0;

		ob_start();

		if($service_id > 0) {

			$service_staff = $wpdb->get_results($wpdb->prepare('SELECT `staff_id` FROM `'.$wpdb->prefix.'appointy_service_location_satff` WHERE `service_id` = %d AND `location_id` = %d',$service_id,$branch_id));

			if(!empty($service_staff)) {

				foreach( $service_staff as $row ) {
					
					$staff_id = Appointy_Router_Helper::get_request_data( $row, 'staff_id' );
					
					if(intval($staff_id) === intval($member_id)) {
						$member_availability = true;
					}else{
						$member_availability = self::check_member_availability($_POST['booked_service'],$staff_id);
					}
					
					
					if($member_availability === true || intval($member_id) === intval($staff_id)){
					
					$userdata = get_userdata( $staff_id );

					$staff_name = Appointy_Router_Helper::get_request_data( $userdata, 'display_name' );

					$attachment_id = get_user_meta($staff_id, $wpdb->get_blog_prefix().'user_avatar', true);

					

					if($attachment_id > 0) {

						$image_url = Appointy_Image_Helper::get_image_url_by_id($attachment_id);

					} else {

						$image_url = Appointy_Image_Helper::get_image_url_by_id();

					}

					?>

					<div class="col-md-4 staffitem <?php echo ($member_id === $staff_id) ? 'active' : ''; ?>" data-staffid="<?php echo esc_attr($staff_id); ?>" data-staffname="<?php echo esc_attr($staff_name); ?>">

						<div class="book-popLoc-box">

							<div class="book-popLoc-pic">

								<img src="<?php echo esc_url($image_url); ?>" alt="">  

							</div>

							<h4 class="book-popLoc-title"><?php echo esc_html($staff_name); ?></h4>

						</div>

					</div>

					<?php

					$i++;
					}

				}

			}

		}

		

		if( $i === 0 ) {

			echo '<div class="sf-no-staff not-found">';

			echo __( 'There is no staff member available at this location.','appointy' );

			echo '</div>';	

		}

		

		$response = ob_get_clean();

		wp_send_json_success($response);

   		die();

	}
	
	/**

	 * Check member availability

	 *

	 * @return string

	 */
	public static function check_member_availability($booked_service = array(),$staff_id = 0){
		global $wpdb;
		
		$appointment_id = Appointy_Router_Helper::get_request_data( $booked_service, 'appointment_id' );
		$member_id = Appointy_Router_Helper::get_request_data( $booked_service, 'member_id' );
		$branch_id = Appointy_Router_Helper::get_request_data( $booked_service, 'branch_id' );
		$service_id = Appointy_Router_Helper::get_request_data( $booked_service, 'service_id' );
		$multidate_service = Appointy_Router_Helper::get_request_data( $booked_service, 'multidate_service' );
		$fullday_timeslots = Appointy_Router_Helper::get_request_data( $booked_service, 'fullday_timeslots' );
		$booking_start_time = Appointy_Router_Helper::get_request_data( $booked_service, 'booking_start_time' );
		$booking_end_time = Appointy_Router_Helper::get_request_data( $booked_service, 'booking_end_time' );
		
		$selected_multiple_dates = Appointy_Appointments_Helper::get_multidate_booking_dates_array($appointment_id,$service_id);
		
		$type = 'addbooking';
		
		if($multidate_service === 'yes') {
			$avl_dates_array = array();
			if($fullday_timeslots === 'full_day') {
				$avlflag = 1;
				if(!empty($selected_multiple_dates)) {
					foreach($selected_multiple_dates as $appointment_date){
						$day = Appointy_Misc_Helper::get_day( $appointment_date );
				
						$staff_id = ( intval($staff_id) > 0 ) ? $staff_id : 0;
						
						//Get avaialable slots by custom schedule date
						$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `custom_date` = %s AND `member_id` = %d order by `start_time_number` asc',$appointment_date,$staff_id));
						
						if( empty( $results ) ) {
							//Check if slots are avaialble on particular day if yes then render timeslots
							$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `weekday` = %s AND `member_id` = %d order by `start_time_number` asc',$day,$staff_id));
							
							if( empty( $results ) ) {
								$avlflag = 0;
								return false;
							}
						}
						
						$dateresponse = Appointy_Booking_Form_Helper::check_date_unavailability( $appointment_date,$staff_id );
						if( $dateresponse === false ) {
							$avlflag = 0;
							return false;
						}
					}
				}
				
				if($avlflag === 1) {
					return true;
				}
			}else{
				$avlflag = 1;
				if(!empty($selected_multiple_dates)) {
					foreach($selected_multiple_dates as $appointment_date){
						$appointment_date = date('Y-m-d',strtotime($appointment_date));
					
						$booking_date = $appointment_date;
						
						$day = Appointy_Misc_Helper::get_day( $appointment_date );
						
						$service_availability = get_post_meta($service_id,'_service_availability',true);
						$service_availability_status = get_post_meta($service_id,'_service_availability_status',true);
						if( $service_availability_status === 'on' ) {
							$service_availability = ( !empty( $service_availability[$day] ) ) ? (array) $service_availability[$day] : array();
							
							$service_start_time = ( !empty( $service_availability[0] ) ) ? date('H:i:s',strtotime($service_availability[0])) : '';
							$service_end_time = ( !empty( $service_availability[1] ) ) ? date('H:i:s',strtotime($service_availability[1])) : '';
							$service_day_status = ( !empty( $service_availability[2] ) ) ? $service_availability[2] : '';
							
							if( $service_day_status === false ) {
								$avlflag = 0;
								return false;
							}
						}else{
							$service_start_time = '';
							$service_end_time = '';
							$service_day_status = '';
						}
							
						$staff_id = ( intval($staff_id) > 0 ) ? $staff_id : 0;
						
						$dateresponse = Appointy_Booking_Form_Helper::check_date_unavailability( $appointment_date,$staff_id );
						if( $dateresponse === false ) {
							$avlflag = 0;
							return false;
						}
						
						//Get avaialable slots by custom schedule date
						$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `custom_date` = %s AND `member_id` = %d order by `start_time_number` asc',$appointment_date,$staff_id));
						
						if( !empty( $results ) ) {
							$avl_dates_array[] = Appointy_Booking_Form_Helper::get_available_slots_for_multidate( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $staff_id, $type, $service_id );
						} else {
							//Check if slots are avaialble on particular day if yes then render timeslots
							$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `weekday` = %s AND `member_id` = %d order by `start_time_number` asc',$day,$staff_id));
							
							if( empty( $results ) ) {
								$avlflag = 0;
								return false;
							}else {
								$avl_dates_array[] = Appointy_Booking_Form_Helper::get_available_slots_for_multidate( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $staff_id, $type, $service_id );
							}
						}
						
						if(!empty($avl_dates_array)) {
							foreach($avl_dates_array as $avl_dates){
								if(!empty($avl_dates[$appointment_date])) {
									if(!in_array($booking_start_time,$avl_dates[$appointment_date])) {
										$avlflag = 0;
										return false;
									}
								}
								
							}
						}
					}
				}
				
				if($avlflag === 1) {
					return true;
				}
			}
		}else{
			$avlflag = 1;
			
			$booking_date = Appointy_Router_Helper::get_request_data( $booked_service, 'booking_date' );
			$appointment_date = Appointy_Router_Helper::get_request_data( $booked_service, 'booking_date' );
			
			$day = Appointy_Misc_Helper::get_day( $appointment_date );
			
			$service_availability = get_post_meta($service_id,'_service_availability',true);
			$service_availability_status = get_post_meta($service_id,'_service_availability_status',true);
			if( $service_availability_status === 'on' ) {
				$service_availability = ( !empty( $service_availability[$day] ) ) ? (array) $service_availability[$day] : array();
				
				$service_start_time = ( !empty( $service_availability[0] ) ) ? date('H:i:s',strtotime($service_availability[0])) : '';
				$service_end_time = ( !empty( $service_availability[1] ) ) ? date('H:i:s',strtotime($service_availability[1])) : '';
				$service_day_status = ( !empty( $service_availability[2] ) ) ? $service_availability[2] : '';
				
				if( $service_day_status === false ) {
					$avlflag = 0;
					return false;
				}
			}else{
				$service_start_time = '';
				$service_end_time = '';
				$service_day_status = '';
			}
				
			$staff_id = ( intval($staff_id) > 0 ) ? $staff_id : 0;
			
			$dateresponse = Appointy_Booking_Form_Helper::check_date_unavailability( $appointment_date,$staff_id );
			if( $dateresponse === false ) {
				$avlflag = 0;
				return false;
			}
			
			//Get avaialable slots by custom schedule date
			$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `custom_date` = %s AND `member_id` = %d order by `start_time_number` asc',$appointment_date,$staff_id));
			
			if( !empty( $results ) ) {
				$avl_dates_array[] = Appointy_Booking_Form_Helper::get_available_slots_for_multidate( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $staff_id, $type, $service_id );
			} else {
				//Check if slots are avaialble on particular day if yes then render timeslots
				$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`member_id`,`start_time`,`end_time`,`start_time_number`,`end_time_number`,`weekday`,`weekday_number`,`interval`,`custom_date` FROM `'.$wpdb->prefix.'appointy_work_periods` WHERE `weekday` = %s AND `member_id` = %d order by `start_time_number` asc',$day,$staff_id));
				
				if( empty( $results ) ) {
					$avlflag = 0;
					return false;
				}else {
					$avl_dates_array[] = Appointy_Booking_Form_Helper::get_available_slots_for_multidate( $results, $appointment_date, $service_availability_status, $service_start_time, $service_end_time, $booking_date, $booking_start_time, $staff_id, $type, $service_id );
				}
			}
			
			$avl_dates_array = $avl_dates_array[0][$appointment_date];
			
			if(in_array($booking_start_time,$avl_dates_array)) {
				return true;
			}
		}
	}
	
	
	/**

	 * Get repeating services

	 *

	 * @return string

	 */

	public static function load_repeating_services(){
		global $wpdb;
		
		$user = wp_get_current_user();
		$user_roles = $user->roles;

		$appointment_id = Appointy_Router_Helper::get_request_data( $_POST, 'appointment_id' );
		$service_id = Appointy_Router_Helper::get_request_data( $_POST, 'service_post_id' );
		ob_start();
		
		echo '<div class="cancel-all-repeat"><button class="site-button-outline button-sm m-l15 cancelallrepeatservice" data-appointment_id="'.esc_attr( $appointment_id ).'" data-service_id="'.esc_attr( $service_id ).'"><i class="feather-x"></i> '.esc_html__('Cancel All Repeat Services','appointy').'</button></div>';
		
		?>
		<div class="table-responsive">
		<table id="repeatServiceTable" class="table table-striped table-bordered">
			<thead>
				<tr>
					<th><?php echo __('Service Name','appointy'); ?></th>
					<th><?php echo __('Date','appointy'); ?></th>
					<th><?php echo __('Time','appointy'); ?></th>
					<th><?php echo __('Service Status','appointy'); ?></th>
					<th><?php echo __('Payment Status','appointy'); ?></th>
					<th><?php echo __('Action','appointy'); ?></th>
				</tr>
			</thead>
			<tbody>
				<?php
				$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`date`,`start_time`,`end_time`,`status`,`payment_status` FROM `'.$wpdb->prefix.'appointy_repeat_schedule` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
				foreach ($results as $row) {
					$repeat_schedule_id = Appointy_Router_Helper::get_sanitize_data( $row, 'id' );
					$date = Appointy_Router_Helper::get_sanitize_data( $row, 'date' );
					$start_time = Appointy_Router_Helper::get_sanitize_data( $row, 'start_time' );
					$end_time = Appointy_Router_Helper::get_sanitize_data( $row, 'end_time' );
					$status = Appointy_Router_Helper::get_sanitize_data( $row, 'status' );
					$payment_status = Appointy_Router_Helper::get_sanitize_data( $row, 'payment_status' );
					$sendreminderflag = 0;
					echo '<tr>';
					echo '<td>' . get_the_title($service_id) . '</td>';
					echo '<td>' . Appointy_Misc_Helper::get_date_format($date) . '</td>';
					echo '<td>' . Appointy_Misc_Helper::get_time_format($start_time).' - '.Appointy_Misc_Helper::get_time_format($end_time).'</td>';
					echo '<td>' . Appointy_Misc_Helper::translate_string($status).'</td>';
					if($payment_status === 'default') {
						
						$booking_amount_status = get_post_meta($appointment_id,'booking_amount_status',true);
						
						if($booking_amount_status === 'unpaid') {
						echo '<td>' .esc_html__('Pending','appointy');
						if(in_array('appointy_customer',$user_roles)) {
						echo '<div class="ap-repeat-payment"><a href="javascript:;" class="site-button button-sm payrepeatpayment" data-appointment_id="'.esc_attr($appointment_id).'" data-repeat_service_id="'.esc_attr($repeat_schedule_id).'" data-serviceid="'.esc_attr($service_id).'">'.esc_html__('Pay Now','appointy').'</a></div>';
						}elseif(current_user_can( 'administrator' )){
						$sendreminderflag = 1;
						}
						echo '</td>';
						}else{
						echo '<td>' .esc_html__('Paid','appointy').'</td>';
						}
					}else{
						echo '<td>' . Appointy_Misc_Helper::translate_string($payment_status);
						
						if($payment_status === 'pending' && ($status === 'active' || $status === 'past') && in_array('appointy_customer',$user_roles)) {
						echo '<div class="ap-repeat-payment"><a href="javascript:;" class="site-button button-sm payrepeatpayment" data-appointment_id="'.esc_attr($appointment_id).'" data-repeat_service_id="'.esc_attr($repeat_schedule_id).'" data-serviceid="'.esc_attr($service_id).'">'.esc_html__('Pay Now','appointy').'</a></div>';
						}elseif($payment_status === 'pending' && ($status === 'active' || $status === 'past') && current_user_can( 'administrator' )) {
						$sendreminderflag = 1;
						}
						echo '</td>';
					}
					
					if($status === 'past') {
					echo '<td>';
					if($sendreminderflag === 1) {
					?>
					<div class="ap-payment-reminder"><a href="javascript:;" class="site-button-outline button-sm paymentreminder" data-appointment_id="<?php echo esc_attr($appointment_id) ?>" data-repeat_service_id="<?php echo esc_attr($repeat_schedule_id) ?>"><i class="feather-send"></i> <?php echo esc_html__('Send Reminder','appointy'); ?> </a></div>
					<?php
					}
					echo '</td>';
					}else{
					echo '<td><button class="site-button-outline button-sm m-l15 cancelrepeatservice" data-repeat_schedule_id="'.esc_attr( $repeat_schedule_id ).'"><i class="feather-x"></i> '.esc_html__('Cancel','appointy').'</button>';
					if($sendreminderflag === 1) {
					?>
					<div class="ap-payment-reminder"><a href="javascript:;" class="site-button-outline button-sm paymentreminder" data-appointment_id="<?php echo esc_attr($appointment_id) ?>" data-repeat_service_id="<?php echo esc_attr($repeat_service_id) ?>"><i class="feather-send"></i> <?php echo esc_html__('Send Reminder','appointy'); ?> </a></div>
					<?php
					}
					echo '</td>';
					}
					echo '</tr>';
				}
				?>
			</tbody>
		</table>
		</div>
		<?php
		

		$response = ob_get_clean();

		wp_send_json_success($response);

   		die();

	}
	
	
	/**

	 * Get available members

	 *

	 * @return string

	 */

	public static function load_view_attachments(){
		global $wpdb;

		$attachment_ids = (!empty($_POST['attachment_ids'])) ? $_POST['attachment_ids'] : array();
		
		ob_start();

		echo '<ul class="ap-booking-attachments">';
			if(!empty($attachment_ids)) {
				foreach($attachment_ids as $attachment_id) {
					$filename = basename ( get_attached_file( $attachment_id ) );
					
					$src  = Appointy_Manage_Uploads::get_icon_for_attachment($attachment_id,'appointy-300x300');
					
					echo sprintf('<li><span class="ap-attachment-image"><img src="%s"></span><span class="sf-attachment-filename">%s</span> <span class="sf-attachment-download"><a class="site-button-outline button-sm" href="'.get_permalink( $attachment_id ).'?attachment_id=%d&download_file=1"><i class="fa fa-download"></i> '.esc_html__('Download','healthify').'</a></span></li>',esc_url($src),$filename,$attachment_id);
					
				}
			}
		echo '</ul>';

		$response = ob_get_clean();

		wp_send_json_success($response);

   		die();

	}
	

	/**

	 * Update appointment staff member

	 *

	 * @return void

	 */

	public static function update_staff_member() {

	    global $wpdb;

		

		$appointment_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'appointment_id' );

		$member_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'member_id' );

		$branch_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'branch_id' );

		$service_id = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'service_id' );
		
		$sid = Appointy_Router_Helper::get_request_data( $_POST['booked_service'], 'id' );

		

		$row = $wpdb->get_row($wpdb->prepare('SELECT `member_id` FROM `'.$wpdb->prefix.'appointy_booked_services` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));

		

		$old_member_id = Appointy_Router_Helper::get_request_data( $row, 'member_id' );

		$old_member_id = ($old_member_id != '') ? $old_member_id : 0;

		

		$update_booked_services['member_id']	= $member_id;

					

		$where = array(

			'appointment_id' => $appointment_id,

			'service_id' => $service_id

		);

		

		$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($update_booked_services),$where);

		

		if($old_member_id != $member_id) {

			Appointy_Send_Email_Notification_Helper::send_update_service_staff_email_notifications($appointment_id,$sid);

			Appointy_Send_Email_Notification_Helper::send_remove_service_staff_email_notifications($appointment_id,$sid,$old_member_id);
			
			$booked_service = Appointy_Appointments_Helper::get_booked_service( $sid );
			
			if (PHP_VERSION_ID >= 80100) {
			if($old_member_id > 0) {
			Appointy_Google_Calendar_Helper::cancelToGoogleCalendarAppointment($appointment_id,$sid,$old_member_id,$booked_service);
			}
			
			if($member_id > 0) {
			Appointy_Google_Calendar_Helper::addToGoogleCalendarAppointment($appointment_id,$sid,$member_id,$booked_service);
			}
			}
		}

		

		ob_start();

		?>

		<div class="assigned-member-pic"> <img src="<?php echo Appointy_Staff_Helper::get_user_avatar( $member_id,'appointy-300x300' ); ?>"> </div> 
		<div class="memberinfo-right">
		<strong><?php echo esc_html__('You\'ve assigned the staff member','appointy'); ?></strong> <span><?php echo Appointy_Misc_Helper::get_fullname_by_user_id( $member_id ); ?></span>
		</div>

		<?php

		$html = ob_get_clean();

		

		$response = array(

						'message'   => esc_html__('Appointment staff member updated successfully.','appointy'),

						'member_id' => $member_id,

						'member_info' => $html

					);

		wp_send_json_success($response);

		exit;

	}
	
	/**

	 * Update appointment received full payment

	 *

	 * @return void

	 */

	public static function mark_received_full_payment() {
	    global $wpdb;

		$appointment_id = Appointy_Router_Helper::get_sanitize_data( $_POST, 'appointment_id' );
		
		$deposit_options = get_post_meta($appointment_id,'deposit_options',true);
		if($deposit_options === 'deposit_only') { 
		
		$due_amount = get_post_meta($appointment_id,'due_amount',true);
		$deposit_amount = get_post_meta($appointment_id,'deposit_amount',true);
		
		$deposit_amount = floatval($deposit_amount) + floatval($due_amount);
		
		update_post_meta($appointment_id,'deposit_payment_status','full_payment');
		update_post_meta($appointment_id,'due_amount',0);
		update_post_meta($appointment_id,'deposit_amount',$deposit_amount);
		update_post_meta($appointment_id,'booking_amount_status','paid');
		
		Appointy_Send_Email_Notification_Helper::send_after_received_fullpayment_email_notifications($appointment_id);
		
		$response = array(
			'message'   => esc_html__('Deposit payment status updated successfully.','appointy'),
		);
		}elseif(get_post_meta($appointment_id,'booking_amount_status',true) === 'unpaid'){
			update_post_meta($appointment_id,'booking_amount_status','paid');
			
			$booked_services['booking_amount_status']	= 'paid';
			
			$where = array(
				'appointment_id' => $appointment_id
			);
			
			$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($booked_services),$where);
		}

		wp_send_json_success($response);
		exit;
	}
	
	/**

	 * Cancel repeat service

	 *

	 * @return void

	 */

	public static function cancel_repeat_service() {
	    global $wpdb;

		$repeat_schedule_id = Appointy_Router_Helper::get_sanitize_data( $_POST, 'repeat_schedule_id' );
		
		$repeat_schedule['status']	= 'cancelled';

		$where = array(
			'id' => $repeat_schedule_id
		);

		$wpdb->update($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($repeat_schedule),$where);
		
		$wpdb->query($wpdb->prepare('DELETE FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `repeat_service_id` = %d',$repeat_schedule_id));
		
		$response = array(
			'message'   => esc_html__('Repeat schedule cancelled successfully.','appointy'),
		);

		wp_send_json_success($response);
		exit;
	}
	
	/**

	 * Cancel all repeat service

	 *

	 * @return void

	 */

	public static function cancel_all_repeat_service() {
	    global $wpdb;

		$appointment_id = Appointy_Router_Helper::get_sanitize_data( $_POST, 'appointment_id' );
		$service_id = Appointy_Router_Helper::get_sanitize_data( $_POST, 'service_id' );
		
		$results = $wpdb->get_results($wpdb->prepare('SELECT `id` FROM `'.$wpdb->prefix.'appointy_repeat_schedule` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
		
		if(!empty($results)) {
			foreach($results as $row){
				$repeat_schedule_id = Appointy_Router_Helper::get_sanitize_data( $row, 'id' );
				$wpdb->query($wpdb->prepare('DELETE FROM `'.$wpdb->prefix.'appointy_blocked_schedule` WHERE `repeat_service_id` = %d',$repeat_schedule_id));	
			}
		}
		
		$repeat_schedule['status']	= 'cancelled';

		$where = array(
			'appointment_id' => $appointment_id,
			'service_id' => $service_id
		);

		$wpdb->update($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($repeat_schedule),$where);
		
		$response = array(
			'message'   => esc_html__('All repeated schedule cancelled successfully.','appointy'),
		);

		wp_send_json_success($response);
		exit;
	}
	
	
	

	/**

	 * Get appointment reference id

	 *

	 * @return array

	 */

	public static function get_appointment_ref_id( $appointment_id = 0, $prefix = 'yes' ) { 

		

		$appointment_ref_id = get_post_meta( $appointment_id,'appointment_ref_id',true );

		

		if( $prefix === 'yes' ){

			return '#'.$appointment_ref_id;	

		} else {

			return $appointment_ref_id;

		}

	}

	

	/**

	 * Get appointment services for mails

	 *

	 * @return array

	 */

	public static function get_mail_appointment_services($appointment_id = 0) { 

		ob_start();

		$booked_services = self::get_booked_services( $appointment_id );

		if(!empty($booked_services)) {

			foreach($booked_services as $booked_service) {

				$service_id = Appointy_Router_Helper::get_request_data($booked_service,'id');
				
				$service_post_id = Appointy_Router_Helper::get_request_data($booked_service,'service_id');
				
				$multidate_service = Appointy_Router_Helper::get_request_data($booked_service,'multidate_service');
					
				$fullday_timeslots = Appointy_Router_Helper::get_request_data($booked_service,'fullday_timeslots');
				
				$has_repeat = Appointy_Router_Helper::get_request_data($booked_service,'has_repeat');

				$repeat_service_id = Appointy_Router_Helper::get_request_data($booked_service,'repeat_service_id');

				$repeat_service_payment = Appointy_Router_Helper::get_request_data($booked_service,'repeat_service_payment');

				$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');

				$servicetype = Appointy_Router_Helper::get_request_data($booked_service,'servicetype');

				$variation_name = Appointy_Router_Helper::get_request_data($booked_service,'variation_name');

				

				$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;

				

				$booking_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_date');

				$booking_start_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_start_time');

				$booking_end_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_end_time');

				$service_price = Appointy_Router_Helper::get_request_data($booked_service,'service_price');

				$member_id = Appointy_Router_Helper::get_request_data($booked_service,'member_id');

				$branch_id = Appointy_Router_Helper::get_request_data($booked_service,'branch_id');

				$cacellation_reason = Appointy_Router_Helper::get_request_data($booked_service,'cacellation_reason');

				$service_status = Appointy_Router_Helper::get_request_data($booked_service,'service_status');
				
				$meeting_details = Appointy_Booking_Form_Helper::get_meeting_links($appointment_id,$service_id);
				
				$hours = Appointy_Router_Helper::get_request_data($booked_service,'hours');

				$minutes = Appointy_Router_Helper::get_request_data($booked_service,'minutes');
	
				
	
				$duration = Appointy_Booking_Form_Helper::get_duration($hours,$minutes);
	
				$extra_service_duration = Appointy_Appointments_Helper::get_extra_service_duration($appointment_id,$service_post_id);
	
				
	
				$duration = intval($duration) + intval($extra_service_duration);
	
				
	
				$booking_end_time = date(Appointy_Misc_Helper::get_wp_time_format(), strtotime($booking_date.' '.$booking_start_time." +".sanitize_text_field($duration)." minutes"));

				?>

				<div class="panel panel-default" id="serviceblock_<?php echo esc_attr($service_id); ?>">

				  <div class="panel-body aon-panel-body p-a0">

					<div class="table-responsive">

					  <table class="table aon-table sf-service-booking-table">

						<thead>

						  <tr>

							<th><?php esc_html_e('Service','appointy'); ?></th>

							<th><?php esc_html_e('Date & Time','appointy'); ?></th>

							<th><?php esc_html_e('Status','appointy'); ?></th>
							
							<?php
							if(!empty($meeting_details)) {
								$join_url = Appointy_Router_Helper::get_request_data( $meeting_details, 'join_url' );
								if($join_url != '') {
								?>
								<th><?php esc_html_e('Meeting','appointy'); ?></th>
								<?php
								}
							}
							?>
							

						  </tr>

						</thead>

						<tbody>

						  <tr>

							<td><div class="sf-servicebooking-text"><i class="fa fa-gear"></i> <?php echo esc_html($service_name); ?></div>
							
							<?php if($fullday_timeslots === 'full_day') { ?>
							<div class="sf-servicebooking-text"><i class="fa fa-clock-o"></i> <?php esc_html_e('Full Day','appointy'); ?></div>
							<?php }else{
							?>
							<div class="sf-servicebooking-text"><i class="fa fa-clock-o"></i> <?php echo Appointy_Booking_Form_Helper::display_service_hours($hours,$minutes); ?></div>
							<?php
							} ?>

							</td>

							<td>
							<?php if($multidate_service === 'yes') { ?>
							<div class="sf-servicebooking-text blockservice-date"><i class="fa fa-calendar"></i> <?php echo Appointy_Appointments_Helper::get_multidate_booking_dates($appointment_id,$service_post_id); ?></div>
							<?php }else{ ?>
							<div class="sf-servicebooking-text blockservice-date"><i class="fa fa-calendar"></i> <?php echo Appointy_Misc_Helper::get_date_format($booking_date); ?></div>
							<?php } ?>
								<?php if($fullday_timeslots != 'full_day') { ?>
							  <div class="sf-servicebooking-text blockservice-time"><i class="fa fa-clock-o"></i> <?php echo Appointy_Misc_Helper::get_time_format($booking_start_time).' - '.Appointy_Misc_Helper::get_time_format($booking_end_time); ?></div>
							  <?php } ?>
							  </td>

							<td><span id="servicestatus-<?php echo sprintf('%d-%d',$appointment_id,$service_id); ?>" data-toggle="tooltip" class="site-button outline <?php echo sanitize_html_class(Appointy_Misc_Helper::get_status_color(esc_html($service_status))); ?> button-sm">

							  <?php 

								if(get_post_status($appointment_id) === 'cancelled') {

									echo Appointy_Misc_Helper::translate_string('cancelled');

								} else {

									if($service_status === 'pending') {

										echo Appointy_Misc_Helper::translate_string('in-process');

									} else {

										echo Appointy_Misc_Helper::translate_string($service_status);

									}

								}

								?>

							  </span> </td>
							  
							<?php
							if(!empty($meeting_details)) {
								$join_url = Appointy_Router_Helper::get_request_data( $meeting_details, 'join_url' );
								if($join_url != '') {
								?>
								<td><a href="<?php echo esc_url($host_url); ?>" class="site-button-outline button-sm m-l15" target="_blank"><i class="feather-users"></i> <?php esc_html_e('Start Meeting','appointy'); ?></a></td>
								<?php
								}
							}
							?>

						  </tr>

						</tbody>

					  </table>

					  <table class="table aon-table sf-service-booking-btn">

						<tbody>

						  <tr>

							<td><div class="sf-servicebook-price"><strong><?php echo Appointy_Misc_Helper::get_price_format($service_price); ?></strong></div></td>

						  </tr>

						</tbody>

					  </table>

					  <div class="sf-assigned-member-info">

						<?php if($member_id > 0) { ?>
						
						<div class="sf-assigned-membername" id="assignedmemberinfo-<?php echo sprintf('%d-%d',$appointment_id,$service_id); ?>">

						<span class="assigned-member-pic"> <img src="<?php echo Appointy_Staff_Helper::get_user_avatar( $member_id,'appointy-300x300' ); ?>"> </span> <?php echo Appointy_Misc_Helper::get_fullname_by_user_id( $member_id ); ?>
						
						</div>

						<?php } ?>

						<?php 

						if($branch_id > 0) { ?>

						<div class="sf-assigned-branchaddress"><i class="fa fa-map-marker"></i> <strong><?php echo esc_html__('Address: ','appointy'); ?>: </strong><?php echo get_post_meta($branch_id, 'friendly_address', true); ?></div>

						<?php } ?>

						<?php 

						if($service_status === 'cancelled') {

							if($cacellation_reason != '') {

							?>

								<div class="alert alert-danger m-t15"><strong><?php echo esc_html__('Cancellation Reason','appointy'); ?>:</strong> <?php echo esc_html($cacellation_reason); ?></div>

							<?php

							}

					  }

					  ?>

					  </div>
					  
					  <?php
					  	$extra_services = Appointy_Appointments_Helper::get_appointment_extra_services($appointment_id,$service_post_id);
						if(!empty($extra_services)) {
							echo '<ul>';
							foreach($extra_services as $extra_service){
								$extra_service_id = Appointy_Router_Helper::get_sanitize_data($extra_service,'extra_service_id');
								$extra_service_name = Appointy_Router_Helper::get_sanitize_data($extra_service,'extra_service_name');
								$extra_service_price = Appointy_Router_Helper::get_sanitize_data($extra_service,'extra_service_price');
								$hours = Appointy_Router_Helper::get_sanitize_data($extra_service,'hours');
								$minutes = Appointy_Router_Helper::get_sanitize_data($extra_service,'minutes');
								$display_service_period = Appointy_Router_Helper::get_sanitize_data($extra_service,'display_service_period');
								$service_period	 = Appointy_Router_Helper::get_sanitize_data($extra_service,'service_period');
								
								$attachment_id = get_post_meta($extra_service_id, 'image_id', true);
	
								$serviethumb = Appointy_Image_Helper::get_image_url_by_id($attachment_id,'thumbnail');
			
								echo '<li>';
								echo '<span><img src="'.esc_url($serviethumb).'"></span>';
								echo '<span>'.esc_html($extra_service_name).'</span>';	
								echo '<span>'.Appointy_Misc_Helper::get_price_format($extra_service_price).'</span>';	
								echo '<span>'.esc_html($display_service_period).'</span>';	
								echo '</li>';
							}
							echo '</ul>';
						}
					  ?>

					</div>

				  </div>

				</div>

				<?php

			}

		}

		$html = ob_get_clean();

		

		return $html;

	}
	
	/**
	 * Get appointment total
	 *
	 * @return array
	 */
	public static function get_total_appointment_amount() {
		$args = array(
	
			'post_status' => array( 'processing', 'on-hold', 'completed' ),

			'post_type' => 'appointy_appointment',

			'posts_per_page' => -1,

		);
		
		$the_query = new \WP_Query( $args );
		$totalamount = 0;
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) : $the_query->the_post();
				$post_id = get_the_id();		
				
				$amount = get_post_meta($post_id,'totalamount',true);
				$totalamount = floatval($totalamount) + floatval($amount);
				
			endwhile;
			wp_reset_postdata();
		}
		
		return $totalamount;		
	}
	
	/**
	 * Get invoice total
	 *
	 * @return array
	 */
	public static function get_total_invoice_amount() {
		$args = array(
			'post_status' => array( 'draft', 'publish' ),
			'post_type' => 'appointy_invoice',
			'posts_per_page' => -1,
		);
		$the_query = new \WP_Query( $args );
		$totalamount = 0;
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) : $the_query->the_post();
				$post_id = get_the_id();		
				
				$amount = get_post_meta($post_id,'grand_total',true);
				$totalamount = floatval($totalamount) + floatval($amount);
	
			endwhile;
			wp_reset_postdata();
		}
		
		return $totalamount;
	}
	
	/**
	 * Get all appointments
	 *
	 * @return array
	 */
	public static function get_all_appointments() {
		$args = array(
	
			'post_status' => array( 'cancelled', 'pending', 'processing', 'on-hold', 'completed' ),

			'post_type' => 'appointy_appointment',

			'posts_per_page' => -1,

		);
		
		$the_query = new \WP_Query( $args );
		$completed = 0;
		$pending = 0;
		$cancelled = 0;
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) : $the_query->the_post();
				$post_id = get_the_id();		
				
				if( get_post_status($post_id) === 'processing' || get_post_status($post_id) === 'on-hold' || get_post_status($post_id) === 'pending' ) {
					$pending++;
				} elseif( get_post_status($post_id) === 'completed' ) {
					$completed++;
				} elseif( get_post_status($post_id) === 'cancelled' ) {
					$cancelled++;
				}
				
			endwhile;
			wp_reset_postdata();
		}
		
		$result = array(
			'completed' => $completed,
			'pending' => $pending,
			'cancelled' => $cancelled,
			'all' => intval($completed) + intval($pending) + intval($cancelled)
		);
		
		return $result;
	}
	
	/**
	 * Get appointments graph fields
	 *
	 * @return array
	 */
	public static function get_appointments_graph( $year = '' ) {
		$completed_array = array();
		$uncompleted_array = array();
		$cancelled_array = array();
		
		$args = array(
			'post_status' => array( 'processing', 'on-hold', 'completed', 'cancelled' ),
			'post_type' => 'appointy_appointment',
			'posts_per_page' => -1,
			'date_query' => array(
				array(
					'year'     => $year
				)
			),
		);		
		
		$the_query = new \WP_Query( $args );
		
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) : $the_query->the_post();
				$post_id = get_the_id();		
				$month = get_the_date('n');
				
				if( get_post_status($post_id) === 'processing' || get_post_status($post_id) === 'on-hold' ) {
					$uncompleted_array[] = $month;
				} elseif( get_post_status($post_id) === 'completed' ) {
					$completed_array[] = $month;
				} elseif( get_post_status($post_id) === 'cancelled' ) {
					$cancelled_array[] = $month;
				}
				
			endwhile;
			wp_reset_postdata();
		}
		
		$completed = array();
		$uncompleted = array();
		$cancelled = array();
		
		for($i = 0;$i < 12;$i++) {
			$completed[$i] = 0;
			$uncompleted[$i] = 0;
			$cancelled[$i] = 0;
		}
		
		$montly_completed = array_count_values($completed_array);
		if(!empty($montly_completed)) {
			foreach($montly_completed as $key => $value) {
				$completed[$key - 1] = $value;
			}
		}
		
		$montly_uncompleted = array_count_values($uncompleted_array);
		if(!empty($montly_uncompleted)) {
			foreach($montly_uncompleted as $key => $value) {
				$uncompleted[$key - 1] = $value;
			}
		}
		
		$montly_cancelled = array_count_values($cancelled_array);
		if(!empty($montly_cancelled)) {
			foreach($montly_cancelled as $key => $value) {
				$cancelled[$key - 1] = $value;
			}
		}
		
		
		$graph_fields = array(
			'months'	          => self::get_months_names(),
			'completed_label'       => esc_html__('Appointments Completed','appointy'),
			'uncompleted_label'       => esc_html__('Incomplete Appointments','appointy'),
			'cancelled_label'  => esc_html__('Appointments Cancelled','appointy'),
			'completed_dataset'     => $completed,
			'uncompleted_dataset'     => $uncompleted,
			'cancelled_dataset'=> $cancelled,
		);
		
		return $graph_fields;
	}
	
	/**
	 * Get revenue graph fields
	 *
	 * @return array
	 */
	public static function get_revenue_graph( $year = '' ) {
		/*Get monthly booking amount Start*/

		$args = array(
			'post_status' => array( 'processing', 'on-hold', 'completed' ),
			'post_type' => 'appointy_appointment',
			'posts_per_page' => -1,
			'date_query' => array(
				array(
					'year'     => $year
				)
			),
		);
		
		$the_query = new \WP_Query( $args );
		
		$booking_array = array();
		
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) : $the_query->the_post();
		
				$month = date('n',strtotime(get_the_date()));
		
				$post_id = get_the_id();		
		
				$amount = get_post_meta($post_id,'totalamount',true);
				$booking_array[$month][] = $amount;
		
			endwhile;
		
			wp_reset_postdata();
		}
		
		$bookings = array();
		for($i = 0;$i < 12;$i++) {
			$bookings[$i] = 0;
		}
		
		
		
		if(!empty($booking_array)) {
			foreach($booking_array as $key => $value) {
				$bookings[$key - 1] = array_sum($value);
			}
		}
		/*Get monthly booking amount End*/
		
		/*Get monthly invoice amount Start*/
		$args = array(
			'post_status' => array( 'draft', 'publish' ),
			'post_type' => 'appointy_invoice',
			'date_query' => array(
								array(
									'year'  => $year,
								),
							),
			'posts_per_page' => -1,
		);
		
		$the_query = new \WP_Query( $args );
		
		$invoice_array = array();
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) : $the_query->the_post();
		
				$month = date('n',strtotime(get_the_date()));
		
				$post_id = get_the_id();		
		
				$amount = get_post_meta($post_id,'totalamount',true);
				$invoice_array[$month][] = $amount;
		
			endwhile;
			wp_reset_postdata();
		}
		
		$invoice = array();
		for($i = 0;$i < 12;$i++) {
			$invoice[$i] = 0;
		}
		
		if(!empty($invoice_array)) {
			foreach($invoice_array as $key => $value) {
				$invoice[$key - 1] = array_sum($value);
			}
		}
		/*Get monthly invoice amount End*/
		
		/*Get monthly subscription amount End*/
		$graph_fields = array(
			'months'	          => self::get_months_names(),
			'appointment_label'       => esc_html__('Appointments','appointy'),
			'invoice_label'       => esc_html__('Invoice','appointy'),
			'booking_dataset'     => $bookings,
			'invoice_dataset'     => $invoice,
		);
		
		return $graph_fields;
	}
	
	/**
	 * Get month names
	 *
	 * @return void
	 */
	public static function get_months_names() {
		
		$months = array(
			esc_html__('January','appointy'),
			esc_html__('February','appointy'),
			esc_html__('March','appointy'),
			esc_html__('April','appointy'),
			esc_html__('May','appointy'),
			esc_html__('June','appointy'),
			esc_html__('July','appointy'),
			esc_html__('August','appointy'),
			esc_html__('September','appointy'),
			esc_html__('October','appointy'),
			esc_html__('November','appointy'),
			esc_html__('December','appointy')
		);
		
		return $months;
	}
	
	/**
	 * Ajax pagination
	 *
	 * @return string
	 */
	public static function ajax_pagination( $type = '', $total_post = 0, $post_count = 0, $per_page = 10, $page = 1 ) {
		global $wp_query, $wp_rewrite;

		// Sanitize the received page  
        $cur_page = $page;
        $page -= 1;
        // Set the number of results to display
        $previous_btn = true;
        $next_btn = true;
        $first_btn = true;
        $last_btn = true;
        $start = $page * $per_page;
		
		// This is where the magic happens
        $no_of_paginations = ceil($total_post / $per_page);

        if ($cur_page >= 7) {
            $start_loop = $cur_page - 3;
            if ($no_of_paginations > $cur_page + 3)
                $end_loop = $cur_page + 3;
            else if ($cur_page <= $no_of_paginations && $cur_page > $no_of_paginations - 6) {
                $start_loop = $no_of_paginations - 6;
                $end_loop = $no_of_paginations;
            } else {
                $end_loop = $no_of_paginations;
            }
        } else {
            $start_loop = 1;
            if ($no_of_paginations > 7)
                $end_loop = 7;
            else
                $end_loop = $no_of_paginations;
        }
       
        // Pagination Buttons logic    
        $pag_container = "
        <div class='cvf-universal-pagination site-pagination s-p-center' data-type='$type'>
            <ul class='pagination'>";

        /*if ($first_btn && $cur_page > 1) {
            $pag_container .= "<li p='1' class='active page-item'>First</li>";
        } else if ($first_btn) {
            $pag_container .= "<li p='1' class='inactive page-item'>First</li>";
        }*/

        if ($previous_btn && $cur_page > 1) {
            $pre = $cur_page - 1;
            $pag_container .= "<li p='$pre' class='active page-item'><a href='javascript:;' class='page-link'><i class='fa fa-chevron-left'></i></a></li>";
        } else if ($previous_btn) {
            $pag_container .= "<li class='inactive page-item'><a href='javascript:;' class='page-link'><i class='fa fa-chevron-left'></i></a></li>";
        }
        for ($i = $start_loop; $i <= $end_loop; $i++) {

            if ($cur_page == $i)
                $pag_container .= "<li p='$i' class = 'current page-item' ><a href='javascript:;' class='page-link'>{$i}</a></li>";
            else
                $pag_container .= "<li p='$i' class='active page-item'><a href='javascript:;' class='page-link'>{$i}</a></li>";
        }
       
        if ($next_btn && $cur_page < $no_of_paginations) {
            $nex = $cur_page + 1;
            $pag_container .= "<li p='$nex' class='active page-item'><a href='javascript:;' class='page-link'><i class='fa fa-chevron-right'></i></a></li>";
        } else if ($next_btn) {
            $pag_container .= "<li class='inactive page-item'><a href='javascript:;' class='page-link'><i class='fa fa-chevron-right'></i></a></li>";
        }

        /*if ($last_btn && $cur_page < $no_of_paginations) {
            $pag_container .= "<li p='$no_of_paginations' class='active page-item'>Last</li>";
        } else if ($last_btn) {
            $pag_container .= "<li p='$no_of_paginations' class='inactive page-item'>Last</li>";
        }*/

        echo $pag_container = $pag_container . "
            </ul>
        </div>";
	}
	
	/**
	 * Booking review form
	 *
	 * @return array
	 */
	public static function booking_review_form( ) {
		
		$fields = apply_filters( 'booking_review_form_fields', array(
			'review_title' => array(
				'type'        => 'text',
				'icon'        => 'fa fa-user-circle-o',
				'colum-width' => 'col-lg-12',
				'required'    => true,
				'placeholder' => esc_html__( 'Review Title', 'appointy' ),
				'validation_message' => esc_html__( 'Review title is required', 'appointy' ),
				'priority'    => 1
			),
			'description' => array(
				'type'        => 'textarea',
				'icon'        => 'fa fa-pencil',
				'colum-width' => 'col-lg-12',
				'required'    => true,
				'validation_message' => esc_html__( 'Please enter description', 'appointy' ),
				'placeholder' => esc_html__( 'Description', 'appointy' ),
				'priority'    => 2
			)
		) );

		return Appointy_Form_Helper::get_fields( $fields );	
	}
	
	/**
	 * Add appointment review
	 *
	 * @return array
	 */
	public static function add_feedback() {
		global $wpdb, $current_user;
		if( ! wp_verify_nonce( $_POST['_nonce'], 'appointy_ajax_nonce' ) ) {
			wp_send_json_error();
			die();
		}
		
		$reviewid = Appointy_Router_Helper::get_sanitize_data( $_POST, 'reviewid' );
		$appointment_id = Appointy_Router_Helper::get_sanitize_data( $_POST, 'bookingid' );
		$service_id = Appointy_Router_Helper::get_sanitize_data( $_POST, 'serviceid' );
		$rating = Appointy_Router_Helper::get_sanitize_data( $_POST, 'rating' );
		$review_title = Appointy_Router_Helper::get_sanitize_data( $_POST, 'review_title' );
		$description = Appointy_Router_Helper::get_sanitize_data( $_POST, 'description' );
		
		$customer_name = Appointy_Appointments_Helper::get_appointment_customername( $appointment_id );
		$customer_email = get_post_meta( $appointment_id, 'email', true );
		
		$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
		$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
		
		$booked_service = Appointy_Appointments_Helper::get_booked_service( $service_id );
		
		$member_id = Appointy_Router_Helper::get_request_data($booked_service,'member_id');
		$member_id = ( $member_id != '' ) ? $member_id : 0;
		
		$review_status = 'publish';
		
		if( !empty( $reviewid ) ) {
			$meta_fields['rating'] = $rating;
			
			$review_post = array(
				'ID'           		=> $reviewid,
				'post_title' 		=> $review_title,
				'post_status' 		=> $review_status,
				'post_content' 		=> $description,
				'meta_input'   		=> $meta_fields
			);
			$post_id = wp_update_post( $review_post );
		} else {
			$user_from = ( is_user_logged_in() ) ? $current_user->ID : 0;
		
			$meta_fields['review_to']  = $service_id;
			$meta_fields['review_to_member']  = $member_id;
			$meta_fields['from_name']  = $customer_name;
			$meta_fields['from_email'] = $customer_email;
			$meta_fields['rating'] = $rating;
			
			$review_post = array(
				'post_title' 		=> $review_title,
				'post_status' 		=> $review_status,
				'post_content' 		=> $description,
				'post_author' 		=> $customer_id,
				'post_type' 		=> 'appointy_reviews',
				'post_date' 		=> wp_date('Y-m-d H:i:s'),
				'meta_input'   		=> $meta_fields
			);
			$post_id = wp_insert_post($review_post);
		}
		
		if ( is_wp_error( $post_id ) ) { 	
			$response = array('msg' => $wpdb->print_error());
			wp_send_json_error($response);	
		} else {		
			
			$avgratingdata = self::calculate_appointment_average_rating($member_id);
			
			update_user_meta( $member_id,'avg_booking_rating',$avgratingdata['average_rating'] );
			update_user_meta( $member_id,'total_booking_review',$avgratingdata['totalreview'] );
			
			if( !empty( $reviewid ) ) {
			Appointy_Send_Email_Notification_Helper::send_update_review_email_notifications($post_id,$appointment_id,$service_id);
			}else{
			Appointy_Send_Email_Notification_Helper::send_add_review_email_notifications($post_id,$appointment_id,$service_id);
			}
			
			if( !empty( $reviewid ) ) {
				$response = array( 'msg' => esc_html__('Your review updated successfully.', 'appointy') );
			} else {
				$response = array( 'msg' => esc_html__('Your review posted successfully.', 'appointy') );
			}
			wp_send_json_success($response);
		}

		die();
		
	}
	
	/**
	 * Get average rating
	 *
	 * @return array
	 */
	public static function calculate_appointment_average_rating( $member_id = 0 ) {
		global $wp_query, $wpdb;

		$args = array(
            'post_type' => 'appointy_reviews',
            'post_status' => 'publish',
            'posts_per_page' => -1,
			'meta_query' => array(
				array(
					'key'     => 'review_to_member',
					'value'   => $member_id,
					'compare' => '=',
				),
			),
        );
		
        $wp_query = new \WP_Query($args);
		$totalreview = 0;
		$total_rating = 0;
		if ( $wp_query->have_posts() ) {
			while ( $wp_query->have_posts() ) : $wp_query->the_post();
				$reviewid = get_the_id();
				
				$rating = get_post_meta( $reviewid,'rating',true );
				if( !empty( $rating ) ) {
					$total_rating = floatval($total_rating) + floatval($rating);
				}
				
				$totalreview++;
			endwhile;
		}	
		
		if($total_rating > 0) {
			$average_rating = floatval($total_rating) / floatval($totalreview);
		} else {
			$average_rating = 0;
		}
		
		$average_rating = round($average_rating,1);
		
		$response = array('average_rating' => $average_rating, 'totalreview' => $totalreview);
		
		return $response;
	}
	
	/**
	 * Has booking review
	 *
	 * @return array
	 */
	public static function has_appointment_review( $service_id = 0, $customer_id = 0 ) {
		global $wp_query, $wpdb;

		$args = array(
            'post_type' => 'appointy_reviews',
            'post_status' => array('publish','draft'),
            'posts_per_page' => 1,
			'post_author' => $customer_id,
			'meta_query' => array(
				array(
					'key'     => 'review_to',
					'value'   => $service_id,
					'compare' => '=',
				),
			),
        );
		
        $wp_query = new \WP_Query($args);
		if ( $wp_query->have_posts() ) {
			return true;
		} else {
			return false;
		}	
	}
	
	/**
	 * Get booking review id
	 *
	 * @return array
	 */
	public static function get_appointment_review_id( $service_id = 0, $customer_id = 0 ) {
		global $wp_query, $wpdb;

		$args = array(
            'post_type' => 'appointy_reviews',
            'post_status' => array('publish','draft'),
            'posts_per_page' => 1,
			'post_author' => $customer_id,
			'meta_query' => array(
				array(
					'key'     => 'review_to',
					'value'   => $service_id,
					'compare' => '=',
				),
			),
        );
		
        $wp_query = new \WP_Query($args);
		//$totalposts = $wp_query->found_posts;
		if ( $wp_query->have_posts() ) {
			while ( $wp_query->have_posts() ) : $wp_query->the_post();
				$reviewid = get_the_id();
				return $reviewid;
			endwhile;
		}else{
			return false;
		}
	}
	
	/**
	 * Process load booking review
	 *
	 * @return array
	 */
	public static function load_booking_feedback( ) {
		global $wpdb;
		
		$reviewid = Appointy_Router_Helper::get_request_data( $_POST, 'reviewid' );
		
		$title = get_the_title($reviewid);
		$description = get_the_content('','',$reviewid);
		$rating = get_post_meta( $reviewid,'rating',true );
		
		$response = array( 
			'title' => $title,
			'description' => $description,
			'rating' => $rating
		);
		wp_send_json_success($response);
		
   		die();
	}
	
	/**
	 * View booking review details
	 *
	 * @return array
	 */
	public static function view_booking_review_details() {
		global $wpdb, $current_user;
		
		$post_id = Appointy_Router_Helper::get_request_data( $_POST, 'postid' );
		$reviewerid = get_post_field( 'post_author', $post_id );
			
		$rating = get_post_meta( $post_id,'rating',true );
		$reviewer_avatar = '';
		$ratingprefix = 'reviewdetail';
		ob_start();
		?>
		<div class="sf-userReviewBox">
            <div class="sf-userReview-header">
                <div class="sf-userReview-propic">
                <img src="<?php echo esc_url($reviewer_avatar); ?>" alt=""></div>
                <div class="sf-userReview-proinfo">
                    <h6 class="sf-userReview-proName"><?php echo get_post_meta($post_id,'from_name',true); ?></h6>
                    <div class="sf-userReview-proDate"><i class="fa fa-calendar-o"></i> <?php echo Appointy_Misc_Helper::get_date_format(get_the_date('',$post_id)); ?></div>
                </div>
            </div>
            
            <div class="sf-userReview-ratingBox">
                <div class="sf-userReview-prorating">
                    <span class="sf-userReview-title"><?php esc_html_e( 'Rating','appointy' ); ?></span>
                    <div class="sf-medi-rate">
                    <div class="showdynamicrating" id="showdynamicrating-<?php echo esc_attr($ratingprefix); ?>-<?php echo esc_attr($post_id); ?>" data-reviewid="<?php echo esc_attr($ratingprefix); ?>-<?php echo esc_attr($post_id); ?>" data-rating="<?php echo esc_attr(floatval($rating)); ?>"></div>
                    <span class="sf-rating-lable">(<?php echo trim($rating); ?>/5)</span>
                    </div>
                </div>
                <h6><?php echo get_the_title($post_id); ?></h6>
                <div class="sf-userReview-protext"><?php echo apply_filters('the_content', get_the_content('','',$post_id)); ?></div>
                
            </div>
        </div>
		<?php
		$response = ob_get_clean();
		wp_send_json_success($response);
		die();
	}
	
	/**
	 * Get customer reviews
	 *
	 * @return array
	 */
	public static function get_customer_reviews( $customer_id = 0 ) {
		global $wp_query, $wpdb;

		$args = array(
            'post_type' => 'appointy_reviews',
            'post_status' => 'publish',
            'posts_per_page' => -1,
			'author' => $customer_id
        );
		
        $customer_review_query = new \WP_Query($args);
		
		return $customer_review_query;
	}
	
	/**
	 * Get member reviews
	 *
	 * @return array
	 */
	public static function get_member_reviews( $member_id = 0 ) {
		global $wp_query, $wpdb;

		$args = array(
            'post_type' => 'appointy_reviews',
            'post_status' => 'publish',
            'posts_per_page' => -1,
			'meta_query' => array(
				array(
					'key'     => 'review_to_member',
					'value'   => $member_id,
					'compare' => '=',
				),
			),
        );
		
        $member_review_query = new \WP_Query($args);
		
		return $member_review_query;
	}
	
	/**
	 * Get appointment per page
	 *
	 * @return string
	 */
	public static function get_appointment_per_page() {
		$per_page = 10;
		
		return $per_page;
	}
	
	/**
	 * Load pagination appointments
	 *
	 * @return array
	 */
	public static function load_pagination_appointments() {
		global $wp_query, $wpdb;
		
		$user_id = get_current_user_id();
		
		$user = wp_get_current_user();
		$user_roles = $user->roles;
		
		if(in_array('appointy_staff',$user_roles)) {
			$page = Appointy_Router_Helper::get_sanitize_data( $_POST, 'page' );
		
			$bookingurl = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-booking-form' );
			$staff_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-staff-dashboard' );
			
			$cur_page = $page;
			$page -= 1;
			// Set the number of results to display
			$per_page = self::get_appointment_per_page();
			$previous_btn = true;
			$next_btn = true;
			$first_btn = true;
			$last_btn = true;
			$start = $page * $per_page;
			
			$results = self::get_staff_appointments( $user_id, $per_page, $start);
			$template_name = 'appointments-content';
			
			$total_results = self::get_staff_total_appointments( $user_id);
			
			//echo $the_query->request;
			$total_post = count($total_results);
			$post_count = count($results);
			ob_start();
			if ( $results ) {
				echo '<div class="pagination_container" id="appointy_appointments_table">';
				foreach($results as $row){
					$appointment_id = Appointy_Router_Helper::get_sanitize_data( $row, 'appointment_id' );
					$service_id = Appointy_Router_Helper::get_sanitize_data( $row, 'id' );
					$appointment_date = Appointy_Router_Helper::get_sanitize_data( $row, 'booking_date' );
					$appointment_time = Appointy_Router_Helper::get_sanitize_data( $row, 'booking_start_time' );
					
					$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
					$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
					
					$viewbooking = add_query_arg( array( 'navitem' => 'view-appointment','appointment_id' => $appointment_id,'service_id' => $service_id ), $staff_dashboard_url );
					?>
					<div class="sf-appoi-row">
						<div class="d-flex justify-content-between align-items-center">
							<div class="sf-appoi-first d-flex align-items-center">
								<div class="aon-date-box"> <strong><?php echo wp_date('d',strtotime($appointment_date)); ?></strong> <span><?php echo wp_date('M',strtotime($appointment_date)); ?></span> </div>
								<div class="sf-appoi-user"> <img src="<?php echo Appointy_Staff_Helper::get_user_avatar($customer_id,'appointy-300x300'); ?>" alt=""> </div>
								<div class="sf-appoi-info">
									<h4><?php echo Appointy_Appointments_Helper::get_appointment_customername( $appointment_id ); ?></h4>
								</div>
							</div>
							<div class="sf-appoi-second">
								<i class="fa fa-calendar-o"></i> <?php echo wp_date('l',strtotime($appointment_date)); ?>, <i class="fa fa-clock-o"></i> <?php echo Appointy_Misc_Helper::get_time_format($appointment_time); ?>
							</div>
							<div class="sf-appoi-second"> <span class="btn-pending"><?php echo Appointy_Appointments_Helper::get_appointment_payment_method($appointment_id); ?></span> </div>
							<div class="sf-appoi-third">
								<div class="dropdown action-dropdown dropdown-left">
									<button  type="button" class="action-button btn btn-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false"> <i class="fa fa-ellipsis-v"></i> </button>
									<ul class="dropdown-menu" >
										<li><a class="dropdown-item" href="<?php echo esc_url($bookingurl); ?>"><i class="feather-calendar"></i> <?php echo esc_html__( 'Book Agian', 'appointy' ) ?></a></li>
										<li><a class="dropdown-item" href="<?php echo esc_url($viewbooking); ?>"><i class="feather-eye"></i> <?php echo esc_html__( 'View Detail', 'appointy' ) ?></a></li>
										<li><a class="dropdown-item" href="javascript:;"><i class="feather-trash"></i> <?php echo esc_html__( 'Cancelled', 'appointy' ) ?></a></li>
									</ul>
								</div>
							</div>
						</div>
					</div>
					<?php
				}
				self::ajax_pagination( 'appointments', $total_post, $post_count, $per_page, $cur_page );
				echo '</div>';
				wp_reset_postdata();
			}
			$html = ob_get_clean();
		}else{
			$page = Appointy_Router_Helper::get_sanitize_data( $_POST, 'page' );
			
			$bookingurl = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-booking-form' );
			$customer_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-customer-dashboard' );
			
			$cur_page = $page;
			$page -= 1;
			// Set the number of results to display
			$per_page = self::get_appointment_per_page();
			$previous_btn = true;
			$next_btn = true;
			$first_btn = true;
			$last_btn = true;
			$start = $page * $per_page;
			
			$the_query = self::get_customer_appointments( $user_id, $per_page, $start);
			$template_name = 'appointments-content';
			
			//echo $the_query->request;
			$total_post = $the_query->found_posts;
			$post_count = $the_query->post_count;
			ob_start();
			if ( $the_query->have_posts() ) {
				while ( $the_query->have_posts() ) : $the_query->the_post();
					$appointment_id = get_the_id();	
					$viewbooking = add_query_arg( array( 'navitem' => 'view-appointment','appointment_id' => $appointment_id ), $customer_dashboard_url );
				
					$appointment_date = get_the_date('',$appointment_id);
					$appointment_time = get_the_time('',$appointment_id);
					
					$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
					$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
					?>
					<div class="sf-appoi-row">
						<div class="d-flex justify-content-between align-items-center">
							<div class="sf-appoi-first d-flex align-items-center">
								<div class="aon-date-box"> <strong><?php echo wp_date('d',strtotime($appointment_date)); ?></strong> <span><?php echo wp_date('M',strtotime($appointment_date)); ?></span> </div>
								<div class="sf-appoi-user"> <img src="<?php echo Appointy_Staff_Helper::get_user_avatar($customer_id,'appointy-300x300'); ?>" alt=""> </div>
								<div class="sf-appoi-info">
									<h4><?php echo Appointy_Appointments_Helper::get_appointment_customername( $appointment_id ); ?></h4>
								</div>
							</div>
							<div class="sf-appoi-second">
								<i class="fa fa-calendar-o"></i> <?php echo wp_date('l',strtotime($appointment_date)); ?>, <i class="fa fa-clock-o"></i> <?php echo Appointy_Misc_Helper::get_time_format($appointment_time); ?>
							</div>
							<div class="sf-appoi-second"> <span class="btn-pending"><?php echo Appointy_Appointments_Helper::get_appointment_payment_method($appointment_id); ?></span> </div>
							<div class="sf-appoi-third">
								<div class="dropdown action-dropdown dropdown-left">
									<button  type="button" class="action-button btn btn-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false"> <i class="fa fa-ellipsis-v"></i> </button>
									<ul class="dropdown-menu" >
										<li><a class="dropdown-item" href="<?php echo esc_url($bookingurl); ?>"><i class="feather-calendar"></i> <?php echo esc_html__( 'Book Agian', 'appointy' ) ?></a></li>
										<li><a class="dropdown-item" href="<?php echo esc_url($viewbooking); ?>"><i class="feather-eye"></i> <?php echo esc_html__( 'View Detail', 'appointy' ) ?></a></li>
										<li><a class="dropdown-item" href="javascript:;"><i class="feather-trash"></i> <?php echo esc_html__( 'Cancelled', 'appointy' ) ?></a></li>
									</ul>
								</div>
							</div>
						</div>
					</div>
					<?php
				endwhile;
				self::ajax_pagination( 'appointments', $total_post, $post_count, $per_page, $cur_page );
				wp_reset_postdata();
			}
			$html = ob_get_clean();
		}
		wp_send_json_success($html);
		
   		die();
	}
	
	/**

	 * Get calendar appointments

	 *

	 * @return array

	 */

	public static function get_calendar_appointments_query($user_id = '') { 

		global $wpdb;
		
		$args = array(
	
				'post_status' => array( 'cancelled', 'pending', 'processing', 'on-hold', 'completed' ),
	
				'post_type' => 'appointy_appointment',
	
				'orderby' => 'ID',
	
				'order'   => 'DESC',
	
				'posts_per_page' => -1,
				
				'meta_query' => array(
					array(
						'key'     => 'booking_customer_id',
						'value'   => $user_id,
						'compare' => '=',
					),
				)
	
			);

		

		

		$the_query = new \WP_Query( $args );

		

		return $the_query;

	}
	
	/**

	 * Get staff calendar appointments

	 *

	 * @return array

	 */

	public static function get_staff_calendar_appointments($user_id = 0) { 
		global $wpdb;

		$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`date`,`appointment_id`,`service_id`,`service_name`,`servicetype`,`service_period`,`variation_name`,`hours`,`minutes`,`display_service_period`,`show_branches`,`members_available`,`branch_id`,`member_id`,`booking_date`,`booking_start_time`,`booking_end_time`,`parent_category`,`service_status`,`status_update_by`,`service_price`,`booking_amount_status`,`customerid`,`customeremail`,`couponcode`,`oldserviceprice`,`cacellation_reason`,`service_completed_date` FROM `'.$wpdb->prefix.'appointy_booked_services` WHERE `member_id` = %d order by `id` desc',$user_id));

		return $results;
	}
	
	/**
	 * Process load appointment calendar
	 *
	 * @return array
	 */
	public static function load_appointment_calendar() {
		global $wpdb;
		extract($_POST);
		
		$user_id = ( isset( $user_id ) ) ? sanitize_text_field( $user_id ) : '';
		
		$user = wp_get_current_user();
		$user_roles = $user->roles;
		
		if(in_array('appointy_staff',$user_roles)) {
		
		$results = self::get_staff_calendar_appointments( $user_id );
		
		$allappointments = array();
		
		$staff_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-staff-dashboard' );
		
		if ( $results ) {
			foreach($results as $booked_service){
				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $booked_service, 'appointment_id' );
				
				$customername = Appointy_Appointments_Helper::get_appointment_customername( $appointment_id );
				
				$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
				$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
				
				$service_id = Appointy_Router_Helper::get_request_data($booked_service,'id');
	
				$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');

				$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');

				$servicetype = Appointy_Router_Helper::get_request_data($booked_service,'servicetype');

				$variation_name = Appointy_Router_Helper::get_request_data($booked_service,'variation_name');

				

				$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;

				

				$booking_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_date');

				$booking_start_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_start_time');

				$booking_end_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_end_time');

				$service_price = Appointy_Router_Helper::get_request_data($booked_service,'service_price');

				$member_id = Appointy_Router_Helper::get_request_data($booked_service,'member_id');

				$branch_id = Appointy_Router_Helper::get_request_data($booked_service,'branch_id');

				$cacellation_reason = Appointy_Router_Helper::get_request_data($booked_service,'cacellation_reason');

				$service_status = Appointy_Router_Helper::get_request_data($booked_service,'service_status');
				
				$member_name = Appointy_Misc_Helper::get_fullname_by_user_id( $member_id );
				
				$viewbooking = add_query_arg( array( 'navitem' => 'view-appointment','appointment_id' => $appointment_id,'service_id' => $service_id ), $staff_dashboard_url );
				
				if( $service_status == 'completed' ) {
					$event_color = '#5BD168';
				} elseif($service_status == 'pending') {
					$event_color = '#EC5052';
				}elseif($service_status == 'processing') {
					$event_color = '#bbcefb';
				}elseif($service_status == 'on-hold') {
					$event_color = '#f4d55b';
				}elseif($service_status == 'cancelled') {
					$event_color = '#f49f9f';
				}
				
				$appointment['id'] = $appointment_id;
				$appointment['title'] = $service_name;
				$appointment['url'] = $viewbooking;
				$appointment['color'] = $event_color;
				$appointment['start'] = $booking_date.'T'.$booking_start_time.'Z';
				$appointment['end'] = $booking_date.'T'.$booking_end_time;
				$appointment['member_name'] = $member_name;
				$appointment['customer_name'] = $customername;
				$appointment['patient_email'] = get_post_meta( $appointment_id, 'email', true );
				$appointment['patient_phone'] = get_post_meta( $appointment_id, 'phone', true );
				$appointment['service_status'] = $service_status;
				$appointment['appointment_status'] = Appointy_Appointments_Helper::get_post_status_by_slug( Appointy_Appointments_Helper::get_post_status( $appointment_id ) );
				$appointment['appointment_date'] = Appointy_Misc_Helper::get_date_format($booking_date);
				$appointment['appointment_start_time'] = Appointy_Misc_Helper::get_time_format($booking_start_time);
				$appointment['appointment_end_time'] = Appointy_Misc_Helper::get_time_format($booking_end_time);
				$appointment['start_time'] = $booking_start_time;
				$appointment['patient_avatar'] = Appointy_Staff_Helper::get_user_avatar($customer_id,'appointy-300x300');
				
				array_push($allappointments, $appointment);
			}
		}
		echo $allappointments = json_encode($allappointments);
		}else{
		$the_query = self::get_calendar_appointments_query($user_id);
		
		$customer_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-customer-dashboard' );

		$allappointments = array();
		
		if ( $the_query->have_posts() ) {
			while ( $the_query->have_posts() ) : $the_query->the_post();
				$appointment_id = get_the_id();
				$customername = Appointy_Appointments_Helper::get_appointment_customername( $appointment_id );
				
				$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
				$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
				
				$booked_services = Appointy_Appointments_Helper::get_booked_services( $appointment_id );

				if(!empty($booked_services)) {

					foreach($booked_services as $booked_service) {
	
						$service_id = Appointy_Router_Helper::get_request_data($booked_service,'id');
	
						$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');
	
						$service_name = Appointy_Router_Helper::get_request_data($booked_service,'service_name');
	
						$servicetype = Appointy_Router_Helper::get_request_data($booked_service,'servicetype');
	
						$variation_name = Appointy_Router_Helper::get_request_data($booked_service,'variation_name');
	
						
	
						$service_name = ($servicetype === 'hourly') ? $variation_name : $service_name;
	
						
	
						$booking_date = Appointy_Router_Helper::get_request_data($booked_service,'booking_date');
	
						$booking_start_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_start_time');
	
						$booking_end_time = Appointy_Router_Helper::get_request_data($booked_service,'booking_end_time');
	
						$service_price = Appointy_Router_Helper::get_request_data($booked_service,'service_price');
	
						$member_id = Appointy_Router_Helper::get_request_data($booked_service,'member_id');
	
						$branch_id = Appointy_Router_Helper::get_request_data($booked_service,'branch_id');
	
						$cacellation_reason = Appointy_Router_Helper::get_request_data($booked_service,'cacellation_reason');
	
						$service_status = Appointy_Router_Helper::get_request_data($booked_service,'service_status');
						
						$member_name = Appointy_Misc_Helper::get_fullname_by_user_id( $member_id );
						
						$viewbooking = add_query_arg( array( 'navitem' => 'view-appointment','appointment_id' => $appointment_id ), $customer_dashboard_url );
						
						if( $service_status == 'completed' ) {
							$event_color = '#5BD168';
						} elseif($service_status == 'pending') {
							$event_color = '#EC5052';
						}elseif($service_status == 'processing') {
							$event_color = '#bbcefb';
						}elseif($service_status == 'on-hold') {
							$event_color = '#f4d55b';
						}elseif($service_status == 'cancelled') {
							$event_color = '#f49f9f';
						}
						
						$appointment['id'] = $appointment_id;
						$appointment['title'] = $service_name;
						$appointment['url'] = $viewbooking;
						$appointment['color'] = $event_color;
						$appointment['start'] = $booking_date.'T'.$booking_start_time.'Z';
						$appointment['end'] = $booking_date.'T'.$booking_end_time;
						$appointment['member_name'] = $member_name;
						$appointment['customer_name'] = $customername;
						$appointment['patient_email'] = get_post_meta( $appointment_id, 'email', true );
						$appointment['patient_phone'] = get_post_meta( $appointment_id, 'phone', true );
						$appointment['service_status'] = $service_status;
						$appointment['appointment_status'] = Appointy_Appointments_Helper::get_post_status_by_slug( Appointy_Appointments_Helper::get_post_status( $appointment_id ) );
						$appointment['appointment_date'] = Appointy_Misc_Helper::get_date_format($booking_date);
						$appointment['appointment_start_time'] = Appointy_Misc_Helper::get_time_format($booking_start_time);
						$appointment['appointment_end_time'] = Appointy_Misc_Helper::get_time_format($booking_end_time);
						$appointment['start_time'] = $booking_start_time;
						$appointment['patient_avatar'] = Appointy_Staff_Helper::get_user_avatar($customer_id,'appointy-300x300');
						
						array_push($allappointments, $appointment);
	
					}
	
				}
			endwhile;
			wp_reset_postdata();
		}
		
		echo $allappointments = json_encode($allappointments);
		}
		
		die();
	}
	
	/**
	 * Update deposit full payment
	 *
	 * @return string
	 */
	public static function update_deposit_full_payment($woopostdata,$order_id,$item_id) {
		global $wpdb, $current_user;
		
		$order = new \WC_Order( $order_id );
				
		$payment_method = $order->get_payment_method();
		$order_status = $order->get_status();
		
		if ( $woopostdata && ! isset ( $woopostdata['processed'] ) ) {
			
			if($order_status === 'on-hold'){
				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'appointment_id' );
				
				update_post_meta($appointment_id,'deposit_woo_payment_status','on-hold');
				
			}elseif($order_status === 'completed' || $order_status === 'processing'){
				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'appointment_id' );
			
				$due_amount = get_post_meta($appointment_id,'due_amount',true);
				$deposit_amount = get_post_meta($appointment_id,'deposit_amount',true);
				
				$total_deposit_amount = floatval($deposit_amount) + floatval($due_amount);
				
				update_post_meta($appointment_id,'deposit_payment_status','full_payment');
				update_post_meta($appointment_id,'due_amount',0);
				update_post_meta($appointment_id,'deposit_amount',$total_deposit_amount);
				update_post_meta($appointment_id,'booking_amount_status','paid');
				
				update_post_meta($appointment_id,'deposit_woo_payment_status',$order_status);
				
				Appointy_Send_Email_Notification_Helper::send_after_received_fullpayment_email_notifications($appointment_id,$due_amount,$deposit_amount,$total_deposit_amount);
			}
		} else {
			$existinginvoice = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));		
			
			if(($order_status === 'completed' || $order_status === 'processing') && $woopostdata && ! isset ( $woopostdata['completed'] ) && ! isset ( $woopostdata['cancelled'] )) {
				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'appointment_id' );
			
				$due_amount = get_post_meta($appointment_id,'due_amount',true);
				$deposit_amount = get_post_meta($appointment_id,'deposit_amount',true);
				
				$total_deposit_amount = floatval($deposit_amount) + floatval($due_amount);
				
				update_post_meta($appointment_id,'deposit_payment_status','full_payment');
				update_post_meta($appointment_id,'due_amount',0);
				update_post_meta($appointment_id,'deposit_amount',$total_deposit_amount);
				update_post_meta($appointment_id,'booking_amount_status','paid');
				
				update_post_meta($appointment_id,'deposit_woo_payment_status',$order_status);
				
				Appointy_Send_Email_Notification_Helper::send_after_received_fullpayment_email_notifications($appointment_id,$due_amount,$deposit_amount,$total_deposit_amount);
			}	
		}
	}
	
	/**
	 * Pay for repeat service payment
	 *
	 * @return string
	 */
	public static function update_repeat_service_payment($woopostdata,$order_id,$item_id) {
		global $wpdb, $current_user;
		
		$order = new \WC_Order( $order_id );
				
		$payment_method = $order->get_payment_method();
		$order_status = $order->get_status();
		
		if ( $woopostdata && ! isset ( $woopostdata['processed'] ) ) {
			
			if($order_status === 'on-hold'){
				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'appointment_id' );
				$repeat_service_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'repeat_service_id' );
				
				$repeat_schedule['payment_status']	= 'on-hold';

				$where = array(
					'id' => $repeat_service_id,
				);
		
				$wpdb->update($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($repeat_schedule),$where);
				
				$repeat_schedule['repeat_service_payment']	= 'on-hold';

				$where = array(
					'repeat_service_id' => $repeat_service_id,
				);
		
				$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($repeat_schedule),$where);
				
			}elseif($order_status === 'completed' || $order_status === 'processing'){
				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'appointment_id' );
				$repeat_service_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'repeat_service_id' );
				
				$repeat_schedule['payment_status']	= 'paid';

				$where = array(
					'id' => $repeat_service_id,
				);
		
				$wpdb->update($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($repeat_schedule),$where);
				
				$repeat_schedule['repeat_service_payment']	= 'paid';

				$where = array(
					'repeat_service_id' => $repeat_service_id,
				);
		
				$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($repeat_schedule),$where);
				
				Appointy_Send_Email_Notification_Helper::send_after_received_repeatpayment_email_notifications($appointment_id,$repeat_service_id);
			}
		} else {
			$existinginvoice = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));		
			
			if(($order_status === 'completed' || $order_status === 'processing') && $woopostdata && ! isset ( $woopostdata['completed'] ) && ! isset ( $woopostdata['cancelled'] )) {
				$appointment_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'appointment_id' );
				$repeat_service_id = Appointy_Router_Helper::get_sanitize_data( $woopostdata, 'repeat_service_id' );
				
				$repeat_schedule['payment_status']	= 'paid';

				$where = array(
					'id' => $repeat_service_id,
				);
		
				$wpdb->update($wpdb->prefix.'appointy_repeat_schedule',wp_unslash($repeat_schedule),$where);
				
				$repeat_schedule['repeat_service_payment']	= 'paid';

				$where = array(
					'repeat_service_id' => $repeat_service_id,
				);
		
				$wpdb->update($wpdb->prefix.'appointy_booked_services',wp_unslash($repeat_schedule),$where);
				
				Appointy_Send_Email_Notification_Helper::send_after_received_repeatpayment_email_notifications($appointment_id,$repeat_service_id);
			}	
		}
	}
	
	/**
	 * Is repeat appointment
	 *
	 * @return array
	 */
	public static function get_repeat_service_payment_status($repeat_service_id = 0) {
		global $wpdb;
		
		$row = $wpdb->get_row($wpdb->prepare('SELECT `payment_status` FROM `'.$wpdb->prefix.'appointy_repeat_schedule` WHERE `id` = %d',$repeat_service_id));
		
		if(!empty($row)) {
			$payment_status = Appointy_Router_Helper::get_sanitize_data( $row, 'payment_status' );
			
			return $payment_status;
		}else{
			return '';
		}
	}
	
	/**
	 * Get status class
	 *
	 * @return string
	 */
	public static function get_status_class($status = '') {
		global $wpdb;
		
		switch (strtolower($status)) {

			case 'pending':

				$returnstr = 'ap-pending';

				break;

			case 'on-hold':

				$returnstr = 'ap-on-hold';

				break;

			case 'default':

				$returnstr = 'ap-pending';

				break;

			case 'paid':

				$returnstr = 'ap-paid';

				break;

			default:

				$returnstr = 'ap-pending';

				break;												

		}
		
		return $returnstr;
	}
	
	/**
	 * Get service price tax
	 *
	 * @return array
	 */
	public static function get_service_price_tax($appointment_id = 0,$service_price = 0) {
		global $wpdb;
		
		$totalTaxAmount = 0;
		$taxdata = get_post_meta($appointment_id,'taxdata',true);
		if(!empty($taxdata)) {
			foreach($taxdata as $taxinfo){
				$tax_name = Appointy_Router_Helper::get_sanitize_data($taxinfo,'tax_name');
				$tax_value = Appointy_Router_Helper::get_sanitize_data($taxinfo,'tax');
				$tax_type = Appointy_Router_Helper::get_sanitize_data($taxinfo,'tax_type');
				$tax_name = Appointy_Router_Helper::get_sanitize_data($taxinfo,'tax_name');
				
				$taxAmount = 0;
				$displayTaxValue = '';
				
				if($tax_type === 'fixed') {
					if($tax_value > 0){
						$taxAmount = floatval($tax_value);
					}else{
						$taxAmount = 0;
					}
				} else if($tax_type === 'percent') {
					if($tax_value > 0){
						$taxAmount = (floatval($tax_value)/100) * floatval($service_price);
					}else{
						$taxAmount = 0;	
					}
				}
			}
			
			$totalTaxAmount = $totalTaxAmount + $taxAmount;
		}
		
		return $totalTaxAmount;
	}
	
	/**
	 * Get appointment extra services
	 *
	 * @return array
	 */
	public static function get_appointment_extra_services($appointment_id = 0,$service_id = 0) {
		global $wpdb;
		
		$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`extra_service_id`,`extra_service_name`,`extra_service_price`,`hours`,`minutes`,`display_service_period`,`service_period` FROM `'.$wpdb->prefix.'appointy_extra_services` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
		
		return $results;
	}
	
	/**
	 * Get extra service duration
	 *
	 * @return array
	 */
	public static function get_extra_service_duration($appointment_id = 0,$service_id = 0) {
		global $wpdb;
		
		$results = $wpdb->get_results($wpdb->prepare('SELECT `service_period` FROM `'.$wpdb->prefix.'appointy_extra_services` WHERE `appointment_id` = %d AND `service_id` = %d',$appointment_id,$service_id));
		
		$total_duration = 0;
		if(!empty($results)) {
			foreach($results as $extra_service){
				$service_period	 = Appointy_Router_Helper::get_sanitize_data($extra_service,'service_period');
				
				$total_duration = intval($total_duration) + intval($service_period);
			}
		}
		
		return $total_duration;
	}
	
	/**
	 * Get extra service duration
	 *
	 * @return array
	 */
	public static function get_extra_service_total_amount($appointment_id = 0) {
		global $wpdb;
		
		$results = $wpdb->get_results($wpdb->prepare('SELECT `extra_service_price` FROM `'.$wpdb->prefix.'appointy_extra_services` WHERE `appointment_id` = %d',$appointment_id));
		
		$total_amount = 0;
		if(!empty($results)) {
			foreach($results as $extra_service){
				$service_price	 = Appointy_Router_Helper::get_sanitize_data($extra_service,'extra_service_price');
				
				$total_amount = intval($total_amount) + intval($service_price);
			}
		}
		
		return $total_amount;
	}
	
}

new Appointy_Appointments_Helper();