<?php 
class Appointy_Form_Helper {

	/**
	 * Render form structure
	 *
	 * @return void
	 */
	public static function get_form_structure( $key = '', $field = array(), $social_color_class = '' ) {
	
	$field_type = ( isset($field['type']) ) ? trim( $field['type'] ) : '';
	$columwidth = ( isset($field['colum-width']) ) ? trim( $field['colum-width'] ) : 'col-sm-6';
	$required = ( isset($field['required']) ) ? $field['required'] : false;
	?>
	<?php
	if( $field_type === 'hidden' ) {
		Appointy_Template_Loader::get_template_part( 'form-fields/' . $field['type'] . '-field', array( 'key' => $key, 'field' => $field ) );
	} else {
	?>
    <div class="<?php echo esc_attr( $columwidth ); ?>">
        <div class="form-group <?php echo ( $field_type === 'radio' || $field_type === 'checkbox' || $field_type === 'checkboxlist' ) ? 'form-inline' : ''; ?>">
            
			<?php if( $field_type === 'checkboxlist' ) {
				if( !empty($field['options']) ) {
				?>
				<label><?php echo esc_html( $field['label'] ); ?> <?php echo ($required) ? '*' : ''; ?></label>
				<?php
				}
			}else{ ?>
				<?php if( !empty($field['label']) ) { ?>
				<label><?php echo esc_html( $field['label'] ); ?> <?php echo ($required) ? '*' : ''; ?></label>
				<?php 
				}
			} 
			
			if( $field_type === 'radio' || $field_type === 'checkbox' || $field_type === 'checkboxlist' ) { 
				Appointy_Template_Loader::get_template_part( 'form-fields/' . $field['type'] . '-field', array( 'key' => $key, 'field' => $field ) );
			} elseif( $field_type === 'password' ) {
			$iconclass_outer = ( !empty($field['icon']) )? 'aon-inputicon-box' : 'input-group'; 
			$fieldid = ( isset( $field['id'] ) ) ? esc_attr( $field['id'] ) : '';
			?>
			<div class="<?php echo sanitize_html_class($iconclass_outer); ?> appointy-pass-wrap"> 
                <?php Appointy_Template_Loader::get_template_part( 'form-fields/' . $field['type'] . '-field', array( 'key' => $key, 'field' => $field ) ); ?>
                <?php if( !empty($field['icon']) ) { ?>
				<i class="aon-input-icon <?php echo sanitize_html_class($social_color_class); ?> <?php echo ( isset($field['icon']) ) ? esc_attr( $field['icon'] ) : ''; ?>" <?php echo ( isset($field['iconcolor']) ) ? 'style="color:'.esc_attr($field['iconcolor']).'"' : ''; ?>></i>
				<?php } ?>
                <a href="javascript:;" class="aon-input-icon2 showhidepass" data-fieldid="<?php echo esc_attr($fieldid); ?>"><i class="feather-eye"></i></a>
            </div>
			<?php
			} else {
			$iconclass_outer = ( !empty($field['icon']) )? 'aon-inputicon-box' : 'input-group'; 
			?>
            <div class="<?php echo sanitize_html_class($iconclass_outer); ?>"> 
                <?php Appointy_Template_Loader::get_template_part( 'form-fields/' . $field['type'] . '-field', array( 'key' => $key, 'field' => $field ) ); ?>
                <?php if( !empty($field['icon']) ) { ?>
				<i class="aon-input-icon <?php echo sanitize_html_class($social_color_class); ?> <?php echo ( isset($field['icon']) ) ? esc_attr( $field['icon'] ) : ''; ?>" <?php echo ( isset($field['iconcolor']) ) ? 'style="color:'.esc_attr($field['iconcolor']).'"' : ''; ?>></i>
				<?php } ?>
            </div>
			<?php } ?>
        </div>
    </div>
	<?php
	}

	}
	
	/**
	 * Get form fields
	 *
	 * @return void
	 */
	public static function get_fields( $fields ) {
		uasort( $fields, array('self', 'sort_by_priority') );
		return $fields;
	}
	
	/**
	 * Sort form fields by priority
	 *
	 * @return void
	 */
	public static function sort_by_priority( $a, $b ) {
		$aa = isset( $a['priority'] ) ? $a['priority'] : '';
		$bb = isset( $b['priority'] ) ? $b['priority'] : '';
		if ( $aa === $bb ) {
			return 0;
		}
		return ( $aa < $bb ) ? -1 : 1;
	}
}