<?php 
class Appointy_Invoice_Helper {

	/**
     * Initialize the class
     *
     * @since     1.0.0
     */
    public function __construct() {
		add_action('wp_ajax_appointy_save_invoice', array($this, 'save_invoice'));
		add_action('wp_ajax_appointy_get_customer_info', array($this, 'get_customer_info'));
		add_action('wp_ajax_appointy_get_invoice', array($this, 'get_invoice'));
		add_action('wp_ajax_appointy_view_invoice', array($this, 'view_invoice'));
		add_action('wp_ajax_appointy_delete_invoice', array($this, 'delete_invoice'));
    }
	
	/**
	 * Delete invoice
	 *
	 * @return array
	 */
	public static function delete_invoice() {
		global $wpdb;
		
		$data_ids = Appointy_Router_Helper::get_request_data( $_POST, 'data_ids' );
		
		$data_id_array = explode(",", $data_ids); 

		if(!empty($data_id_array)) {
			foreach($data_id_array as $invoiceid) {
				$force_delete = true;
				wp_delete_post( $invoiceid, $force_delete );
			}
		}
		
		wp_send_json_success();
		die();
	}
	
	/**
	 * Get view invoice
	 *
	 * @return html
	 */
	public static function view_invoice() {
		global $wpdb,$current_user;
		ob_start();
		
		$invoiceid = Appointy_Router_Helper::get_request_data( $_POST, 'invoiceid' );
		$invoice_object = get_post( $invoiceid );
		?>
        <div class="sf-myaccount-heading ap-invoice-wrapper">
			<div class="sf-myaccount-heading-right">
				<a href="javascript:;" class="btn site-button backtoinvoicetable"><i class="fa fa-chevron-circle-left"></i> <?php esc_html_e('Back','appointy'); ?></a>
            </div>
		</div>
        
		<div class="panel panel-default">
							
			<div class="panel-body aon-panel-body p-lr0 p-tb30">
				
			<div id="view-invoice-row">
				<div class="row">
					<div class="col-md-7">
						<div class="sf-invoice-text"><?php esc_html_e( 'Invoice','appointy' ); ?></div>
						<div class="sf-invoice-compay-info">
							<ul>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_name' ) != '') : ?>
								<li><i class="feather-user"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_name' ); ?></li>
								<?php endif; ?>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_email' ) != '') : ?>
								<li><i class="feather-mail"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_email' ); ?></li>
								<?php endif; ?>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_phone' ) != '') : ?>
								<li><i class="feather-phone"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_phone' ); ?></li>
								<?php endif; ?>
								<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_address' ) != '') : ?>
								<li><i class="feather-map-pin"></i> <?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_from_address' ); ?></li>
								<?php endif; ?>
							</ul>
						</div>
					</div>
					<div class="col-md-5">
						<div class="sf-invoice-logo"><?php echo get_bloginfo('name'); ?></div>
					</div>
					<?php if(Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_extra_details' ) != '') : ?>
					<div class="col-md-12">
						<div class="sf-invoice-compay-info"><?php echo Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_extra_details' ); ?></div>
					</div>
					<?php endif; ?>
				</div>
				
				<div class="row">
					<div class="p-tb30 m-lr15 clearfix bg-invoice invoice-top-bg">
						<div class="row invoice-top-row">
						<div class="col-md-6">
							<div class="p-lr15">
							   <ul class="invoice-top-left">
								<li><strong><?php esc_html_e( 'Issued Date','appointy' ); ?>:</strong><span> <?php echo Appointy_Misc_Helper::get_date_format(get_the_date( '', $invoiceid )); ?></span></li>
								<li><strong><?php esc_html_e( 'Order','appointy' ); ?>:</strong><span> #<?php echo get_post_meta($invoiceid,'_invoice_id',true); ?></span></li>
								<li><strong><?php esc_html_e( 'Due Date','appointy' ); ?>:</strong><span> <?php echo Appointy_Misc_Helper::get_date_format(get_post_meta($invoiceid,'_due_date',true)); ?></span></li>
								<li class="invoice-total"><strong><?php esc_html_e( 'Total','appointy' ); ?></strong><span> <?php echo Appointy_Misc_Helper::get_price_format(get_post_meta( $invoiceid,'grand_total',true )); ?></span></li>
							</ul>
							</div> 
						</div>
						<div class="col-md-6">
							<div class="p-lr15">
							   <h6><?php esc_html_e( 'Bill To','appointy' ); ?></h6>
								<ul class="list-unstyled invoice-user-info">
									<li><i class="feather-user"></i> <?php echo get_post_meta($invoiceid,'_first_name',true).' '.get_post_meta($invoiceid,'_last_name',true); ?></li>
									<li><i class="feather-user"></i> <?php echo get_post_meta($invoiceid,'_email',true); ?></li>
                                    <li><i class="feather-user"></i> <?php echo get_post_meta($invoiceid,'_phone',true); ?></li>
								</ul>
							</div> 
						</div>
						</div>
						<div class="col-md-12">
							<div class="p-lr15">
							   <?php echo apply_filters('the_content', $invoice_object->post_content); ?>
							</div> 
						</div>
					</div>
				</div>
				<?php echo Appointy_Invoice_Helper::get_invoice_items($invoiceid); ?>                       
			</div>
			
			<div class="p-tb30 m-lr15 clearfix invoice-footer">
				<?php
				$invoicefooterlefttext = Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_footer_lefttext' );
				$invoicecopyrighttext = Appointy_Misc_Helper::get_settings( 'invoice_settings', 'invoice_footer_righttext' );
				?>
				 <h5><?php echo wp_kses($invoicefooterlefttext,Appointy_Misc_Helper::get_allowed_tags()); ?></h5>
				 <span><?php echo wp_kses($invoicecopyrighttext,Appointy_Misc_Helper::get_allowed_tags()); ?></span>
			</div>
							
			</div>
		</div>
		<?php
		$response = ob_get_clean();
		wp_send_json_success($response);
		exit;
	}
	
	/**
	 * Get invoice datatable
	 *
	 * @return void
	 */
	public static function get_invoice() {
	    global $wpdb;

		$args = array(
			'post_status' => array( 'invoice-pending', 'invoice-paid', 'invoice-payment-hold', 'invoice-payment-cancelled' ),
			'post_type' => 'appointy_invoice',
			'posts_per_page' => -1,
		);
		$the_query = new \WP_Query( $args );
		$data = array();
		if ( $the_query->have_posts() ) 
		{
			$nestedData = array(); 
			while ( $the_query->have_posts() ) : $the_query->the_post();
				$post_id = get_the_id();		
				
				$nestedData['postid'] = $post_id;
				$nestedData['delete'] = '<div class="checkbox sf-radio-checkbox">
											<input type="checkbox" id="invoice-'.esc_attr($post_id).'" value="'.esc_attr($post_id).'" class="delete_row delete_invoice">
											<label for="invoice-'.esc_attr($post_id).'"></label>
										</div>';
				$nestedData['invoiceid'] = '#'.get_post_meta($post_id,'_invoice_id',true);
				$nestedData['invoicetitle'] = get_the_title();
				$nestedData['duedate'] = get_post_meta($post_id,'due_date',true);
				$nestedData['amount'] = Appointy_Misc_Helper::get_price_format(get_post_meta($post_id,'grand_total',true));
				$nestedData['customername'] = get_post_meta($post_id,'_first_name',true).' '.get_post_meta($post_id,'_last_name',true);
				$nestedData['customeremail'] = get_post_meta($post_id,'_email',true);
				$nestedData['status'] = Appointy_Appointments_Helper::get_post_status_by_slug( Appointy_Appointments_Helper::get_post_status( $post_id ) );
				
				if( get_post_status($post_id) === 'invoice-paid' || get_post_status($post_id) === 'invoice-payment-hold' ) {
					$actions = '<div class="dropdown action-dropdown dropdown-left">
								  <button class="action-button btn btn-primary dropdown-toggle" type="button" data-bs-toggle="dropdown"><i class="fa fa-ellipsis-v"></i></button>
								  <ul class="dropdown-menu">
									<li><a href="javascript:;" class="dropdown-item viewinvoice" data-invoiceid="'.esc_attr($post_id).'"><i class="feather-eye"></i> '.esc_html__( 'View','appointy' ).'</a></li>
									<li><a href="javascript:;" class="dropdown-item"><i class="fa fa-close"></i> '.esc_html__( 'Close','appointy' ).'</a></li>
								  </ul>
								</div>';
				} else {
					$params['invoiceid'] = $post_id;
					$editinvoiceurl = Appointy_Router_Helper::generate_link( ['invoice', 'add'],$params );
					$actions = '<div class="dropdown action-dropdown dropdown-left">
								  <button class="action-button btn btn-primary dropdown-toggle" type="button" data-bs-toggle="dropdown"><i class="fa fa-ellipsis-v"></i></button>
								  <ul class="dropdown-menu">
									<li><a href="javascript:;" class="dropdown-item viewinvoice" data-invoiceid="'.esc_attr($post_id).'"><i class="feather-eye"></i> '.esc_html__( 'View','appointy' ).'</a></li>
									<li><a class="dropdown-item" href="'.esc_url($editinvoiceurl).'"><i class="fa fa-pencil"></i> '.esc_html__( 'Edit','appointy' ).'</a></li>
									<li><a class="dropdown-item" href="javascript:;"><i class="fa fa-close"></i> '.esc_html__( 'Close','appointy' ).'</a></li>
								  </ul>
								</div>';
				}
				
				$nestedData['action'] = $actions;
				
				$data[] = $nestedData;
			endwhile;
			wp_reset_postdata();
		}
		
		$json_data = array( 'data' => $data );
		
		echo json_encode( $json_data );
		die();
	}
	
	/**
	 * Save invoice
	 *
	 * @return array
	 */
	public static function save_invoice( ) {
		global $wpdb,$invoicedata;
		extract($_POST);
		
		if (!isset( $_POST['secure_save_invoice'] )  || ! wp_verify_nonce( $_POST['secure_save_invoice'], 'ajax-save-invoice-nonce'))	{
			$response = array('msg' => esc_html__('Sorry you are not authorized to perform this action','appointy'));
			wp_send_json_error($response);
			exit;
		}
		
		$invoiceid = Appointy_Router_Helper::get_sanitize_data( $_POST, 'invoiceid' );
		
		if( !empty($invoiceid) && $invoiceid > 0 ) {
			$meta_fields = array();
			$invoicedata['subtotal'] = 0;
			$invoicedata['total_tax'] = 0;
			$invoicedata['total_discount'] = 0;
			$invoicedata['grand_total'] = 0;
			//Add invoice items
			if(!empty($cl_invoice_meta_item[ 'invoice_items' ])){
				foreach ( $cl_invoice_meta_item[ 'invoice_items' ] as $invoice_item ) {
				  self::add_invoice_item( array(
					'title' => $invoice_item[ 'title' ],
					'description' => $invoice_item[ 'description' ],
					'unit_price' => $invoice_item[ 'unit_price' ],
					'item_total' => $invoice_item[ 'item_total' ],
					'predefined_service' => $invoice_item[ 'predefined_service' ],
				  ) );
				}
			}
			// Add tax/discount
			if(!empty($cl_invoice[ 'meta' ])){
				foreach ( $cl_invoice[ 'meta' ] as $arraykey => $arrayvalue ) {
					if($arraykey === 'tax'){
						self::add_invoice_tax( array(
							'name' => $arrayvalue[ 'name' ],
							'type' => $arrayvalue[ 'type' ],
							'amount' => $arrayvalue[ 'amount' ],
						  ) );
					 }elseif($arraykey === 'discount'){
						self::add_invoice_discount( array(
							'name' => $arrayvalue[ 'name' ],
							'type' => $arrayvalue[ 'type' ],
							'amount' => $arrayvalue[ 'amount' ],
						  ) );
					 } 
				}
			}
			
			$invoicedata['grand_total'] = ($invoicedata['subtotal'] + $invoicedata['total_tax']) - $invoicedata['total_discount'];
			$customerid = $cl_customer['user_data']['user_email'];
			$customerinfo = get_user_by('id', $customerid);
			$invoicedata['user_email'] = $customerinfo->user_email;
			
			$meta_fields['user_email'] = $invoicedata['user_email'];
			$meta_fields['invoice_items'] = $invoicedata['invoice_items'];
			$meta_fields['subtotal'] = $invoicedata['subtotal'];
			$meta_fields['tax'] = (isset($invoicedata['tax'])) ? $invoicedata['tax'] : '';
			$meta_fields['total_tax'] = $invoicedata['total_tax'];
			$meta_fields['discount'] = (isset($invoicedata['discount'])) ? $invoicedata['discount'] : '';
			$meta_fields['total_discount'] = $invoicedata['total_discount'];
			$meta_fields['grand_total'] = $invoicedata['grand_total'];
			
			$invoice_post = array(
				'ID'           => $invoiceid,
				'post_title' => $invoice_title,
				'post_status' => $status,
				'post_type' => 'appointy_invoice',
				'post_content' => $invoice_description,
				'meta_input'   => $meta_fields
			);
			$postid = wp_update_post( $invoice_post );
			
			self::update_invoice_meta_fields($_POST,$postid);
			
			$redirecturl = add_query_arg( array( 'page' => 'appointment','menu_item' => 'invoice__index' ), admin_url( 'admin.php' ) );
		
			$response = array( 'msg' => esc_html__('Invoice updated successfully.', 'appointy'), 'redirect' => $redirecturl );
			wp_send_json_success($response);
			die();
				
		} else {
			
			$meta_fields = array();
		
			$invoicedata['subtotal'] = 0;
			$invoicedata['total_tax'] = 0;
			$invoicedata['total_discount'] = 0;
			$invoicedata['grand_total'] = 0;
			
			//Add invoice items
			if(!empty($cl_invoice_meta_item[ 'invoice_items' ])) {
				foreach ( $cl_invoice_meta_item[ 'invoice_items' ] as $invoice_item ) {
				  self::add_invoice_item( array(
					'title' => $invoice_item[ 'title' ],
					'description' => $invoice_item[ 'description' ],
					'unit_price' => $invoice_item[ 'unit_price' ],
					'item_total' => $invoice_item[ 'item_total' ],
					'predefined_service' => $invoice_item[ 'predefined_service' ],
				  ) );
				}
			}
			
			// Add tax/discount
			if(!empty($cl_invoice[ 'meta' ])) {
				foreach ( $cl_invoice[ 'meta' ] as $arraykey => $arrayvalue ) {
					if($arraykey === 'tax'){
						self::add_invoice_tax( array(
							'name' => $arrayvalue[ 'name' ],
							'type' => $arrayvalue[ 'type' ],
							'amount' => $arrayvalue[ 'amount' ],
						  ) );
					 }elseif($arraykey === 'discount'){
						self::add_invoice_discount( array(
							'name' => $arrayvalue[ 'name' ],
							'type' => $arrayvalue[ 'type' ],
							'amount' => $arrayvalue[ 'amount' ],
						  ) );
					} 
				}
			}
			
			$invoicedata['grand_total'] = ($invoicedata['subtotal'] + $invoicedata['total_tax']) - $invoicedata['total_discount'];
			$customerid = $cl_customer['user_data']['user_email'];
			$customerinfo = get_user_by('id', $customerid);
			$invoicedata['user_email'] = $customerinfo->user_email;
			
			$meta_fields['user_email'] = $invoicedata['user_email'];
			$meta_fields['invoice_items'] = $invoicedata['invoice_items'];
			$meta_fields['subtotal'] = $invoicedata['subtotal'];
			$meta_fields['tax'] = (isset($invoicedata['tax'])) ? $invoicedata['tax'] : '';
			$meta_fields['total_tax'] = $invoicedata['total_tax'];
			$meta_fields['discount'] = (isset($invoicedata['discount'])) ? $invoicedata['discount'] : '';
			$meta_fields['total_discount'] = $invoicedata['total_discount'];
			$meta_fields['grand_total'] = $invoicedata['grand_total'];
	
			$invoice_post = array(
				'post_title' => $invoice_title,
				'post_status' => $status,
				'post_type' => 'appointy_invoice',
				'post_content' => $invoice_description,
				'meta_input'   => $meta_fields
			);
			$postid = wp_insert_post( $invoice_post );
			
			self::update_invoice_meta_fields($_POST,$postid);
			
			Appointy_Send_Email_Notification_Helper::send_invoice_generate_email_notifications($postid);
			
			$redirecturl = add_query_arg( array( 'page' => 'appointment','menu_item' => 'invoice__index' ), admin_url( 'admin.php' ) );
		
			$response = array( 'msg' => esc_html__('Invoice created successfully.', 'appointy'), 'redirect' => $redirecturl );
			wp_send_json_success($response);
			die();
		
		}
	}
	
	/**
	 * Add invoice tax in meta data
	 *
	 * @return array
	 */
	public static function add_invoice_tax( $args = array() ) {
		global $invoicedata;
		extract(wp_parse_args($args, array(
			'name' => '',
			'type' => '',
			'amount' => '',
		)));
		
		
		if (empty ($amount)){
			return false;
		}	
		
		$invoicedata['tax']['name'] = $name;
		$invoicedata['tax']['type'] = $type;
		$invoicedata['tax']['amount'] = $amount;
		
		if ( $type === 'percent' ) {
			$invoicedata['total_tax'] = $invoicedata['subtotal'] * ($amount / 100);
		} else {
			$invoicedata['total_tax'] = $amount;
		}
	}
	
	/**
	 * Add invoice discount in meta data
	 *
	 * @return array
	 */
	public static function add_invoice_discount( $args = array() ) {
		global $invoicedata;
		extract(wp_parse_args($args, array(
			'name' => '',
			'type' => '',
			'amount' => '',
		)));
		
		if (empty ($amount)){
			return false;
		}	
		
		$invoicedata['discount']['name'] = $name;
		$invoicedata['discount']['type'] = $type;
		$invoicedata['discount']['amount'] = $amount;
		
		if ( $type === 'percent' ) {
			$invoicedata['total_discount'] = (($invoicedata['subtotal'] * $amount) / 100);
		} else {
			$invoicedata['total_discount'] = $amount;
		}
	}
	
	/**
	 * Update invoice meta fields
	 *
	 * @return array
	 */
	public static function update_invoice_meta_fields( $values = array(), $postid = 0 ) {
		$invoice_fields = self::invoice_fields();
		
		if(!empty($invoice_fields)) {
			foreach ( $invoice_fields as $key => $field ) {
				$values[ $key ] = ( isset($values[ $key ]) ) ? $values[ $key ] : '';
				
				if( isset($values[ $key ]) ) {
					if( 'invoice_title' !== $key ) {
						update_post_meta( $postid, '_' . $key, $values[ $key ] );
					}
				}
			}
		}
		
		$invoice_customer_fields = self::invoice_customer_fields();
        
		if( !empty($invoice_customer_fields) ) {
			foreach( $invoice_customer_fields as $key => $field ) {
				$values[ $key ] = ( isset($values[ $key ]) ) ? $values[ $key ] : '';
				if( isset($values[ $key ]) ) {
					update_post_meta( $postid, '_' . $key, $values[ $key ] );
				}
			}
		}
	}
	
	/**
	 * Add invoice item
	 *
	 * @return array
	 */
	public static function add_invoice_item( $args = array() ) {
		global $invoicedata;
		extract(wp_parse_args($args, array(
			'title' => '',
			'description' => '',
			'unit_price' => '',
			'item_total' => '',
			'predefined_service' => '',
		)));
		
		if (empty ($title) || empty ($unit_price)) {
			return false;
		}	
		
		if ( !empty( $invoicedata['invoice_items'] ) ) {
		  $totalitems = count($invoicedata['invoice_items']) + 1;
		} else {
		  $totalitems = 1;
		}
		
		$invoicedata['invoice_items'][$totalitems]['title'] = $title;
		$invoicedata['invoice_items'][$totalitems]['description'] = $description;
		$invoicedata['invoice_items'][$totalitems]['unit_price'] = $unit_price;
		$invoicedata['invoice_items'][$totalitems]['item_total'] = $item_total;
		$invoicedata['invoice_items'][$totalitems]['predefined_service'] = $predefined_service;
		
		$invoicedata['subtotal'] += $item_total;
	}
	
	/**
	 * Get invoice customer info
	 *
	 * @return array
	 */
	public static function get_customer_info() {
	
		$customer_user_id = Appointy_Router_Helper::get_request_data( $_POST, 'customerid' );
		
		$customeremail = Appointy_Misc_Helper::get_email_by_user_id($customer_user_id);
		
		$response = array(
			'first_name' => get_user_meta( $customer_user_id,'first_name',true ),
			'last_name' => get_user_meta( $customer_user_id,'last_name',true ),
			'phone' => get_user_meta( $customer_user_id,'phone',true ),
			'country_code' => get_user_meta( $customer_user_id,'country_code',true ),
			'email' => $customeremail
		);
		wp_send_json_success($response);
		die();
	}
	
	public static function invoice_fields() {
		
		$fields = apply_filters( 'appointy_invoice_form_fields', array(
			'invoice_title' => array(
				'label'       => esc_html__( 'Invoice Title', 'appointy' ),
				'type'        => 'text',
				'icon'        => 'fa fa-user',
				'colum-width' => 'col-md-12',
				'required'    => true,
				'validation_message' => esc_html__( 'Please enter invoice title', 'appointy' ),
				'placeholder' => esc_html__( 'Invoice Title', 'appointy' ),
				'priority'    => 1
			),
			'due_date' => array(
				'label'       => esc_html__( 'Due Date', 'appointy' ),
				'type'        => 'date',
				'icon'        => 'fa fa-calendar',
				'colum-width' => 'col-md-6',
				'required'    => true,
				'validation_message' => esc_html__( 'Please enter date', 'appointy' ),
				'placeholder' => esc_html__( 'Due Date', 'appointy' ),
				'priority'    => 2
			),
			'invoice_id' => array(
				'label'       => esc_html__( 'Invoice ID', 'appointy' ),
				'type'        => 'text',
				'icon'        => 'fa fa-file-text-o',
				'colum-width' => 'col-md-6',
				'required'    => true,
				'readonly'    => true,
				'value'    	  => self::get_next_invoice_id(),
				'validation_message' => esc_html__( 'Please enter invoice id', 'appointy' ),
				'placeholder' => esc_html__( 'Invoice ID', 'appointy' ),
				'priority'    => 3
			),
			'status' => array(
				'label'       => esc_html__( 'Status', 'appointy' ),
				'type'        => 'select',
				'default'     => '',
				'colum-width' => 'col-md-6',
				'required'    => true,
				'icon'        => 'fa fa-question-circle',
				'placeholder' => esc_html__( 'Please select status', 'appointy' ),
				'priority'    => 4,
				'options' => array(
					'invoice-pending' => esc_html__( 'Pending', 'appointy' ),
					'invoice-paid'  => esc_html__( 'Paid', 'appointy' )
				)
			)
		) );

		return Appointy_Form_Helper::get_fields( $fields );	
	}
	
	public static function invoice_customer_fields() {
		
		$fields = apply_filters( 'appointy_invoice_customer_form_fields', array(
			'first_name' => array(
				'label'       => esc_html__( 'First Name', 'appointy' ),
				'type'        => 'text',
				'icon'        => 'feather-user',
				'colum-width' => 'col-md-6',
				'required'    => true,
				'validation_message' => esc_html__( 'Please enter first name', 'appointy' ),
				'placeholder' => esc_html__( 'First Name', 'appointy' ),
				'priority'    => 1
			),
			'last_name' => array(
				'label'       => esc_html__( 'Last Name', 'appointy' ),
				'type'        => 'text',
				'icon'        => 'feather-user',
				'colum-width' => 'col-md-6',
				'required'    => true,
				'validation_message' => esc_html__( 'Please enter last name', 'appointy' ),
				'placeholder' => esc_html__( 'Last Name', 'appointy' ),
				'priority'    => 2
			),
			'email' => array(
				'label'       => esc_html__( 'Email', 'appointy' ),
				'type'        => 'email',
				'icon'        => 'feather-mail',
				'colum-width' => 'col-md-4',
				'required'    => true,
				'validation_message' => esc_html__( 'Please enter email', 'appointy' ),
				'placeholder' => esc_html__( 'Email', 'appointy' ),
				'priority'    => 3
			),
			'country_code' => array(
				'label'       => esc_html__( 'Country Code', 'appointy' ),
				'type'        => 'select',
				'icon'        => 'feather-map-pin',
				'colum-width' => 'col-lg-4',
				'required'    => true,
				'priority'    => 4,
				'options' 	  => Appointy_Sms_Helper::get_country_code_dropdown(),
			),
			'phone' => array(
				'label'       => esc_html__( 'Phone', 'appointy' ),
				'type'        => 'text',
				'icon'        => 'feather-phone',
				'colum-width' => 'col-md-4',
				'required'    => true,
				'validation_message' => esc_html__( 'Please enter phone', 'appointy' ),
				'placeholder' => esc_html__( 'Phone', 'appointy' ),
				'priority'    => 5
			)
		) );

		return Appointy_Form_Helper::get_fields( $fields );	
	}
	
	/**
	 * Get next invoice id
	 *
	 * @return int
	 */
	public static function get_next_invoice_id() {
		global $wpdb;
		
		$post_type = 'appointy_invoice';
		
		$row = $wpdb->get_row( $wpdb->prepare( 'SELECT `ID` FROM `'.$wpdb->prefix.'posts` WHERE `post_type` = %s order by `ID` desc limit 0,1',$post_type ) );
		
		if( !empty($row) ) {
			$post_id = $row->ID;
			
			$invoice_id = get_post_meta($post_id,'_invoice_id',true);
			
			$invoice_id = intval($invoice_id) + 1;
		} else {
			$invoice_id = 1000;
		}
		
		return $invoice_id;
	}
	
	/**
	 * Get invoice items
	 *
	 * @return int
	 */
	public static function get_invoice_items($postid = 0) {
		$html = '';
		
		$invoice_items = get_post_meta( $postid,'invoice_items',true );
		
		if(!empty($invoice_items)){
			$html = '<div class="table-responsive">          
				  <table class="aon-table table invoice-itemn-table" style="width:100%;">
					<thead>
					  <tr>
						<th>'.esc_html__( 'Item', 'appointy' ).'</th>
						<th>'.esc_html__( 'Description', 'appointy' ).'</th>
						<th>'.esc_html__( 'Duration', 'appointy' ).'</th>
						<th>'.esc_html__( 'Price', 'appointy' ).'</th>
					  </tr>
					</thead>
					<tbody>';
			foreach($invoice_items as $key => $item)
			{
				if(!empty($item))
				{
					$item_title	= ( !empty($item['title']) ) ? $item['title'] : '';
					$description	= ( !empty($item['description']) ) ? $item['description'] : '-';
					$duration	= ( !empty($item['duration']) ) ? $item['duration'].' '.$item['duration_type'] : '-';
					$item_total	= ( !empty($item['item_total']) ) ? Appointy_Misc_Helper::get_price_format($item['item_total']) : '-';
					
					$html .= '<tr>
								<td>'.$item_title.'</td>
								<td>'.$description.'</td>
								<td>'.$duration.'</td>
								<td>'.$item_total.'</td>
							  </tr>';
				}		  
						
			}
				
			$grand_total = get_post_meta( $postid,'grand_total',true );
			$total_tax = get_post_meta( $postid,'total_tax',true );
			$total_discount = get_post_meta( $postid,'total_discount',true );
			
			if($total_tax > 0)
			{
			$html .= '<tr>
							<td colspan="2"></td>
							<td><strong>'.esc_html__( 'Tax', 'appointy' ).'</strong></td>
							<td><strong>'.Appointy_Misc_Helper::get_price_format($total_tax).'</strong></td>
						</tr>';
			}
			
			if($total_discount > 0)
			{
			$html .= '<tr>
							<td colspan="2"></td>
							<td><strong>'.esc_html__( 'Discount', 'appointy' ).'</strong></td>
							<td><strong>'.Appointy_Misc_Helper::get_price_format($total_discount).'</strong></td>
						</tr>';
			}			
			
			$html .= '</tbody>';
			$html .= '<tfoot>
							<tr>
								<td colspan="2"><div class="sf-invoice-status">'.Appointy_Appointments_Helper::get_post_status_by_slug( Appointy_Appointments_Helper::get_post_status( $postid ) ).'</div></td>
								<td>'.esc_html__( 'TOTAL', 'appointy' ).'</td>
								<td>'.Appointy_Misc_Helper::get_price_format($grand_total).'</td>
							</tr>
						</tfoot>';
			
			$html .= '</table>
				  </div>';	
		}
		return $html; 	
	}
	
	/**
	 * Get invoice tax info
	 *
	 * @return string
	 */
	public static function get_invoice_tax_info( $invoiceid = 0 ) {
		$html = '';
	
		$tax = get_post_meta( $invoiceid,'tax',true );
		
		$taxname	= ( !empty($tax['name']) ) ? $tax['name'] : '';
		$taxtype	= ( !empty($tax['type']) ) ? $tax['type'] : '';
		$amount	= ( !empty($tax['amount']) ) ? $tax['amount'] : '';
		
		if($taxtype === 'percent') {
			$taxvalue = $amount.'%'.' '.$taxname;
		} elseif($taxtype === 'amount') {
			$taxvalue = sprintf(esc_html__( '%s (Fixed Amount: %s)', 'appointy' ),$taxname,Appointy_Misc_Helper::get_price_format($amount));
		} else {
			$taxvalue = '';
		}
		
		return $taxvalue;
	}
	
	/**
	 * Get invoice discount info
	 *
	 * @return string
	 */
	public static function get_invoice_discount_info( $invoiceid = 0 ) {
		$html = '';
	
		$discount = get_post_meta( $invoiceid,'discount',true );
		
		$discountname	= ( !empty($discount['name']) ) ? $discount['name'] : '';
		$discounttype	= ( !empty($discount['type']) ) ? $discount['type'] : '';
		$amount	= ( !empty($discount['amount']) ) ? $discount['amount'] : '';
		
		if($discounttype === 'percent') {
			$discountvalue = $amount.'%'.' '.$discountname;
		} elseif($discounttype === 'amount') {
			$discountvalue = sprintf(esc_html__( '%s (Fixed Amount: %s)', 'appointy' ),$discountname,Appointy_Misc_Helper::get_price_format($amount));
		} else {
			$discountvalue = '';
		}
		
		return $discountvalue;
	}
	
	/**
	 * Update invoice payment info
	 *
	 * @return string
	 */
	public static function update_invoice_payment($woopostdata,$order_id,$item_id) {
		global $wpdb, $current_user;
		
		$order = new \WC_Order( $order_id );
				
		$payment_method = $order->get_payment_method();
		$order_status = $order->get_status();
		
		if ( $woopostdata && ! isset ( $woopostdata['processed'] ) ) {
			
			if($order_status === 'on-hold'){
				$status = 'invoice-payment-hold';
			}elseif($order_status === 'completed' || $order_status === 'processing'){
				$status = 'invoice-paid';
			}
			
			$existinginvoice = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));
			
			if(!empty($existinginvoice)) {
				
				$invoiceid = Appointy_Router_Helper::get_request_data( $existinginvoice, 'post_id' );
				
				$invoice_post = array(
					'ID'           => $invoiceid,
					'post_status'  => $status
				);
				wp_update_post( $invoice_post );
				
				if($order_status === 'completed' || $order_status === 'processing') {
					Appointy_Send_Email_Notification_Helper::send_invoice_paid_email_notifications($invoiceid);
				}
				
				return;
			}
			
			$invoiceid = Appointy_Router_Helper::get_request_data( $woopostdata, 'invoiceid' );
			
			$meta_fields['order_id'] = $order_id;
			$meta_fields['payment_type'] = 'woocommerce';
			
			$invoice_post = array(
				'ID'           => $invoiceid,
				'post_status'  => $status,
				'meta_input'   => $meta_fields
			);
			wp_update_post( $invoice_post);
			
			do_action('appointy_after_paid_invoice',$invoiceid );
			
		} else {
			$existinginvoice = $wpdb->get_row($wpdb->prepare('SELECT `post_id` FROM '.$wpdb->prefix.'postmeta WHERE `meta_key` = "order_id" AND `meta_value` = %s',$order_id));		
			
			if(!empty($existinginvoice) && ($order_status === 'completed' || $order_status === 'processing') && $woopostdata && ! isset ( $woopostdata['completed'] ) && ! isset ( $woopostdata['cancelled'] )) {
				$invoiceid = Appointy_Router_Helper::get_request_data( $existinginvoice, 'post_id' );
				
				$invoice_post = array(
					'ID'           => $invoiceid,
					'post_status'  => 'invoice-paid'
				);
				wp_update_post( $invoice_post );
				
				Appointy_Send_Email_Notification_Helper::send_invoice_paid_email_notifications($invoiceid);
			}	
		}
	}
}
new Appointy_Invoice_Helper();
