<?php 

class Appointy_Misc_Helper {



	/**

	 * Get allowed tags for editors

	 *

	 * @return array

	 */

	public static function get_allowed_tags() {



		$allowed_atts = array(

			'align'      => array(),

			'class'      => array(),

			'type'       => array(),

			'id'         => array(),

			'dir'        => array(),

			'lang'       => array(),

			'style'      => array(),

			'xml:lang'   => array(),

			'src'        => array(),

			'alt'        => array(),

			'href'       => array(),

			'rel'        => array(),

			'rev'        => array(),

			'target'     => array(),

			'novalidate' => array(),

			'type'       => array(),

			'value'      => array(),

			'name'       => array(),

			'tabindex'   => array(),

			'action'     => array(),

			'method'     => array(),

			'for'        => array(),

			'width'      => array(),

			'height'     => array(),

			'data'       => array(),

			'title'      => array(),

		);

		$allowedtags['form']     = $allowed_atts;

		$allowedtags['label']    = $allowed_atts;

		$allowedtags['input']    = $allowed_atts;

		$allowedtags['textarea'] = $allowed_atts;

		$allowedtags['iframe']   = $allowed_atts;

		$allowedtags['script']   = $allowed_atts;

		$allowedtags['style']    = $allowed_atts;

		$allowedtags['strong']   = $allowed_atts;

		$allowedtags['small']    = $allowed_atts;

		$allowedtags['table']    = $allowed_atts;

		$allowedtags['span']     = $allowed_atts;

		$allowedtags['abbr']     = $allowed_atts;

		$allowedtags['code']     = $allowed_atts;

		$allowedtags['pre']      = $allowed_atts;

		$allowedtags['div']      = $allowed_atts;

		$allowedtags['img']      = $allowed_atts;

		$allowedtags['h1']       = $allowed_atts;

		$allowedtags['h2']       = $allowed_atts;

		$allowedtags['h3']       = $allowed_atts;

		$allowedtags['h4']       = $allowed_atts;

		$allowedtags['h5']       = $allowed_atts;

		$allowedtags['h6']       = $allowed_atts;

		$allowedtags['ol']       = $allowed_atts;

		$allowedtags['ul']       = $allowed_atts;

		$allowedtags['li']       = $allowed_atts;

		$allowedtags['em']       = $allowed_atts;

		$allowedtags['hr']       = $allowed_atts;

		$allowedtags['br']       = $allowed_atts;

		$allowedtags['tr']       = $allowed_atts;

		$allowedtags['td']       = $allowed_atts;

		$allowedtags['p']        = $allowed_atts;

		$allowedtags['a']        = $allowed_atts;

		$allowedtags['b']        = $allowed_atts;

		$allowedtags['i']        = $allowed_atts;

		$allowedtags['blockquote']  = $allowed_atts;

		$allowedtags['figure']  = $allowed_atts;	

		$allowedtags['option']  = $allowed_atts;	

		

		return $allowedtags;

	}

	

	/**

	 * Get category name

	 *

	 * @return array

	 */

	public static function get_category_name($termid = 0,$taxonomy = 'category') {

		$term = get_term_by( 'id', $termid, $taxonomy );

		

		return ( !empty( $term->name ) ) ? $term->name : '';

	}

	

	/**

	 * Get category slug

	 *

	 * @return array

	 */

	public static function get_category_slug($termid = 0,$taxonomy = 'category') {

		$term = get_term_by( 'id', $termid, $taxonomy );

		

		return ( !empty( $term->slug ) ) ? $term->slug : '';

	}

	

	/**

	 * Get price format

	 *

	 * @return array

	 */

	public static function get_price_format( $price = 0) {

		if(class_exists( 'WooCommerce' )){

			$format = wc_price($price);

		}else{

			$format = self::get_currency_symbol().$price;

		}

		

		return $format;

	}

	

	/**

	 * Get get currency

	 *

	 * @return array

	 */

	public static function get_currency() {

		$default_currency = get_option('woocommerce_currency');

		

		if($default_currency != '') {

			return $default_currency;

		} else {

			$default_currency = 'USD';

			return $default_currency;

		}

	}

	

	/**

	 * Get get currency symbol

	 *

	 * @return symbol

	 */

	public static function get_currency_symbol( $currency = '' ) {

		

		if( class_exists('WooCommerce') ) {

			return get_woocommerce_currency_symbol();	

		} else {

			$currency = self::get_currency();

			

			$symbols = apply_filters(

				'appointy_currency_code', array(

					'AED' => '&#x62f;.&#x625;',

					'AFN' => '&#x60b;',

					'ALL' => 'L',

					'AMD' => 'AMD',

					'ANG' => '&fnof;',

					'AOA' => 'Kz',

					'ARS' => '&#36;',

					'AUD' => '&#36;',

					'AWG' => 'Afl.',

					'AZN' => 'AZN',

					'BAM' => 'KM',

					'BBD' => '&#36;',

					'BDT' => '&#2547;&nbsp;',

					'BGN' => '&#1083;&#1074;.',

					'BHD' => '.&#x62f;.&#x628;',

					'BIF' => 'Fr',

					'BMD' => '&#36;',

					'BND' => '&#36;',

					'BOB' => 'Bs.',

					'BRL' => '&#82;&#36;',

					'BSD' => '&#36;',

					'BTC' => '&#3647;',

					'BTN' => 'Nu.',

					'BWP' => 'P',

					'BYR' => 'Br',

					'BYN' => 'Br',

					'BZD' => '&#36;',

					'CAD' => '&#36;',

					'CDF' => 'Fr',

					'CHF' => '&#67;&#72;&#70;',

					'CLP' => '&#36;',

					'CNY' => '&yen;',

					'COP' => '&#36;',

					'CRC' => '&#x20a1;',

					'CUC' => '&#36;',

					'CUP' => '&#36;',

					'CVE' => '&#36;',

					'CZK' => '&#75;&#269;',

					'DJF' => 'Fr',

					'DKK' => 'DKK',

					'DOP' => 'RD&#36;',

					'DZD' => '&#x62f;.&#x62c;',

					'EGP' => 'EGP',

					'ERN' => 'Nfk',

					'ETB' => 'Br',

					'EUR' => '&euro;',

					'FJD' => '&#36;',

					'FKP' => '&pound;',

					'GBP' => '&pound;',

					'GEL' => '&#x20be;',

					'GGP' => '&pound;',

					'GHS' => '&#x20b5;',

					'GIP' => '&pound;',

					'GMD' => 'D',

					'GNF' => 'Fr',

					'GTQ' => 'Q',

					'GYD' => '&#36;',

					'HKD' => '&#36;',

					'HNL' => 'L',

					'HRK' => 'Kn',

					'HTG' => 'G',

					'HUF' => '&#70;&#116;',

					'IDR' => 'Rp',

					'ILS' => '&#8362;',

					'IMP' => '&pound;',

					'INR' => '&#8377;',

					'IQD' => '&#x639;.&#x62f;',

					'IRR' => '&#xfdfc;',

					'IRT' => '&#x062A;&#x0648;&#x0645;&#x0627;&#x0646;',

					'ISK' => 'kr.',

					'JEP' => '&pound;',

					'JMD' => '&#36;',

					'JOD' => '&#x62f;.&#x627;',

					'JPY' => '&yen;',

					'KES' => 'KSh',

					'KGS' => '&#x441;&#x43e;&#x43c;',

					'KHR' => '&#x17db;',

					'KMF' => 'Fr',

					'KPW' => '&#x20a9;',

					'KRW' => '&#8361;',

					'KWD' => '&#x62f;.&#x643;',

					'KYD' => '&#36;',

					'KZT' => 'KZT',

					'LAK' => '&#8365;',

					'LBP' => '&#x644;.&#x644;',

					'LKR' => '&#xdbb;&#xdd4;',

					'LRD' => '&#36;',

					'LSL' => 'L',

					'LYD' => '&#x644;.&#x62f;',

					'MAD' => '&#x62f;.&#x645;.',

					'MDL' => 'MDL',

					'MGA' => 'Ar',

					'MKD' => '&#x434;&#x435;&#x43d;',

					'MMK' => 'Ks',

					'MNT' => '&#x20ae;',

					'MOP' => 'P',

					'MRO' => 'UM',

					'MUR' => '&#x20a8;',

					'MVR' => '.&#x783;',

					'MWK' => 'MK',

					'MXN' => '&#36;',

					'MYR' => '&#82;&#77;',

					'MZN' => 'MT',

					'NAD' => '&#36;',

					'NGN' => '&#8358;',

					'NIO' => 'C&#36;',

					'NOK' => '&#107;&#114;',

					'NPR' => '&#8360;',

					'NZD' => '&#36;',

					'OMR' => '&#x631;.&#x639;.',

					'PAB' => 'B/.',

					'PEN' => 'S/.',

					'PGK' => 'K',

					'PHP' => '&#8369;',

					'PKR' => '&#8360;',

					'PLN' => '&#122;&#322;',

					'PRB' => '&#x440;.',

					'PYG' => '&#8370;',

					'QAR' => '&#x631;.&#x642;',

					'RMB' => '&yen;',

					'RON' => 'lei',

					'RSD' => '&#x434;&#x438;&#x43d;.',

					'RUB' => '&#8381;',

					'RWF' => 'Fr',

					'SAR' => '&#x631;.&#x633;',

					'SBD' => '&#36;',

					'SCR' => '&#x20a8;',

					'SDG' => '&#x62c;.&#x633;.',

					'SEK' => '&#107;&#114;',

					'SGD' => '&#36;',

					'SHP' => '&pound;',

					'SLL' => 'Le',

					'SOS' => 'Sh',

					'SRD' => '&#36;',

					'SSP' => '&pound;',

					'STD' => 'Db',

					'SYP' => '&#x644;.&#x633;',

					'SZL' => 'L',

					'THB' => '&#3647;',

					'TJS' => '&#x405;&#x41c;',

					'TMT' => 'm',

					'TND' => '&#x62f;.&#x62a;',

					'TOP' => 'T&#36;',

					'TRY' => '&#8378;',

					'TTD' => '&#36;',

					'TWD' => '&#78;&#84;&#36;',

					'TZS' => 'Sh',

					'UAH' => '&#8372;',

					'UGX' => 'UGX',

					'USD' => '&#36;',

					'UYU' => '&#36;',

					'UZS' => 'UZS',

					'VEF' => 'Bs F',

					'VND' => '&#8363;',

					'VUV' => 'Vt',

					'WST' => 'T',

					'XAF' => 'CFA',

					'XCD' => '&#36;',

					'XOF' => 'CFA',

					'XPF' => 'Fr',

					'YER' => '&#xfdfc;',

					'ZAR' => '&#82;',

					'ZMW' => 'ZK',

				)

			);

	

			$currency_symbol = isset( $symbols[ $currency ] ) ? $symbols[ $currency ] : '';

			return apply_filters( 'appointy_currency_symbol', $currency_symbol, $currency );

		}

	}

	

	/**

	 * Get custom terms

	 *

	 * @return array

	 */

	public static function get_custom_terms( $texonomy = '', $args = array() ) {

		if($texonomy != '') {

			$child = (!empty($args['child'])) ? trim($args['child']) : false;

			

			if( (bool) $child === true ) {

				$parent = (!empty($args['parent_category_id'])) ? trim($args['parent_category_id']) : '';

			} else {

				$parent = 0;

			}

			

			if( $texonomy === 'appointy_country' || $texonomy === 'appointy_state' || $texonomy === 'appointy_city' ) {

				$parent = '';

			}

			

			if(!empty($args['search'])) {

				$args = array(

					'orderby'           => 'name',

					'name__like'        => (!empty($args['search'])) ? trim($args['search']) : '',

					'order'             => 'ASC',

					'number'            => (!empty($args['limit'])) ? $args['limit'] : '',

					'parent'            => $parent,

					'hide_empty'        => (!empty($args['hide_empty'])) ? trim($args['hide_empty']) : false,

				);		

			} else {

				$args = array(

					'orderby'           => 'name',

					'order'             => 'ASC',

					'number'            => (!empty($args['limit'])) ? trim($args['limit']) : '',

					'parent'            => $parent,

					'hide_empty'        => (!empty($args['hide_empty'])) ? trim($args['hide_empty']) : false,

				);		

			}

		}

		

		$terms = get_terms( $texonomy,$args );

		

		return $terms;

	}

	

	/**

	 * Get taxonomy fields for metaboxes

	 *

	 * @return array

	 */

	public static function get_taxonomy_metafields() {

		

		$taxonomy_fields = array('appointy_state','appointy_city');

					

		return $taxonomy_fields;

	}

	

	/**

	 * Get wp time format

	 *

	 * @return array

	 */

	public static function get_date_format($date = '') {

		$date_format = get_option( 'date_format' );

		

		if($date != '') {

			return wp_date( $date_format, strtotime( $date ) );

		} 

	}

	

	

	/**

	 * Get wp time format

	 *

	 * @return array

	 */

	public static function get_wp_time_format() {

		$time_format = get_option( 'time_format' );

		return $time_format;

	}

	

	/**

	 * Get time format

	 *

	 * @return string

	 */

	public static function get_time_format( $time = '' ) {

		$time_format = get_option( 'time_format' );

		

		$formatted_date = '';

		

		if( $time != '' ) {

			$formatted_date = date_i18n( $time_format, strtotime( $time ) );

		}

		

		return $formatted_date; 

	}

	

	public static function datepicker_format() {

		return 'dd-mm-yyyy';

	}

	

	public static function datepicker_php_format() {

		return 'd-m-Y';

	}

	

	/**

	 * Get day from date

	 *

	 * @return array

	 */

	public static function get_day( $date = '' ) {

		$day = date("l", strtotime($date));

		$day = strtolower($day);

		

		return $day;

	}

	

	/**

	 * Get WooCommerce product id

	 *

	 * @return array

	 */

	public static function get_woocommerce_poduct_id() {

		$product_id = Appointy_Misc_Helper::get_settings( 'woocommrce_payment_settings', 'woo_product_id' );

		

		return $product_id;

	}

	

	/**

	 * Get fullname by user id

	 *

	 * @return array

	 */

	public static function get_fullname_by_user_id($user_id = 0) {

	

		$first_name = get_user_meta($user_id,'first_name',true);

		$last_name = get_user_meta($user_id,'last_name',true);

		

		return $first_name.' '.$last_name;

	}

	

	/**

	 * Get fullname by user id

	 *

	 * @return array

	 */

	public static function get_email_by_user_id($user_id = 0) {

		

		$user = get_user_by('id', $user_id);

		

		$user_email = Appointy_Router_Helper::get_request_data($user,'user_email');

		

		return $user_email;

	}

	

	/**

	 * Translate strings

	 *

	 * @return array

	 */

	public static function translate_string($str = ''){

		switch (strtolower($str)) {

			case 'pending':

				$returnstr = esc_html__('Pending','appointy');

				break;

			case 'completed':

				$returnstr = esc_html__('Completed','appointy');

				break;

			case 'incomplete':

				$returnstr = esc_html__('Incomplete','appointy');

				break;	

			case 'cancel':

				$returnstr = esc_html__('Cancelled','appointy');

				break;

			case 'cancelled':

				$returnstr = esc_html__('Cancelled','appointy');

				break;	

			case 'paid':

				$returnstr = esc_html__('Paid','appointy');

				break;

			case 'unpaid':

				$returnstr = esc_html__('Not Paid','appointy');

				break;	

			case 'overdue':

				$returnstr = esc_html__('Overdue','appointy');

				break;	

			case 'upcoming':

				$returnstr = esc_html__('Upcoming','appointy');

				break;	

			case 'past':

				$returnstr = esc_html__('Past','appointy');

				break;

			case 'failed':

				$returnstr = esc_html__('Failed','appointy');

				break;

			case 'publish':

				$returnstr = esc_html__('Publish','appointy');

				break;

			case 'preview':

				$returnstr = esc_html__('Preview','appointy');

				break;

			case 'expired':

				$returnstr = esc_html__('Expired','appointy');

				break;	

			case 'draft':

				$returnstr = esc_html__('Draft','appointy');

				break;

			case 'package':

				$returnstr = esc_html__('Package','appointy');

				break;

			case 'fix':

				$returnstr = esc_html__('Fix','appointy');

				break;

			case 'hourly':

				$returnstr = esc_html__('Hourly','appointy');

				break;

			case 'approved':

				$returnstr = esc_html__('Approved','appointy');

				break;

			case 'declined':

				$returnstr = esc_html__('Declined','appointy');

				break;

			case 'claimed':

				$returnstr = esc_html__('Claimed','appointy');

				break;

			case 'in-process':

				$returnstr = esc_html__('In Process','appointy');

				break;

			case 'active':

				$returnstr = esc_html__('Active','appointy');

				break;

			case 'inactive':

				$returnstr = esc_html__('Inactive','appointy');

				break;

			case 'booking':

				$returnstr = esc_html__('Booking','appointy');

				break;

			case 'featured':

				$returnstr = esc_html__('Featured','appointy');

				break;

			case 'wallet':

				$returnstr = esc_html__('Wallet','appointy');

				break;

			case 'invoice':

				$returnstr = esc_html__('Invoice','appointy');

				break;

			case 'cancellation-on-hold':

				$returnstr = esc_html__('On Hold','appointy');

				break;															

			default:

				$returnstr = ucfirst($str);

				break;												

		}

		

		return $returnstr;

	}
	
	/**

	 * Get status class

	 *

	 * @return array

	 */

	public static function get_status_class($status = ''){

		switch (strtolower($status)) {

			case 'paid':

				$class = 'ap-text-green';

				break;

			case 'unpaid':

				$class = 'ap-text-red';

				break;																

			default:

				$class = 'ap-text-normal';

				break;												

		}

		

		return $class;

	}

	

	/**

	 * Set status button class

	 *

	 * @return void

	 */

	public static function get_status_btn_class( $status = '' ) {

		

		switch (strtolower($status)) {

			case 'cancelled':

				$btnclass = 'btn-cancelled';

				break;

			case 'pending':

				$btnclass = 'btn-pending';

				break;

			case 'processing':

				$btnclass = 'btn-pending';

				break;

			case 'on-hold':

				$btnclass = 'btn-pending';

				break;

			case 'completed':

				$btnclass = 'btn-complete';

				break;			

			default:

				$btnclass = 'btn-pending';

				break;												

		}

		

		return $btnclass;

	}

	

	/**

	 * Get url by shortcode

	 *

	 * @return void

	 */

	public static function get_url_by_shortcode( $shortcode = '' ) {

		global $wpdb;

		$url = '';

		

		$wild = '%';

		$like = $wild . $wpdb->esc_like( $shortcode ) . $wild;

		$sql  = $wpdb->prepare('SELECT ID FROM ' . $wpdb->posts . ' WHERE post_type = "page" AND post_status="publish" AND post_content LIKE %s', $like );

		

		if ( $id = $wpdb->get_var( $sql ) ) {

			$url = esc_url( get_permalink( $id ) );

		}

		return $url;

	}

	

	/* Get serivce status */

	public static function get_status_color($status = '') {

		$class = '';

		switch($status) {

			case 'pending':

				$class = 'orange';

				break;

			case 'completed':

				$class = 'green';

				break;

			case 'cancelled':

				$class = 'red';

			case 'cancellation-on-hold':

				$class = 'red';	

				break;		

		}

		

		return $class;

	}

	

	/* Get settings */

	public static function get_settings($option_group = '', $field_id = '', $default = '') {

		$options = get_option( 'appointy_settings' );

		if ( isset( $options[ $option_group .'_section_'. $field_id ] ) ) {

			return $options[ $option_group .'_section_'. $field_id ];

		} elseif( $default != '' ) {

			return $default;

		}



		return false;

	}
	
	/**

	 * Get appointments

	 *

	 * @return void

	 */

	public static function get_total_appointments() {

	    global $wpdb;



		$the_query = Appointy_Appointments_Helper::get_appointments_query();
		
		return $the_query->found_posts;
		
	}	
	
	/**
	 * Output custom theme colors css
	 *
	 * @return string
	 */
    public static function dynamic_style() {
		
        ob_start();
		
		$primary_color = Appointy_Misc_Helper::get_settings( 'color_settings', 'primary_color' );
		$secondary_color = Appointy_Misc_Helper::get_settings( 'color_settings', 'secondary_color' );
		$custom_color1 = Appointy_Misc_Helper::get_settings( 'color_settings', 'custom_color1' );
		$custom_color2 = Appointy_Misc_Helper::get_settings( 'color_settings', 'custom_color2' );
		$btn_primary_color = Appointy_Misc_Helper::get_settings( 'color_settings', 'btn_primary_color' );
		$btn_primary_color_hover = Appointy_Misc_Helper::get_settings( 'color_settings', 'btn_primary_color_hover' );
		$btn_seconday_color = Appointy_Misc_Helper::get_settings( 'color_settings', 'btn_seconday_color' );
		$btn_seconday_color_hover = Appointy_Misc_Helper::get_settings( 'color_settings', 'btn_seconday_color_hover' );
		
		$primary_color = ($primary_color != '') ? $primary_color : '#6139b3';
		$secondary_color = ($secondary_color != '') ? $secondary_color : '#ff8a00';
		$custom_color1 = ($custom_color1 != '') ? $custom_color1 : '#f0eef9';
		$custom_color2 = ($custom_color2 != '') ? $custom_color2 : '#f8f9fb';
		$btn_primary_color = ($btn_primary_color != '') ? $btn_primary_color : '#ff8a00';
		$btn_primary_color_hover = ($btn_primary_color_hover != '') ? $btn_primary_color_hover : '#6139b3';
		$btn_seconday_color = ($btn_seconday_color != '') ? $btn_seconday_color : '#6139b3';
		$btn_seconday_color_hover = ($btn_seconday_color_hover != '') ? $btn_seconday_color_hover : '#ff8a00';
		
		printf( ':root{
			--theme-primary:%s;
			--theme-secondary:%s;
			--theme-color1:%s;
			--theme-color2:%s;
			--btn-primary:%s;
			--btn-primary-hover:%s;
			--btn-secondary:%s;
			--btn-secondary-hover:%s;
		}',esc_attr($primary_color),esc_attr($secondary_color),esc_attr($custom_color1),esc_attr($custom_color2),esc_attr($btn_primary_color),esc_attr($btn_primary_color_hover),esc_attr($btn_seconday_color),esc_attr($btn_seconday_color_hover));
		
        $dynamic_css = ob_get_clean();
		
		$dynamic_css = self::optimized_css( $dynamic_css );
		wp_register_style( 'appointy-dynamic', false );
		wp_enqueue_style( 'appointy-dynamic' );
		wp_add_inline_style( 'appointy-dynamic', $dynamic_css );
    }
	
	private static function optimized_css( $css ) {
		$css = preg_replace( '!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $css );
		$css = str_replace( [ "\r\n", "\r", "\n", "\t", '  ', '    ', '    ' ], ' ', $css );
		return $css;
	}
	
	/**
	 * Get dashboard logo
	 *
	 * @return html
	 */
	public static function get_dashboard_logo() {
		
		$dashboard_logo = Appointy_Misc_Helper::get_settings( 'general_settings', 'dashboard_logo' );
		
		if ( !empty( $dashboard_logo ) ) {
        	$logo = $dashboard_logo;
		} else {
			$logo = APPOINTY_IMAGE_URL.'logo-dark.png';
		}
		
		return $logo;
	}
	
	/**
	 * Get dashboard logo icon
	 *
	 * @return html
	 */
	public static function get_dashboard_logo_icon() {
		
		$dashboard_logo_icon = Appointy_Misc_Helper::get_settings( 'general_settings', 'dashboard_logo_icon' );
		
		if ( !empty( $dashboard_logo_icon ) ) {
        	$logo = $dashboard_logo_icon;
		} else {
			$logo = APPOINTY_IMAGE_URL.'logo-icon.png';
		}
		
		return $logo;
	}
	
	/**
	 * Get user roles
	 *
	 * @return html
	 */
	public static function get_user_roles($userid = 0) {
		$user = new WP_User( $userid );
		$user_roles = $user->roles;	
		
		return $user_roles;
	}
	
	/**
	 * Google calendar for admin
	 *
	 * @return void
	 */
	public static function get_gcal_admin_id() {
		$administrators = get_users( array( 'role__in' => array( 'administrator' ) ) );
		
		if( !empty( $administrators) ) {
			foreach( $administrators as $administrator ) {
				$adminid = $administrator->ID;
				
				$google_calendar_id = get_user_meta($adminid,'google_calendar_id',true);
				$gcal_access_token = get_user_meta($adminid,'gcal_access_token',true);
				
				if($google_calendar_id != '' && !empty($gcal_access_token)) {
					return $adminid;
				}
			}
		}
		
		$adminid = 0;
		return $adminid;
		
	}
	
	/**
	 * Get id by shortcode
	 *
	 * @return void
	 */
	public static function get_get_id_by_shortcode($shortcode) {
		global $wpdb;
		$url = '';
	
		$pageids = array();
		$sql = 'SELECT ID FROM ' . $wpdb->posts . ' WHERE post_type = "page" AND post_status="publish" AND post_content LIKE "%'.$shortcode.'%"';
	
		if ($results = $wpdb->get_results($sql)) {
			foreach($results as $res){
				$pageids[] = $res->ID;
			}
		}
		return $pageids;
	}
	
	/**
	 * Check page is appointy page
	 *
	 * @return void
	 */
	public static function has_appointy_shortcode() {
		if(in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-booking-form')) || in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-giftcard-payment')) || in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-invoice-pay')) || in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-thank-you')) || in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-login')) || in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-staff-dashboard')) || in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-customer-dashboard')) || in_array(get_the_ID(),Appointy_Misc_Helper::get_get_id_by_shortcode('[appointy-repeat-service-payment]')) ) {
			return true;		
		}else{
			return false;
		}
	}
	
	/**
	 * Get admin phone number
	 *
	 * @return void
	 */
	public static function get_admin_phone() {
		$admin_phone_number = Appointy_Misc_Helper::get_settings( 'sms_settings', 'admin_phone_number' );
		
		if($admin_phone_number != '') {
			return $admin_phone_number;
		}else{
			return '';
		}
	}
	
	/**
	 * Get staff member phone number
	 *
	 * @return void
	 */
	public static function get_member_phone($member_id = 0) {
		$country_code = get_user_meta($member_id,'country_code',true);
		$phone = get_user_meta($member_id,'phone',true);
		
		$member_phone_number = $country_code.$phone;
		
		if($member_phone_number != '') {
			return $member_phone_number;
		}else{
			return '';
		}
	}
	
	/**
	 * Get Frequencies
	 *
	 * @return void
	 */
	public static function get_frequencies() {
		$frequencies = array(
			'daily' 	=> __('Daily', 'appointy'),
			'weekly' 	=> __('Weekly', 'appointy'),
			'biweekly' 	=> __('Biweekly', 'appointy'),
			'monthly' 	=> __('Monthly', 'appointy'),
			'bimonthly' => __('Bimonthly', 'appointy')
		);
		
		return $frequencies;
	}

}