<?php 

class Appointy_Notifications_Helper {



	/**

     * Initialize the class

     *

     * @since     1.0.0

     */

    public function __construct() {

		

		add_action('admin_init', array($this, 'notification_template_default_fields'));

		add_action('admin_init', array($this, 'notification_template_fields'));

		

		add_action('wp_ajax_appointy_get_notifications_templates', array($this, 'get_notifications_templates'));

		add_action('wp_ajax_appointy_save_notification_templates', array($this, 'save_notification_templates'));

		

    }

	

	/**

	 * Get notification templates

	 *

	 * @return array

	 */

	public static function get_notifications_templates( ) {

		global $wpdb;

		

		$notification_templates = self::notification_template_fields();

		

		if ( ! empty( $notification_templates ) ) {

			foreach ( $notification_templates as $key => $notification_template ) {

				

				$nestedData['templatename'] = self::get_notification_section_label($key);

				

				$params['section'] = $key;

				$managecolom_url = Appointy_Router_Helper::generate_link( ['notification_templates', 'form'],$params );

				

				$managecolom = '<a href="'.esc_url( $managecolom_url ).'" class="site-button-outline button-sm">'.esc_html__( 'Manage','appointy' ).'</a>';

				

				$nestedData['manage'] = $managecolom;

				

				$data[] = $nestedData;

				

			}

		}

		

		$json_data = array( 'data' => $data );

		

		echo json_encode( $json_data );

		die();

	}

	

	/**

	 * Notification template default fields

	 *

	 * @return array

	 */

	public static function notification_template_default_fields( ) {

		$default_templates = [];

		

		$default_templates['new_appointment_to_admin'] = esc_html__( 'New appointment made at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );
		
		$default_templates['add_feedback_to_admin'] = esc_html__( 'Feedback added at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );
		
		$default_templates['update_feedback_to_admin'] = esc_html__( 'Feedback updated at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );

		$default_templates['received_repeatpayment_to_admin'] = esc_html__( 'Received repeat payment at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );
		
		$default_templates['received_fullpayment_to_admin'] = esc_html__( 'Received full payment at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );
		
		$default_templates['service_reschedule_to_admin'] = esc_html__( 'Service rescheduled at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );

		$default_templates['service_complete_to_admin'] = esc_html__( 'Service completed at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );

		$default_templates['service_cancel_to_admin'] = esc_html__( 'Service cancelled at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );

		$default_templates['update_service_staff_to_admin'] = esc_html__( 'Update service staff at %SITETITLE%. Appointment ID is: %APPOINTMENT_ID%.', 'appointy' );

		$default_templates['giftcard_generate_to_admin'] = esc_html__( 'Giftcard generated on %SITETITLE%.', 'appointy' );

		$default_templates['invoice_generate_to_admin'] = esc_html__( 'New invoice generated from %SITETITLE%. Invoice Id is: %INVOICEID%.', 'appointy' );

		$default_templates['invoice_paid_to_admin'] = esc_html__( 'Customer have successfully paid invoice to %SITETITLE%. Invoice Id is: %INVOICEID%.', 'appointy' );

		

		$default_templates = apply_filters( 'appointy_default_notification_templates', $default_templates );

		

		return $default_templates;	

	}

	

	/**

	 * Notification template fields

	 *

	 * @return array

	 */

	public static function notification_template_fields( ) {

		

		$fields = apply_filters( 'appointy_notification_template_form_fields', array(

			'new_appointment' => array(

				'new_appointment_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICES%, %APPOINTMENT_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %APPOINTMENT_AMOUNT%, %PAYMENT_METHOD%, %PAYMENT_STATUS%, %SITETITLE%, %SERVICELOCATION%, %ADDRESS%',

					'priority'    => 1

				)

			),
			
			'add_feedback' => array(

				'add_feedback_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICES%, %APPOINTMENT_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %APPOINTMENT_AMOUNT%, %PAYMENT_METHOD%, %PAYMENT_STATUS%, %SITETITLE%, %SERVICELOCATION%, %ADDRESS%, %REVIEW_TITLE%, %DESCRIPTION%, %RATING%, %FROM_NAME%, %FROM_EMAIL%',

					'priority'    => 1

				)

			),
			
			'update_feedback' => array(

				'update_feedback_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICES%, %APPOINTMENT_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %APPOINTMENT_AMOUNT%, %PAYMENT_METHOD%, %PAYMENT_STATUS%, %SITETITLE%, %SERVICELOCATION%, %ADDRESS%, %REVIEW_TITLE%, %DESCRIPTION%, %RATING%, %FROM_NAME%, %FROM_EMAIL%',

					'priority'    => 1

				)

			),

			'received_fullpayment' => array(

				'received_fullpayment_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %ADDRESS%, %DUEAMOUNT%, %DEPOSITAMOUNT%, %TOTALAMOUNT%',

					'priority'    => 1

				)

			),
			
			'received_repeatpayment' => array(

				'received_repeatpayment_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICE_NAME%, %SERVICE_DATE%, %SERVICE_TIME%, %SERVICE_DURATION%, %MEMBER_NAME%, %BRANCH_ADDRESS%, %SERVICE_AMOUNT%, %TAX_AMOUNT%, %TOTAL_AMOUNT%, %SERVICE_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %SERVICELOCATION%, %ADDRESS%',

					'priority'    => 1

				)

			),
			
			'service_reschedule' => array(

				'service_reschedule_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICE_NAME%, %SERVICE_DATE%, %SERVICE_TIME%, %SERVICE_DURATION%, %MEMBER_NAME%, %BRANCH_ADDRESS%, %SERVICE_AMOUNT%, %SERVICE_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %SERVICELOCATION%, %ADDRESS%',

					'priority'    => 1

				)

			),

			'service_complete' => array(

				'service_complete_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICE_NAME%, %SERVICE_DATE%, %SERVICE_TIME%, %SERVICE_DURATION%, %MEMBER_NAME%, %BRANCH_ADDRESS%, %SERVICE_AMOUNT%, %SERVICE_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %SERVICELOCATION%, %ADDRESS%',

					'priority'    => 1

				)

			),

			'service_cancel' => array(

				'service_cancel_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICE_NAME%, %SERVICE_DATE%, %SERVICE_TIME%, %SERVICE_DURATION%, %MEMBER_NAME%, %BRANCH_ADDRESS%, %SERVICE_AMOUNT%, %SERVICE_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %SERVICELOCATION%, %ADDRESS%',

					'priority'    => 1

				)

			),

			'update_service_staff' => array(

				'update_service_staff_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %APPOINTMENT_ID%, %SERVICE_NAME%, %SERVICE_DATE%, %SERVICE_TIME%, %SERVICE_DURATION%, %MEMBER_NAME%, %BRANCH_ADDRESS%, %SERVICE_AMOUNT%, %SERVICE_STATUS%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %SERVICELOCATION%, %ADDRESS%',

					'priority'    => 1

				)

			),

			'giftcard_generate' => array(

				'giftcard_generate_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %TITLE%, %FROM_NAME%, %FROM_EMAIL%, %RECIPIENT_NAME%, %RECIPIENT_EMAIL%, %VOUCHER_AMOUNT%, %MESSAGE%, %EXPIRY_DATE%',

					'priority'    => 1

				)

			),

			'invoice_generate' => array(

				'invoice_generate_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %INVOICEID%, %DUEDATE%, %STATUS%, %INVOICE_ITEMS%, %TAX_INFO%, %TAX_AMOUNT%, %DISCOUNT_INFO%, %DISCOUNT_AMOUNT%, %SUBTOTAL%, %GRAND_TOTAL%, %PAYNOW_LINK%',

					'priority'    => 1

				)

			),

			'invoice_paid' => array(

				'invoice_paid_to_admin' => array(

					'label'       => esc_html__( 'Description (Admin)', 'appointy' ),

					'type'        => 'textarea',

					'colum-width' => 'col-lg-12',

					'description' => '%SITETITLE%, %CUSTOMER_NAME%, %CUSTOMER_EMAIL%, %CUSTOMER_PHONE%, %INVOICEID%, %DUEDATE%, %STATUS%, %INVOICE_ITEMS%, %TAX_INFO%, %TAX_AMOUNT%, %DISCOUNT_INFO%, %DISCOUNT_AMOUNT%, %SUBTOTAL%, %GRAND_TOTAL%, %PAYNOW_LINK%',

					'priority'    => 2

				)

			),

		) );

		

		return Appointy_Form_Helper::get_fields( $fields );	

	}

	

	/**

	 * Notification template fields label

	 *

	 * @return array

	 */

	public static function notification_template_fields_label( ) {

		

		$fields = apply_filters( 'appointy_notification_template_form_fields_label', array(

			'new_appointment' => esc_html__( 'New appointment', 'appointy' ),

			'service_reschedule' => esc_html__( 'Service reschedule', 'appointy' ),
			
			'received_repeatpayment' => esc_html__( 'Received repeat payment', 'appointy' ),
			
			'received_fullpayment' => esc_html__( 'Received full payment', 'appointy' ),

			'service_complete' => esc_html__( 'Service completed', 'appointy' ),

			'service_cancel' => esc_html__( 'Service cancelled', 'appointy' ),
			
			'add_feedback' => esc_html__( 'Add Feedback', 'appointy' ),
			
			'update_feedback' => esc_html__( 'Update Feedback', 'appointy' ),

			'update_service_staff' => esc_html__( 'Update service staff', 'appointy' ),

			'giftcard_generate' => esc_html__( 'Generate giftcard', 'appointy' ),

			'invoice_generate' => esc_html__( 'Invoice generate', 'appointy' ),

			'invoice_paid' => esc_html__( 'Invoice paid', 'appointy' )

		) );

		

		return Appointy_Form_Helper::get_fields( $fields );	

	}

	

	/**

	 * Get notification section label

	 *

	 * @return array

	 */

	public static function get_notification_section_label($key = '') {

		

		$template_label = self::notification_template_fields_label();

		return Appointy_Router_Helper::get_sanitize_data( $template_label, $key );

	}

	

	/**

	 * Save notification templates

	 *

	 * @return array

	 */

	public static function save_notification_templates( ) {

		global $wpdb;

		

		$notification_template_key = Appointy_Router_Helper::get_sanitize_data( $_POST, 'notification_template_key' );

		

		$notification_fields = self::notification_template_fields();

		

		$notification_fields = ( !empty($notification_fields[$notification_template_key]) ) ? (array) $notification_fields[$notification_template_key] : array();

		

		$notification_templates = get_option( 'appointy_notification_templates' );

		

		if( !empty( $notification_fields ) ) {

			foreach( $notification_fields as $key => $field ){

				$notification_templates[$notification_template_key][$key] = Appointy_Router_Helper::get_sanitize_data( $_POST, $key );

			}

		}

		

		update_option( 'appointy_notification_templates', $notification_templates );

			

		$redirecturl = add_query_arg( array( 'page' => 'appointment','menu_item' => 'notification_templates__index' ), admin_url( 'admin.php' ) );

		

		$response = array( 'msg' => esc_html__('Notification template saved successfully.', 'appointy'), 'redirect' => $redirecturl );

		wp_send_json_success($response);

		die();

	}
	
	/**
	 * Get user notifications
	 *
	 * @return array
	 */
	public static function get_user_notification($user_id = 0,$user_type = 'admin') {
		global $wpdb;
		
		if($user_type === 'admin') {
			$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`datetime`,`admin_id`,`customer_id`,`title`,`description`,`link`,`reference`,`reference_id`,`action_perform_by`,`status` FROM '.$wpdb->prefix.'appointy_notifications WHERE `admin_id` = %d order by id desc',$user_id));
		}else{
			$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`datetime`,`admin_id`,`customer_id`,`title`,`description`,`link`,`reference`,`reference_id`,`action_perform_by`,`status` FROM '.$wpdb->prefix.'appointy_notifications WHERE `customer_id` = %d order by id desc',$user_id));
		}
		
		return $results;
	}
	
	/**
	 * Get user notifications
	 *
	 * @return array
	 */
	public static function get_user_unread_notification($user_id = 0,$user_type = 'admin') {
		global $wpdb;
		
		if($user_type === 'admin') {
			$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`datetime`,`admin_id`,`customer_id`,`title`,`description`,`link`,`reference`,`reference_id`,`action_perform_by`,`status` FROM '.$wpdb->prefix.'appointy_notifications WHERE `admin_id` = %d AND `status` = "unread" order by id desc',$user_id));
		}else{
			$results = $wpdb->get_results($wpdb->prepare('SELECT `id`,`datetime`,`admin_id`,`customer_id`,`title`,`description`,`link`,`reference`,`reference_id`,`action_perform_by`,`status` FROM '.$wpdb->prefix.'appointy_notifications WHERE `customer_id` = %d AND `status` = "unread" order by id desc',$user_id));
		}
		
		return $results;
	}

}

new Appointy_Notifications_Helper();