<?php 

class Appointy_Side_Menu_Helper {



	public static function get_side_menu_items() {

		if( current_user_can( 'administrator' ) ) {

			$sidemenus = array(

				array( 'id' => 'dashboard', 'label' => __( 'Dashboard', 'appointy' ), 'icon' => 'feather-layout', 'link' => Appointy_Router_Helper::generate_link(['dashboard', 'index'])),

				array( 'id' => 'settings', 'label' => __( 'Settings', 'appointy' ), 'icon' => 'fa fa-sliders', 'link' => add_query_arg( array( 'page' => 'appointy-settings' ), admin_url( 'admin.php' ) )),

				array( 'id' => 'email-templates', 'label' => __( 'Email Templates', 'appointy' ), 'icon' => 'feather-mail', 'link' => Appointy_Router_Helper::generate_link(['email_templates', 'index'])),

				array( 'id' => 'notification-templates', 'label' => __( 'Notification Templates', 'appointy' ), 'icon' => 'feather-bell', 'link' => Appointy_Router_Helper::generate_link(['notification_templates', 'index'])),

				array( 'id' => 'sms-templates', 'label' => __( 'Sms Templates', 'appointy' ), 'icon' => 'feather-message-square', 'link' => Appointy_Router_Helper::generate_link(['sms_templates', 'index'])),

				array( 'id' => 'appointments', 'label' => __( 'Appointments', 'appointy' ), 'icon' => 'feather-calendar', 'link' => Appointy_Router_Helper::generate_link(['appointments', 'index'])),
				
				array( 'id' => 'google-calendar', 'label' => __( 'Google Calendar', 'appointy' ), 'icon' => 'fa fa-calendar-check-o', 'link' => Appointy_Router_Helper::generate_link(['google-calendar', 'index'])),

				array( 'id' => 'invoice', 'label' => __( 'Invoice', 'appointy' ), 'icon' => 'feather-file-text', 'link' => Appointy_Router_Helper::generate_link(['invoice', 'index'])),

				array( 'id' => 'availability', 'label' => __( 'Availability', 'appointy' ), 'icon' => 'feather-calendar', 'link' => Appointy_Router_Helper::generate_link(['availability', 'index'])),

				array( 'id' => 'services', 'label' => __( 'Services', 'appointy' ), 'icon' => 'feather-settings', 'link' => Appointy_Router_Helper::generate_link(['services', 'index']),

					'children' => array(

								  array('label' => __( 'All Services', 'appointy' ), 'icon' => '', 'link' => Appointy_Router_Helper::generate_link(['services', 'index'])),

								  array('label' => __( 'Categories', 'appointy' ), 'icon' => '', 'link' => Appointy_Router_Helper::generate_link(['service_categories', 'index'])),

					)

				),

				array( 'id' => 'staff', 'label' => __( 'Staff', 'appointy' ), 'icon' => 'feather-users', 'link' => Appointy_Router_Helper::generate_link(['staff', 'index'])),

				array( 'id' => 'customers', 'label' => __( 'Customers', 'appointy' ), 'icon' => 'feather-user-plus', 'link' => Appointy_Router_Helper::generate_link(['customers', 'index'])),

				array( 'id' => 'location', 'label' => __( 'Locations', 'appointy' ), 'icon' => 'feather-map-pin', 'link' => Appointy_Router_Helper::generate_link(['locations', 'index'])),

				array( 'id' => 'coupons', 'label' => __( 'Coupon Codes', 'appointy' ), 'icon' => 'feather-tag', 'link' => Appointy_Router_Helper::generate_link(['coupons', 'index'])),

				array( 'id' => 'taxes', 'label' => __( 'Taxes', 'appointy' ), 'icon' => 'feather-percent', 'link' => Appointy_Router_Helper::generate_link(['taxes', 'index'])),

				array( 'id' => 'giftcards', 'label' => __( 'Giftcards', 'appointy' ), 'icon' => 'feather-gift', 'link' => Appointy_Router_Helper::generate_link(['giftcards', 'index']))

			  );

		} else{

		  $sidemenus = [];

		}

		

		$sidemenus = apply_filters('appointy_side_menu', $sidemenus);

		return $sidemenus;

	}

}