<?php 
class Appointy_Zoom_Helper {

	/**
	 * Create zoom link
	 *
	 * @return array
	 */
	public static function create_zoom_link( $appointment_id = 0, $appointment_service_id = 0, $booked_services = array() ) {
		global $wpdb;
	
		$password = rand(00000, 999999);
		
		$startdatetime = date_i18n('Y-m-d H:i',strtotime($booked_services['booking_date'].' '.$booked_services['booking_start_time']));
		
		$zoomhostid = get_zoom_hostid();
		
		if($zoomhostid != false) {
        $data = array(
			'userId' => $zoomhostid,
			'meetingTopic' => esc_html__('Appointment zoom meeting.','appointy'),
			'start_date' => $startdatetime,
			'timezone' => date_default_timezone_get(),
			'duration' => '60',
			'password' => $password,
			'meeting_authentication' => '',
			'join_before_host' => 1,
			'option_host_video' => 1,
			'option_participants_video' => 1,
			'option_mute_participants' => '',
			'option_auto_recording' => 'none',
			'alternative_host_ids' => '',
			'disable_waiting_room' => '',            
        );

		$response = json_decode( zoom_conference()->createAMeeting( $data ) );

		if ( empty( $response->code ) ) {       

            $returnResponse = json_encode($response);

            $array = array(
                "appointment_id" => $appointment_id,
				"appointment_service_id" => $appointment_service_id,
                "room_title" => esc_html__('Zoom Meeting.','appointy'),
                "meeting_id" => $response->id,
				"host_url" => $response->start_url,
				"join_url" => $response->join_url,
				"meeting_details" => serialize($response),
                "room_password" => $password,
                "class_start_time" => $booked_services['booking_start_time'],
                "created_by" => "Admin",
                "duration" => Appointy_Router_Helper::get_request_data($data,'duration'),
            );
            $wpdb->insert($wpdb->prefix.'appointy_zoom_meetings', wp_unslash($array));
        }
		}
	}
	
	/**
	 * Get zoom host id
	 *
	 * @return array
	 */
	public static function get_zoom_hostid() {
		$decoded_users = json_decode( zoom_conference()->listUsers() );
		if ( ! empty( $decoded_users->code ) ) {
			return false;
		} else {
			$users = ! empty( $decoded_users->users ) ? $decoded_users->users : false;
			return $users[0]->id;
		}
	}
}
new Appointy_Zoom_Helper();