(function( $ ) {
	'use strict';
	
	var appointyBookedService = [];
	var appointyBookedSelectedDates = [];
	var appointyBlockedDates = [];
	
	var appointyBookedService = [];
	var appointyCurrentDate;
	var appointySlotFlag = 1;
	var appointyMemberFlag = 0;
	var calendar;
	var repeatServiceTable;
	
	if (typeof bookingformdata === 'undefined') {
		var inititalBlockedDates = [];
    }else{
		var inititalBlockedDates = bookingformdata;
	}
	
	var toggleLoading = function( status = '' ) {
		if(status == 'show') {
			jQuery('.ap-loading-area').show();
		} else if(status == 'hide') {
			jQuery('.ap-loading-area').hide();	
		}
	}
	
	var togglePanelLoading = function( status = '' ) {
		if(status == 'show') {
			jQuery('.panel-loading-area').show();
		} else if(status == 'hide') {
			jQuery('.panel-loading-area').hide();	
		}
	}
	
	var renderValidationMessage = function( msg = '' ) {
		$('.appointy-error li').remove();
		$('.appointy-error').append('<li class="error">'+msg+'</li>').show();
		$(".sf-alert-box-wrap").show('slow');
		$('.sf-alert-box-wrap').animate({right: '0'} , 1000);
	}
	
	var renderSuccessMessage = function( msg = '' ) {
		$('.sf-success-msg').html(msg).show();
		$(".sf-sucess-box").show('slow');
		$('.sf-sucess-box').animate({right: '0'} , 1000);
	}
	
	var hideSuccessMessage = function() {
			$('body').on('click', '.sf-sucess-box', function() {
				jQuery(this).hide('slow');
			});
		}

	var hideValidationMessage = function() {
			$('body').on('click', '.sf-alert-box-wrap', function() {
				jQuery(this).hide('slow');
			});
		}
	
	var manageStaffAccount = function() {
		$('form[name="staff__account"]').validate({
			submitHandler: function() { 
				var $this = $('form[name="staff__account"]');
				
				var form = document.getElementById('staff__account');
	
				var formData = new FormData( form );
		
				// From the wp_ajax_prefix_ajax_first hook
				formData.append( 'action', 'save_staff_account' );
				formData.append( '_nonce', appointy_options._nonce );
				
				$.ajax({
					cache: false,
					type: "POST",
					url: appointy_options.ajaxurl,
					data: formData,
					beforeSend: toggleLoading('show'),
					processData: false, // Required for file upload
					contentType: false, // Required for file upload
					success: function( response ){
						if ( response.success ) {
							renderSuccessMessage(response.data.msg);
						} else {
							renderValidationMessage(response.data.msg);
						}
					},
					error: function( xhr, status, error ) {
						renderValidationMessage(xhr.responseText);
					},
					complete: function() {
						toggleLoading('hide');	
					}
				});
				
				return false; 
			}
		});	
	}
	
	var managePassword = function() {
		$('form[name="password__account"]').validate({
			rules: {
				current_password: "required",
				password: "required",
				confirm_password: {
					  equalTo: "#password"
				}
			},
			messages: {
				current_password: appointy_options.current_password,
				password: appointy_options.password,
				confirm_password: {
				  equalTo: appointy_options.confirm_password
				}
			},
			submitHandler: function() { 
				var $this = $('form[name="password__account"]');
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: toggleLoading('show'),
					data:  $this.serialize()+"&action=appointy_update_password"
				}).done(function(response) {
					toggleLoading('hide');
					if ( response.success ) {
						renderSuccessMessage(response.data.msg);
					} else {
						renderValidationMessage(response.data.msg);
					}
				}).always(function() {
					toggleLoading('hide');
				});
				return false; 
			}
		});
	}
	
	var manageAppointments = function() {
		var attachment_ids;
		var appointment_id;
		var service_post_id;
		
		jQuery('body').on('click', '.payrepeatpayment', function(){
		
			var appointmentId = jQuery(this).data('appointment_id');
			var repeatServiceId = jQuery(this).data('repeat_service_id');
			var serviceId = jQuery(this).data('serviceid');
			
			var data = {
				action       	: 'addto_woo_cart',
				wootype			: 'payrepeatpayment',
				appointment_id	: appointmentId,
				repeat_service_id	: repeatServiceId,
				service_id		: serviceId
			};
			var formdata = $.param(data);
			
			jQuery.ajax({
				type : "post",
				dataType : "json",
				url : appointy_options.ajaxurl,
				data : formdata,
				beforeSend: toggleLoading('show'),
			}).done(function(response) {
				if ( response.success ) {
					window.location.href = appointy_options.cart_url;
				} else {
					renderValidationMessage(response.data.msg);
				}
			}).complete(function() {
				toggleLoading('hide');
			});
		});
		
		jQuery('body').on('click', '.cancelallrepeatservice', function(){
		
			var appointment_id = jQuery(this).data('appointment_id');
			var service_id = jQuery(this).data('service_id');
			
			bootbox.confirm(appointy_options.are_you_sure, function(result) {
				if(result){
					var data = {
					  "action": "appointy_cancel_all_repeat_service",
					  "appointment_id": appointment_id,
					  "service_id": service_id
					};
				
					var formdata = jQuery.param(data);
				
					$.ajax({
						url: appointy_options.ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: toggleLoading('show'),
						data : formdata,
					}).done(function(response) {
						toggleLoading('hide');
						if( response.success ) {
							renderSuccessMessage(response.data.message);
							
							repeatServiceTable.ajax.reload(null, false);
						}
					});
				}
			});
		});
			
		jQuery('body').on('click', '.cancelrepeatservice', function(){
		
			var repeat_schedule_id = jQuery(this).data('repeat_schedule_id');
			
			bootbox.confirm(appointy_options.are_you_sure, function(result) {
				if(result){
					var data = {
					  "action": "appointy_cancel_repeat_service",
					  "repeat_schedule_id": repeat_schedule_id
					};
				
					var formdata = jQuery.param(data);
				
					$.ajax({
						url: appointy_options.ajaxurl,
						type:'POST',
						dataType: 'json',
						beforeSend: toggleLoading('show'),
						data : formdata,
					}).done(function(response) {
						toggleLoading('hide');
						if( response.success ) {
							renderSuccessMessage(response.data.message);
							
							repeatServiceTable.ajax.reload(null, false);
						}
					});
				}
			});
		});
		
		jQuery('body').on('click', '.payfullpayment', function(){
		
			var appointmentId = jQuery(this).data('appointment_id');
			
			var data = {
				action       	: 'addto_woo_cart',
				wootype			: 'depositfullpayment',
				appointment_id	: appointmentId
			};
			var formdata = $.param(data);
			
			jQuery.ajax({
				type : "post",
				dataType : "json",
				url : appointy_options.ajaxurl,
				data : formdata,
				beforeSend: toggleLoading('show'),
			}).done(function(response) {
				if ( response.success ) {
					window.location.href = appointy_options.cart_url;
				} else {
					renderValidationMessage(response.data.msg);
				}
			}).complete(function() {
				toggleLoading('hide');
			});
		});
		
		var x = $('#bookingratingstar').jRate({
			rating: 0,
			min: 0,
			max: 5,
			precision: 1,
			startColor: '#ff8a00',
			endColor: '#ff8a00',
			width: 20,
			height: 20,
			touch: true,
			backgroundColor: '#DFDFE0',
			onChange: function (rating) {
				$('#bookingratingnumber').val(rating);
			},
			onSet: function (rating) {
				$('#bookingratingnumber').val(rating);
			}
		});
		
		$('body').on('click','.editbooking', function(event){
			appointyBookedService = $( this ).data( 'booked_service' );
			appointyBookedSelectedDates = $( this ).data( 'selecteddates' );
			appointyBlockedDates = $( this ).data( 'blockeddates' );
			
			$('#editappointmentmodal').modal('show');
		});	
		
		$('#editappointmentmodal').on('shown.bs.modal', function () {
			$('#editappointmentmodal').trigger('focus');
			loadEditBookingCalendar(appointyBookedService,appointyBookedSelectedDates,appointyBlockedDates);
		});
		
		$('body').on('click','.assignmember', function(event){
			toggleLoading('show');
			appointyBookedService = $( this ).data( 'booked_service' );
			$('#assignmembermodal').modal('show');
		});
		
		$('#assignmembermodal').on('shown.bs.modal', function () {
			$('#assignmembermodal').trigger('focus');
			loadServiceMembers(appointyBookedService);
		});
		
		$('body').on('click','.viewrepeatingservices', function(event){
			appointment_id = $( this ).data( 'appointment_id' );
			service_post_id = $( this ).data( 'service_post_id' );
			$('#repeatingservicesmodal').modal('show');
		});
		
		$('#repeatingservicesmodal').on('shown.bs.modal', function () {
			$('#repeatingservicesmodal').trigger('focus');
			loadRepeatingServices(appointment_id,service_post_id);
		});
		
		$('body').on('click','.viewattachments', function(event){
			attachment_ids = $( this ).data( 'attachment_ids' );
			$('#viewattachmentsmodal').modal('show');
		});
		
		$('#viewattachmentsmodal').on('shown.bs.modal', function () {
			$('#viewattachmentsmodal').trigger('focus');
			loadViewAttachments(attachment_ids);
		})
		
		$('body').on('click','.viewmultidatedates', function(event){
			var multidatedates = $( this ).data( 'multidatedates' );
			jQuery( '#load_multidate_dates' ).html(multidatedates);
			$('#multidatedatesmodal').modal('show');
		});
		
		/*Start cancel service*/
		$('body').on('click','.cancelservice', function(event){
			var bid = jQuery(this).data('bookingid');
			var sid = jQuery(this).data('serviceid');
			
			jQuery('#cancelservicemodal').modal('show');
			
			jQuery('form[name="service__cancel"] input[name="bookingid"]').val(bid);
			jQuery('form[name="service__cancel"] input[name="serviceid"]').val(sid);
		});
		
		$('body').on('click','.addfeedback', function(event){
			var bid = jQuery(this).data('bookingid');
			var sid = jQuery(this).data('serviceid');
			
			jQuery('#feedbackmodal').modal('show');
			
			jQuery('form[name="givefeedbackform"] input[name="bookingid"]').val(bid);
			jQuery('form[name="givefeedbackform"] input[name="serviceid"]').val(sid);
		});
		
		jQuery('body').on('click', '.viewbookingreview', function(){
		
			var reviewid = jQuery(this).data('reviewid');
			
			var data = {
			  "action": "view_booking_review_details",
			  "postid": reviewid
			};
		
			var formdata = jQuery.param(data);
		
			$.ajax({
				url: appointy_options.ajaxurl,
				type:'POST',
				dataType: 'json',
				beforeSend: toggleLoading('show'),
				data : formdata,
			}).done(function(response) {
				toggleLoading('hide');
				if( response.success ) {
					bootbox.dialog({
						title: appointy_options.booking_review_details,
						message: response.data
					});
					showDynamicRating();
				}
			});
			
		});
		
		$('body').on('click','.editfeedback', function(event){
			var $this = $(this), formcontainer = $('#givefeedbackform');
			var bid = jQuery(this).data('bookingid');
			var sid = jQuery(this).data('serviceid');
			var reviewid = jQuery(this).data('reviewid');
			
			$.ajax({
				url : appointy_options.ajaxurl,
				type:'POST',
				dataType: 'json',
				beforeSend: toggleLoading('show'),
				data: "action=load_booking_feedback&reviewid="+reviewid
			}).done(function(response) {
				toggleLoading('hide');
				if ( response.success ) {
					formcontainer.find('.formeditid').remove();
					formcontainer.find('input[name="review_title"]').val(response.data.title);
					formcontainer.find('textarea[name="description"]').val(response.data.description);
					formcontainer.find('input[name="rating"]').val(response.data.rating);
					formcontainer.prepend( '<input type="hidden" class="formeditid" name="reviewid" value="'+reviewid+'">' );
					x.setRating(response.data.rating);
					
					jQuery('#feedbackmodal').modal('show');
					
					jQuery('form[name="givefeedbackform"] input[name="bookingid"]').val(bid);
					jQuery('form[name="givefeedbackform"] input[name="serviceid"]').val(sid);
				} else {
					renderValidationMessage(response.data.msg);
				}
			});
		});
		
		/*Start service mark as complete*/
		$('body').on('click','.completeservice', function(event){
			var bid = jQuery(this).data('bookingid');
			var sid = jQuery(this).data('serviceid');
			var mid = jQuery(this).data('memberid');
			
			bootbox.confirm(appointy_options.are_you_sure, function(result) {
				if(result){
					var data = {
						action	: 'appointy_complete_service',
						bid : bid,
						sid	: sid,
						mid	: mid
					};
					
					var formdata = jQuery.param(data);
					
					jQuery.ajax({
						type : "post",
						dataType : "json",
						url : appointy_options.ajaxurl,
						data : formdata,
						beforeSend: toggleLoading('show'),
						success: function(response) {
							toggleLoading('hide');
							if( response.success ) {
								/*jQuery( '#servicecomplete-'+bid+'-'+sid ).remove();
								jQuery( '#servicecancel-'+bid+'-'+sid ).remove();
								jQuery( '#serviceedit-'+bid+'-'+sid ).remove();
								
								jQuery( '#servicestatus-'+bid+'-'+sid ).removeClass('red');
								jQuery( '#servicestatus-'+bid+'-'+sid ).removeClass('orange');
								jQuery( '#servicestatus-'+bid+'-'+sid ).removeClass('green');
								
								jQuery( '#servicestatus-'+bid+'-'+sid ).addClass(response.data.statuscolor);
								
								jQuery( '#servicestatus-'+bid+'-'+sid ).html(response.data.servicestatus);*/
								
								renderSuccessMessage(response.data.message);
								
								setTimeout(function() {
									window.location.reload();
								}, 2000);
								
								
								
							}
						},
						error: function(response) {
							toggleLoading('hide');
						}
				   }) 
				}
			});
		});
	}
	
	var showRating = function() {
		if( jQuery('.showrating').length > 0 ){
				$('.showrating').each(function(){
				var $this = $(this);
				var ratingNumber = $this.data('rating');
				var reviewId = $this.data('reviewid');

				$('#showrating-'+reviewId).jRate({
					rating: ratingNumber,
					readOnly: true,
					min: 0,
					max: 5,
					precision: 1,
					startColor: '#ff8a00',
					endColor: '#ff8a00',
					width: 20,
					height: 20,
					touch: true,
					backgroundColor: '#DFDFE0',
				});
				
			} );
			}
		
	}
	
	var showDynamicRating = function() {
		
		if( jQuery('.showdynamicrating').length > 0 ){
			$('.showdynamicrating').each(function(){
			var $this = $(this);
			var ratingnumber = $this.data('rating');
			var reviewid = $this.data('reviewid');

			$('#showdynamicrating-'+reviewid).jRate({
				rating: ratingnumber,
				readOnly: true,
				min: 0,
				max: 5,
				precision: 1,
				startColor: '#ff8a00',
				endColor: '#ff8a00',
				width: 20,
				height: 20,
				touch: true,
				backgroundColor: '#DFDFE0',
			});
			
		} );
		}
	}
	
	var loadEditBookingCalendar = function(appointyBookedService = [],appointyBookedSelectedDates = [],appointyBlockedDates = []) {
		
		var bookingDate = appointyBookedService.booking_date;
			
		var multiDateService = appointyBookedService.multidate_service;
		var multiDateServiceType = appointyBookedService.multidate_service_type;
		var numberOfDates = appointyBookedService.number_of_dates;
		var fullDayTimeSlots = appointyBookedService.fullday_timeslots;
		
		if(multiDateService === 'yes') {
			
			$('#bookingcalendar .singledatepicker-warpper').hide();
			if(multiDateServiceType === 'separate_dates') {
				$('#bookingcalendar .multidatepicker-warpper').show();	
				$('#bookingcalendar .daterangepicker-warpper').hide();
				
				var date = new Date();
				date.setDate(date.getDate() + 1);
				
				$('.multidatepicker').datepicker('destroy');
				
				if(parseInt(numberOfDates) > 0) {
					$('.multidatepicker').datepicker({
						multidate: parseInt(numberOfDates),
						multidateSeparator: ",",
						toggleActive: true,
						format: appointy_options.dateformat,
						language: appointy_options.locale,
						daysOfWeekDisabled: inititalBlockedDates.weekdaysNotInTable,
						startDate: date
					}).on('changeDate', function(e) {
						// `e` here contains the extra attributes
						//alert('first: '+e.dates.length);
					});
				}else{
					$('.multidatepicker').datepicker({
						multidate: true,
						multidateSeparator: ",",
						toggleActive: true,
						format: appointy_options.dateformat,
						language: appointy_options.locale,
						daysOfWeekDisabled: inititalBlockedDates.weekdaysNotInTable,
						startDate: date
					}).on('changeDate', function(e) {
						// `e` here contains the extra attributes
						//alert('second: '+e.dates.length);
					});
				}
				
				//alert(JSON.stringify(appointyBookedSelectedDates, null, 4));
				//alert(JSON.stringify(appointyBlockedDates, null, 4));
				
				// Format selected dates
				var formattedSelectedDates = $.map(appointyBookedSelectedDates, function(date) {
					return formatDateString(date);
				});
				
				// Remove selected dates from blocked dates
				var appointyBlockedDates = $.grep(appointyBlockedDates, function(date) {
					return $.inArray(date, formattedSelectedDates) === -1;
				});
				
				//alert(JSON.stringify(appointyBlockedDates, null, 4));
				
				var setBlockedDates = [];
					
				appointyBlockedDates.forEach(function(date) {
					var setBlockedDate = moment(date).format(appointy_options.dateformat.toUpperCase());
					setBlockedDates.push(setBlockedDate);
				});
				
				jQuery('.multidatepicker').datepicker( 'setDatesDisabled', setBlockedDates );
				
				var setBookingDates = [];
				
				appointyBookedSelectedDates.forEach(function(date) {
					setBookingDate = moment(date).format(appointy_options.dateformat.toUpperCase());
					setBookingDates.push(setBookingDate);
				});
				
				jQuery('.multidatepicker').datepicker( 'setDates', setBookingDates );
				
			}else if(multiDateServiceType === 'date_range'){
				$('#bookingcalendar .multidatepicker-warpper').hide();	
				$('#bookingcalendar .daterangepicker-warpper').show();
				
				$('.input-daterange').datepicker('destroy');
				
				var setBlockedDates = [];
					
				appointyBlockedDates.forEach(function(date) {
					var setBlockedDate = moment(date).format(appointy_options.dateformat.toUpperCase());
					setBlockedDates.push(setBlockedDate);
				});
					
				var date = new Date();
				date.setDate(date.getDate());
		
				$('.input-daterange').datepicker({
					multidate: false,
					multidateSeparator: ",",
					toggleActive: true,
					format: appointy_options.dateformat,
					language: appointy_options.locale,
					daysOfWeekDisabled: inititalBlockedDates.weekdaysNotInTable,
					datesDisabled: setBlockedDates,
					startDate: date
				});
		
				var setBookingDates = [];
				
				appointyBookedSelectedDates.forEach(function(date) {
					setBookingDates.push(new Date(date));
				});
				
				var setStartDateRange = new Date(Math.min.apply(null, setBookingDates));
				var setEndDateRange = new Date(Math.max.apply(null, setBookingDates));
				
				$('.input-daterange input[name="start_range"]').datepicker('setDates', setStartDateRange);
				$('.input-daterange input[name="end_range"]').datepicker('setDates', setEndDateRange);
				
			}
			
			loadDatesTimes();
		}else{
			$('#bookingcalendar .singledatepicker-warpper').show();
			$('#bookingcalendar .multidatepicker-warpper').hide();
			$('#bookingcalendar .daterangepicker-warpper').hide();
			
			var date = new Date();
			date.setDate(date.getDate() + 1);
			jQuery('.singledatepicker').datepicker({
				multidate: false,
				maxViewMode: 0,
				toggleActive: true,
				format: appointy_options.dateformat,
				language: appointy_options.locale,
				daysOfWeekDisabled: inititalBlockedDates.weekdaysNotInTable,
				startDate: date
			})
			.on('changeDate', function(e) {
				
				appointyCurrentDate = jQuery(this).data('datepicker').getFormattedDate('yyyy-mm-dd');
				//alert('Third: '+appointyCurrentDate);
				if( appointyCurrentDate != '' && appointyCurrentDate !== undefined && appointyCurrentDate !== 'undefined' && appointyCurrentDate !== null && appointyCurrentDate !== 'null' ) {
					loadEditTimeSlots(appointyCurrentDate);
					appointySlotFlag = 0;
				}
			});
			
			var setBlockedDates = [];
					
			appointyBlockedDates.forEach(function(date) {
				var setBlockedDate = moment(date).format(appointy_options.dateformat.toUpperCase());
				setBlockedDates.push(setBlockedDate);
			});
			
			jQuery('.singledatepicker').datepicker( 'setDatesDisabled', setBlockedDates );
			
			var setBookingDate = moment(bookingDate).format(appointy_options.dateformat.toUpperCase());
			jQuery('.singledatepicker').datepicker( 'setDate', setBookingDate );
		}
	}
	
	var formatDateString = function(dateString) {
		
		var date = new Date(dateString);
		var year = date.getFullYear();
		var month = ("0" + (date.getMonth() + 1)).slice(-2);
		var day = ("0" + date.getDate()).slice(-2);
		return year + "-" + month + "-" + day;
	}
	
	var manageMultidates = function() {

		$('body').on('click', '.continueaftermultidate', function() {
			loadDatesTimes();														  
		});	
	}
	
	var loadDatesTimes = function() {
		
		var dateRanges = [];
		var multiDateService = appointyBookedService.multidate_service;
		var multiDateServiceType = appointyBookedService.multidate_service_type;
		var numberOfDates = appointyBookedService.number_of_dates;
		var fullDayTimeSlots = appointyBookedService.fullday_timeslots;
		
		if(multiDateServiceType === 'separate_dates') {
			var selectedDates = $('.multidatepicker').datepicker('getDates');
			var dateRanges = selectedDates.map(date => date.getFullYear() + '-' + ('0' + (date.getMonth() + 1)).slice(-2) + '-' + ('0' + date.getDate()).slice(-2));
			
			dateRanges.sort(function(a, b) {
				return new Date(a) - new Date(b);
			});
			
			var currentStartDate = dateRanges[0];
			
			//alert(JSON.stringify(dateRanges, null, 4));
		}else if(multiDateServiceType === 'date_range'){
			var startDateRange = $('.input-daterange input[name="start_range"]').datepicker('getDates');
			var endDateRange = $('.input-daterange input[name="end_range"]').datepicker('getDates');
			
			var startDateRange = new Date(startDateRange);
			var endDateRange = new Date(endDateRange); 
			
			var currentStartDate = startDateRange.getFullYear() + '-' + ('0' + (startDateRange.getMonth() + 1)).slice(-2) + '-' + ('0' + startDateRange.getDate()).slice(-2);
			
			while (startDateRange <= endDateRange) {
				
				startDateRange = startDateRange.getFullYear() + '-' + ('0' + (startDateRange.getMonth() + 1)).slice(-2) + '-' + ('0' + startDateRange.getDate()).slice(-2);
				endDateRange = endDateRange.getFullYear() + '-' + ('0' + (endDateRange.getMonth() + 1)).slice(-2) + '-' + ('0' + endDateRange.getDate()).slice(-2);
				
				dateRanges.push(startDateRange);
				
				var startDateRange = new Date(startDateRange);
				var endDateRange = new Date(endDateRange);
				
				startDateRange.setDate(startDateRange.getDate() + 1);
			}
			//alert(currentStartDate);
			//alert(JSON.stringify(dateRanges, null, 4));
			
			//check date range with blocked dates
			for (var i = 0; i < dateRanges.length; i++) {
				if (appointyBlockedDates.indexOf(dateRanges[i]) !== -1) {
					//alert("Date " + selectedDates[i] + " is blocked.");
					$( '.booking-slots' ).html('');	
					renderValidationMessage(appointy_options.select_avl_dates);	
					return false;
					//break;
				}
			}
			
			//check date range with blocked weekdays
			var blockedWeekdays = inititalBlockedDates.weekdaysNotInTable;
			if (typeof blockedWeekdays === 'undefined') {
				var blockedWeekdays = [];
			}
			
			var blockedWeekdaysFound = [];
	
			for (var i = 0; i < dateRanges.length; i++) {
				var date = new Date(dateRanges[i]);
				var day = date.getDay(); // 0 for Sunday, 1 for Monday, ..., 6 for Saturday
				
				if (blockedWeekdays.indexOf(day) !== -1) {
					blockedWeekdaysFound.push(dateRanges[i]);
				}
			}
		
			if (blockedWeekdaysFound.length > 0) {
				/*var message = "The following selected dates fall on blocked weekdays:\n";
				for (var j = 0; j < blockedWeekdaysFound.length; j++) {
					message += "- " + blockedWeekdaysFound[j] + " (" + getDayName(new Date(blockedWeekdaysFound[j]).getDay()) + ")\n";
				}*/
				$( '.booking-slots' ).html('');
				renderValidationMessage(appointy_options.select_avl_dates);	
				return false;
			}
		}
		appointyBookedService['selected_multiple_dates'] = dateRanges;
		//alert(JSON.stringify(appointyServices, null, 4));
		
		if(fullDayTimeSlots === 'full_day') {
			$( '.booking-slots' ).html('');	
			$( '.continueaftermultidate' ).hide();	
		}else{
			loadEditTimeSlots(currentStartDate);					
			$( '.continueaftermultidate' ).show();	
		}
		
		
	}
	
	var loadEditTimeSlots = function(appointyCurrentDate = '') {
		
		var data = {
			action       : 'appointy_load_booking_slots',
			type       	 : 'editbooking',
			multidate_service : appointyBookedService.multidate_service,
			multidate_service_type : appointyBookedService.multidate_service_type,
			selected_multiple_dates : appointyBookedService.selected_multiple_dates,
			current_date : appointyCurrentDate,
			member_id	 : appointyBookedService.member_id,
			branch_id	 : appointyBookedService.branch_id,
			service_id	 : appointyBookedService.service_id,
			service_period	 : appointyBookedService.service_period,
			booking_date	 : appointyBookedService.booking_date,
			booking_start_time	 : appointyBookedService.booking_start_time,
			booking_end_time	 : appointyBookedService.booking_end_time
		};
		
		jQuery.ajax({
			type : "post",
			dataType : "json",
			url : appointy_options.ajaxurl,
			beforeSend: toggleLoading('show'),
			data : data,
			success: function(response) {
				$( '.ap-loading-area' ).hide();
				if( response.success ) {
					$( '.booking-slots' ).html(response.data.html);
					$( '#booking-monthly-calendar' ).removeClass('sf-noslot-wrapper');
				} else {
					$( '.booking-slots' ).html(response.data.nodata);
					$( '#booking-monthly-calendar' ).addClass('sf-noslot-wrapper');
				}
			},
			complete: function() {
				toggleLoading('hide');
			}
	   }) 
		
		$('body').on('click', '.booking-slots .slotbox', function(){
				$( '.booking-slots .slotbox' ).find('.sf-time-box').removeClass( 'active' );
				
				$( this ).find('.sf-time-box').addClass( 'active' );
				
				var startTime = $( this ).data( 'start-time' );
				var endTime = $( this ).data( 'end-time' );
				
				appointySlotFlag = 1;
				
				var formatedStartTime = $( this ).data( 'formated-starttime' );
				var formatedEndTime = $( this ).data( 'formated-endtime' );
				
				appointyBookedService.booking_date = appointyCurrentDate;
				
				appointyBookedService.booking_start_time = startTime;
				appointyBookedService.booking_end_time = endTime;
				
				appointyBookedService.booking_formated_start_time = formatedStartTime;
				appointyBookedService.booking_formated_end_time = formatedEndTime;
			});
		
	}
	
	var updateDateTime = function() {
		
		// Save show/hide slots
		$('#appointment__edit').validate({
			submitHandler: function() { 
				var $this = $('#appointment__edit');
				
				var dateRanges = [];
				
				var multiDateService = appointyBookedService.multidate_service;
				var multiDateServiceType = appointyBookedService.multidate_service_type;
				var numberOfDates = appointyBookedService.number_of_dates;
				var fullDayTimeSlots = appointyBookedService.fullday_timeslots;
				
				if(multiDateService === 'yes') {
				
				if(multiDateServiceType === 'separate_dates') {
					var selectedDates = $('.multidatepicker').datepicker('getDates');
					var dateRanges = selectedDates.map(date => date.getFullYear() + '-' + ('0' + (date.getMonth() + 1)).slice(-2) + '-' + ('0' + date.getDate()).slice(-2));
					
					dateRanges.sort(function(a, b) {
						return new Date(a) - new Date(b);
					});
					
					//alert(JSON.stringify(dateRanges, null, 4));
				}else if(multiDateServiceType === 'date_range'){
					var startDateRange = $('.input-daterange input[name="start_range"]').datepicker('getDates');
					var endDateRange = $('.input-daterange input[name="end_range"]').datepicker('getDates');
					
					var startDateRange = new Date(startDateRange);
					var endDateRange = new Date(endDateRange); 
					
					var currentStartDate = startDateRange.getFullYear() + '-' + ('0' + (startDateRange.getMonth() + 1)).slice(-2) + '-' + ('0' + startDateRange.getDate()).slice(-2);
					
					while (startDateRange <= endDateRange) {
						
						startDateRange = startDateRange.getFullYear() + '-' + ('0' + (startDateRange.getMonth() + 1)).slice(-2) + '-' + ('0' + startDateRange.getDate()).slice(-2);
						endDateRange = endDateRange.getFullYear() + '-' + ('0' + (endDateRange.getMonth() + 1)).slice(-2) + '-' + ('0' + endDateRange.getDate()).slice(-2);
						
						dateRanges.push(startDateRange);
						
						var startDateRange = new Date(startDateRange);
						var endDateRange = new Date(endDateRange);
						
						startDateRange.setDate(startDateRange.getDate() + 1);
					}
					//alert(currentStartDate);
					//alert(JSON.stringify(dateRanges, null, 4));
				}
				appointyBookedService['selected_multiple_dates'] = dateRanges;
				
				if(fullDayTimeSlots != 'full_day') {
					const activeSlot = $('.booking-slots li .sf-time-box.active');
					
					if(activeSlot.length === 0) {
						renderValidationMessage(appointy_options.select_starttime);
						return false;
					}
				}
				
				}else{
					const activeSlot = $('.booking-slots li .sf-time-box.active');
					
					if(activeSlot.length === 0) {
						renderValidationMessage(appointy_options.select_starttime);
						return false;
					}
				}
				
				var data = {
					'action'       : 'appointy_update_appointment_datetime',
					'booked_service' : appointyBookedService
				};
				var formdata = $this.serialize()+'&'+$.param(data);
				
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: togglePanelLoading('show'),
					data:  formdata
				}).done(function(response) {
					togglePanelLoading('hide');
					if ( response.success ) {
						renderSuccessMessage(response.data.message);
						
						//$('#serviceblock_' +appointyBookedService.id+ ' .blockservice-date').html('<i class="fa fa-calendar"></i> ' + response.data.booking_date);
						//$('#serviceblock_' +appointyBookedService.id+ ' .blockservice-time').html('<i class="fa fa-clock-o"></i> ' + response.data.booking_start_time + '-' + response.data.booking_end_time);
						
						setTimeout(function() {
							$('#editappointmentmodal').modal('hide');
							window.location.reload();
						}, 3000);
					} else {
						renderValidationMessage(response.data.msg);
					}
				});
				return false; 
			}
		});
	}
	
	var cancelService = function() {
		// Save show/hide slots
		$('#service__cancel').validate({
			submitHandler: function() { 
				var $this = $('#service__cancel');
				
				var sid = jQuery('#service__cancel input[name="serviceid"]').val();
				var bid = jQuery('#service__cancel input[name="bookingid"]').val();
				
				var data = {
					'action'       : 'appointy_cancel_service'
				};
				var formdata = $this.serialize()+'&'+$.param(data);
				
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: toggleLoading('show'),
					data:  formdata
				}).done(function(response) {
					toggleLoading('hide');
					if ( response.success ) {
						
						/*jQuery('#service__cancel textarea[name="reason"]').val('');
						jQuery( '#servicecomplete-'+bid+'-'+sid ).remove();
						jQuery( '#servicecancel-'+bid+'-'+sid ).remove();
						jQuery( '#serviceedit-'+bid+'-'+sid ).remove();
						jQuery( '#serviceassign-'+bid+'-'+sid ).remove();
						
						jQuery( '#servicestatus-'+bid+'-'+sid ).removeClass('red');
						jQuery( '#servicestatus-'+bid+'-'+sid ).removeClass('orange');
						jQuery( '#servicestatus-'+bid+'-'+sid ).removeClass('green');
						
						jQuery( '#servicestatus-'+bid+'-'+sid ).addClass(response.data.statuscolor);
						
						jQuery( '#servicestatus-'+bid+'-'+sid ).html(response.data.servicestatus);*/
						
						renderSuccessMessage(response.data.message);
						
						/*jQuery('#service__cancel input[name="bookingid"]').val('');
						jQuery('#service__cancel input[name="serviceid"]').val('');
						jQuery('#service__cancel input[name="cancelby"]').val('');*/
						
						setTimeout(function() {
							jQuery('#cancelservicemodal').modal('hide');
							window.location.reload();
						}, 3000);
					} else {
						renderValidationMessage(response.data.msg);
					}
				});
				return false; 
			}
		});
	}
	
	var manageFeedback = function() {
		// Save show/hide slots
		$('#givefeedbackform').validate({
			submitHandler: function() { 
				var $this = $('#givefeedbackform');
				
				var sid = jQuery('#givefeedbackform input[name="serviceid"]').val();
				var bid = jQuery('#givefeedbackform input[name="bookingid"]').val();
				
				var data = {
					'action'       : 'appointy_add_feedback'
				};
				var formdata = $this.serialize()+'&'+$.param(data);
				
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: toggleLoading('show'),
					data:  formdata
				}).done(function(response) {
					toggleLoading('hide');
					if ( response.success ) {
						
						renderSuccessMessage(response.data.msg);
						
						jQuery('#givefeedbackform input[name="bookingid"]').val('');
						jQuery('#givefeedbackform input[name="serviceid"]').val('');
						
						setTimeout(function() {
							jQuery('#feedbackmodal').modal('hide');
							
							window.location.reload();
						}, 3000);
						
					} else {
						renderValidationMessage(response.data.msg);
					}
				});
				return false; 
			}
		});
	}
	
	var loadRepeatingServices = function(appointment_id = 0,service_post_id = 0) {
		
		var data = {
			'action'       : 'appointy_load_repeating_services',
			'appointment_id' : appointment_id,
			'service_post_id' : service_post_id
		};
		var formdata = $.param(data);
		
		$.ajax({
			url: appointy_options.ajaxurl,
			type:'POST',
			dataType: 'json',
			beforeSend: togglePanelLoading('show'),
			data:  formdata
		}).done(function(response) {
			togglePanelLoading('hide');
			if ( response.success ) {
				jQuery( '#load_repeat_services' ).html(response.data);
				repeatServiceTable = $('#repeatServiceTable').DataTable();
			} else {
				renderValidationMessage(response.data.msg);
			}
		});
	}
	
	var loadServiceMembers = function(appointyBookedService = []) {
		
		var data = {
			'action'       : 'appointy_get_avl_members',
			'booked_service' : appointyBookedService
		};
		var formdata = $.param(data);
		
		$.ajax({
			url: appointy_options.ajaxurl,
			type:'POST',
			dataType: 'json',
			beforeSend: toggleLoading('show'),
			data:  formdata
		}).done(function(response) {
			toggleLoading('hide');
			if ( response.success ) {
				jQuery( '#load_staff_member' ).html(response.data);
				appointyMemberFlag = 0;
			} else {
				renderValidationMessage(response.data.msg);
			}
		});
	}
	
	var loadViewAttachments = function(attachment_ids = []) {
		
		var data = {
			'action'       : 'appointy_load_view_attachments',
			'attachment_ids' : attachment_ids
		};
		var formdata = $.param(data);
		
		$.ajax({
			url: appointy_options.ajaxurl,
			type:'POST',
			dataType: 'json',
			beforeSend: toggleLoading('show'),
			data:  formdata
		}).done(function(response) {
			toggleLoading('hide');
			if ( response.success ) {
				jQuery( '#load_view_attachments' ).html(response.data);
			} else {
				renderValidationMessage(response.data.msg);
			}
		});
	}
	
	var selectStaff = function() {
		$('body').on('click', '#load_staff_member .staffitem', function() {
																				
			$( '#load_staff_member .staffitem' ).not(this).removeClass('active');
			$( this ).toggleClass('active');
			
			if($( this ).hasClass( 'active' )) {
				appointyBookedService.member_id = $( this ).data('staffid');
				appointyMemberFlag = 1;
			}
		});	
	}
	
	var updateServiceMember = function() {
		// Save show/hide slots
		$('#member__assign').validate({
			submitHandler: function() { 
			
				var $this = $('#member__assign');
				
				if(appointyMemberFlag === 0) {
					renderValidationMessage(appointy_options.validate_staff_member);
					return false;
				}
				
				var data = {
					'action'       : 'appointy_update_staff_member',
					'booked_service' : appointyBookedService
				};
				var formdata = $.param(data);
				
				$.ajax({
					url: appointy_options.ajaxurl,
					type:'POST',
					dataType: 'json',
					beforeSend: toggleLoading('show'),
					data:  formdata
				}).done(function(response) {
					toggleLoading('hide');
					if ( response.success ) {
						renderSuccessMessage(response.data.message);
						if(response.data.member_id > 0) {
							jQuery('#serviceassign-'+appointyBookedService.appointment_id+'-'+appointyBookedService.id+' a').data('booked_service',appointyBookedService);
							jQuery('#serviceassign-'+appointyBookedService.appointment_id+'-'+appointyBookedService.id+' a').html('<i class="fa fa-user"></i> '+appointy_options.text_edit_staff);
							
							jQuery('#assignedmemberinfo-'+appointyBookedService.appointment_id+'-'+appointyBookedService.id).html(response.data.member_info);
						} else {
							jQuery('#serviceassign-'+appointyBookedService.appointment_id+'-'+appointyBookedService.id+' a').data('booked_service',appointyBookedService);
							jQuery('#serviceassign-'+appointyBookedService.appointment_id+'-'+appointyBookedService.id+' a').html('<i class="fa fa-user"></i> '+ appointy_options.text_assign_staff);
							
							jQuery('#assignedmemberinfo-'+appointyBookedService.appointment_id+'-'+appointyBookedService.id).html(response.data.message);
						}
						
						setTimeout(function() {
							$('#assignmembermodal').modal('hide');
						}, 3000);
					} else {
						renderValidationMessage(response.data.message);
					}
				});
				return false; 
			}
		});
	}
	
	var ajaxPagination = function() {
		$('body').on('click', '.cvf-universal-pagination li.active', function() {
			var page = $(this).attr('p');
			var type = $('.cvf-universal-pagination').data('type');
			cvf_load_all_posts(page,type);
		   
		});
		
		function cvf_load_all_posts(page,type){
			if( type == 'appointments' ) {
				if( jQuery('#appointy_appointments_table').length > 0 ){
				var data = {
						action	: 'load_pagination_appointments',
						page : page,
						type : type,
				};
				var formdata = jQuery.param(data);		
				}
			}
			
			$.ajax({
				url: appointy_options.ajaxurl,
				type:'POST',
				dataType: 'json',
				beforeSend: toggleLoading('show'),
				data : formdata,
			}).done(function(response) {
				toggleLoading('hide');
				$(".pagination_container").html(response.data);
			});
			
		}

	}
	
	var manageCalendar = function() {
		if( jQuery('#appointment-calendar').length > 0 ) {
			var calendarEl = document.getElementById('appointment-calendar');
			
			var date = new Date();
			date.setDate(date.getDate());

			calendar = new FullCalendar.Calendar(calendarEl, {
			  locale: appointy_options.locale,
			  initialDate: date,
			  initialView: 'dayGridMonth',
			  headerToolbar: {
				left: 'prev,next today',
				center: 'title',
				right: 'dayGridMonth,timeGridWeek,timeGridDay,listWeek'
			  },
			  height: 'auto',
			  navLinks: true, // can click day/week names to navigate views
			  editable: true,
			  selectable: true,
			  selectMirror: true,
			  nowIndicator: true,
			  timeZone: appointy_options.timezone,
			  events: {
				url: appointy_options.ajaxurl,
				method: 'POST',
				extraParams: {
				 action       : 'load_appointment_calendar',
				 user_id		 : jsdata.user_id,
				},
				failure: function() {
				  alert(appointy_options.fetching_events_error);
				},
				color: '#5BD168',   // a non-ajax option
				textColor: '#000000' // a non-ajax option
			  }
			});
		
			calendar.render();
			}
	}
	
	var updateGoogleCalendar = function() {
		$('body').on('change', '#google_calendar_id', function(){
			var googleCalendarId = $( this ).val();												   
			
			if(googleCalendarId == ''){
				return false;	
			}
			var data = {
				action       : 'update_google_calendar_id',
				google_calendar_id	 : googleCalendarId
			};
			
			jQuery.ajax({
				type : "post",
				dataType : "json",
				url : appointy_options.ajaxurl,
				beforeSend: toggleLoading('show'),
				data : data,
				success: function(response) {
					toggleLoading('hide');
					if( response.success ) {
						renderSuccessMessage(response.data.message);
					}
				},
				complete: function() {
					toggleLoading('hide');
				}
		   })	
		});
		
		$('body').on('click', '.disconnectgcal', function(){
			
			var data = {
				action       : 'disconnect_google_calendar'
			};
			
			jQuery.ajax({
				type : "post",
				dataType : "json",
				url : appointy_options.ajaxurl,
				beforeSend: toggleLoading('show'),
				data : data,
				success: function(response) {
					toggleLoading('hide');
					if( response.success ) {
						renderSuccessMessage(response.data.message);
						
						setTimeout(function() {
							window.location.reload();
						}, 2000);
					}
				},
				complete: function() {
					toggleLoading('hide');
				}
		   })	
		});
		
		$('body').on('click', '.syncwithgcal', function(){
			
			var data = {
				action       : 'sync_with_google_calendar_events'
			};
			
			jQuery.ajax({
				type : "post",
				dataType : "json",
				url : appointy_options.ajaxurl,
				beforeSend: toggleLoading('show'),
				data : data,
				success: function(response) {
					toggleLoading('hide');
					if( response.success ) {
						renderSuccessMessage(response.data.message);
						
						setTimeout(function() {
							window.location.reload();
						}, 2000);
					}
				},
				complete: function() {
					toggleLoading('hide');
				}
		   })	
		});
		
	}
	
	/**
     * Document ready
     */
    $(function () {
		manageStaffAccount();
		
		managePassword();
		
		manageAppointments();
		
		updateDateTime();
		
		cancelService();
		
		manageFeedback();
		
		selectStaff();
		
		updateServiceMember();
		
		hideSuccessMessage();
			
		hideValidationMessage();
		
		ajaxPagination();
		
		manageCalendar();
		
		showRating();
		
		updateGoogleCalendar();
		
		manageMultidates();
    });

})( jQuery );
