jQuery( document ).ready( function ( $ )
{
	'use strict';

	// Add more file
	jQuery( '.rwmb-add-file' ).each( function ()
	{
		var $this = jQuery( this ),
			$uploads = $this.siblings( '.file-input' ),
			$first = $uploads.first(),
			uploadCount = $uploads.length,
			$fileList = $this.closest( '.rwmb-input' ).find( '.sk-uploaded' ),
			fileCount = $fileList.children( 'li' ).length,
			maxFileUploads = $fileList.data( 'max_file_uploads' );

		// Hide "Add New File" and input fields when loaded
		if ( maxFileUploads > 0 )
		{
			if ( uploadCount + fileCount >= maxFileUploads )
			{
				$this.hide();
			}
			if ( fileCount >= maxFileUploads )
			{
				$uploads.hide();
			}
		}

		$this.click( function ()
		{
			// Clone upload input only when needed
			if ( maxFileUploads <= 0 || uploadCount + fileCount < maxFileUploads )
			{
				$first.clone().insertBefore( $this );
				uploadCount++;

				// If there're too many upload inputs, hide "Add New File"
				if ( maxFileUploads > 0 && uploadCount + fileCount >= maxFileUploads )
				{
					$this.hide();
				}
			}

			return false;
		} );
	} );
	
	// Edit caption
	jQuery( '.sk-uploaded' ).on( 'click', '.sk-edit-file', function ()
	{
		jQuery('#gallerycaption').modal('show');
		
		 var $this = jQuery( this );
		 var attachment_id = $this.data( 'attachment_id' );
		 var itemtitle = jQuery('#item_' + attachment_id + ' .gallery_attachment_title').html();
		 var itemcaption = jQuery('#item_' + attachment_id + ' .gallery_attachment_caption').html();
		 
		 jQuery('#image_attachment_id').val( attachment_id );
		 jQuery('#gallery_caption_form input[name="imagetitle"]').val(itemtitle);
		  jQuery('#gallery_caption_form textarea[name="imagecaption"]').val(itemcaption);
		 
		 return false;
		 
	} );
	
	jQuery('#gallerycaption').on('hide.bs.modal', function() {
		jQuery('#gallery_caption_form input[name="imagetitle"]').val('');
		jQuery('#gallery_caption_form textarea[name="imagecaption"]').val('');
		
		jQuery("#gallerycaption .alert").remove();
	});
	
	/* Toggle Loading */
	function toggle_loading(status)
	{
		if(status == 'show')
		{
			jQuery('.ap-loading-area').show();
		}else if(status == 'hide')
		{
			jQuery('.ap-loading-area').hide();	
		}
	}
	
	
	
	// Delete file via Ajax
	jQuery( 'body' ).on( 'click', '.sk-delete-file', function ()
	{
		 var $this = jQuery( this ),
			$parent = $this.parents( 'li' ),
			$container = $this.closest( '.sk-uploaded' ),
			data = {
				action       : 'senddeleterequest',
				field_id     : $this.data( 'field_id' ),
				attachment_id: $this.data( 'attachment_id' ),
				user_id: $this.data( 'user_id' ),
			};
			
		 bootbox.confirm(appointy_options.are_you_sure, function(result) {

		 if(result){
				

		jQuery.post( appointy_options.ajaxurl, data, function ( r )
		{
			if ( !r.success )
			{
				return;
			}

			$parent.addClass( 'removed' );
			$parent.remove();
			$container.trigger( 'update.salonfiles' );

			// If transition events not supported
			var div = document.createElement( 'div' );
			if (
				!( 'ontransitionend' in window ) &&
				( 'onwebkittransitionend' in window ) && !( 'onotransitionend' in div || navigator.appName === 'Opera' )
			)
			{
				$parent.remove();
				$container.trigger( 'update.salonfiles' );
			}

			jQuery( '.sk-uploaded' ).on( 'transitionend webkitTransitionEnd otransitionend', 'li.removed', function ()
			{
				jQuery( this ).remove();
				$container.trigger( 'update.salonfiles' );
			} );
			
		}, 'json' );

		 }

		 })
		
	} );

	//Remove deleted file
	jQuery( '.sk-uploaded' ).on( 'transitionend webkitTransitionEnd otransitionend', 'li.removed', function ()
	{
		jQuery( this ).remove();
	} );

	jQuery( 'body' ).on( 'update.salonfiles', '.sk-uploaded', function ()
	{
		
		var $fileList = jQuery( this ),
			maxFileUploads = $fileList.data( 'max_file_uploads' ),
			$uploader = $fileList.siblings( '.new-files' ),
			numFiles = $fileList.children().length;
			
		var $uploadeditem = $fileList.find('ul li').length;
		
		if( $uploadeditem == 0 )
		{
			jQuery('form[name="gallery_form"] button[type="submit"]').attr("disabled", true);
			jQuery('form[name="gallery_form"] button[type="submit"]').addClass('btn-inactive');
			
			jQuery('form[name="identityform"] button[type="submit"]').attr("disabled", true);
		    jQuery('form[name="identityform"] button[type="submit"]').addClass('btn-inactive');
			
			jQuery('form[name="chartfilesform"] button[type="submit"]').attr("disabled", true);
		    jQuery('form[name="chartfilesform"] button[type="submit"]').addClass('btn-inactive');
			
			jQuery('form[name="medicalrecordform"] button[type="submit"]').attr("disabled", true);
		    jQuery('form[name="medicalrecordform"] button[type="submit"]').addClass('btn-inactive');
		}
		
		
		if ( numFiles > 0 )
		{
			$fileList.removeClass( 'collapse' );
		}
		else
		{
			$fileList.addClass( 'collapse' );
		}

		// Return if maxFileUpload = 0
		if ( maxFileUploads === 0 )
		{
			return false;
		}

		// Hide files button if reach max file uploads
		if ( numFiles >= maxFileUploads )
		{
			$uploader.addClass( 'collapse' );
		}
		else
		{
			$uploader.removeClass( 'collapse' );
		}
		
		var $dropArea = jQuery( '.sk-uploader' ),
		$imageList = $dropArea.siblings( '.sk-uploaded' ),
		$imageList = $imageList.find( 'ul' ),
		uploaderData = $dropArea.data( 'js_options' ),
		uploader = {};
		
		uploader = new plupload.Uploader( uploaderData );
		//uploader.init();
		uploader.refresh();
		
		jQuery('#plavatarupload-browse-button').css('z-index','99999');

		return false;
	} );

	// Reorder images
	jQuery( '.rwmb-file' ).each( function ()
	{
		var $this = jQuery( this ),
			data = {
				action     : 'rwmb_rearrangefiles',
				_ajax_nonce: $this.data( 'reorder_nonce' ),
				post_id    : jQuery( '#post_ID' ).val(),
				field_id   : $this.data( 'field_id' )
			};
		$this.sortable( {
			placeholder: 'ui-state-highlight',
			items      : 'li',
			update     : function ()
			{

				data.order = $this.sortable( 'serialize' );

				jQuery.post( appointy_options.ajaxurl, data );
			}
		} );
	} );
} );
