<?php

if ( ! defined( 'ABSPATH' ) ) {

	exit; // Exit if accessed directly

}

$required = ( isset( $field['required'] ) ) ? esc_attr( $field['required'] ) : false;

$validation_message = ( isset( $field['validation_message'] ) ) ? esc_attr( $field['validation_message'] ) : '';

$equalto = ( isset( $field['equalto'] ) ) ? esc_attr( $field['equalto'] ) : '';

$fieldid = ( isset( $field['id'] ) ) ? esc_attr( $field['id'] ) : '';



if($equalto != '')

{

$equalfield = 'equalTo=#'.$equalto.'';

$equalfieldmsg = esc_html__( 'Please enter the same password as above', 'appointy' );

}else

{

$equalfield = '';

$equalfieldmsg = '';

}

?>

<input data-rule-required="<?php echo esc_attr($required); ?>" data-msg-required="<?php echo esc_attr($validation_message); ?>" <?php echo esc_attr($equalfield); ?>  data-msg-equalTo="<?php echo esc_attr($equalfieldmsg); ?>" type="password" id="<?php echo esc_attr( $fieldid ); ?>" class="form-control" name="<?php echo ( isset( $field['name'] ) ) ? esc_attr( $field['name'] ) : esc_attr( $key ); ?>" value="<?php echo ( isset( $field['value'] ) ) ? esc_attr( $field['value'] ) : ''; ?>" placeholder="<?php echo ( isset( $field['placeholder'] ) ) ? esc_attr( $field['placeholder'] ) : ''; ?>" >

<?php if ( ! empty( $field['description'] ) ) { ?><small class="description"><?php echo wp_kses($field['description'],Appointy_Misc_Helper::get_allowed_tags()); ?></small><?php } ?>