<?php

if ( ! defined( 'ABSPATH' ) ) {

	exit; // Exit if accessed directly

}

$required = ( isset( $field['required'] ) ) ? esc_attr( $field['required'] ) : false;

$required = ( $required == 1 ) ? 'true' : 'false';

$validation_message = ( isset( $field['validation_message'] ) ) ? esc_attr( $field['validation_message'] ) : '';

$readonly = ( isset( $field['readonly'] ) ) ? esc_attr( $field['readonly'] ) : false;

$readonly = ( $readonly == 1 ) ? 'readonly="readonly"' : '';

?>

<?php
if( $key === 'map_location' || $key === 'latitude' || $key === 'longitude' )
{
?>
<input data-rule-required="<?php echo esc_attr($required); ?>" data-msg-required="<?php echo esc_attr($validation_message); ?>" type="text" id="<?php echo esc_attr( $key ); ?>" class="form-control" name="<?php echo ( isset( $field['name'] ) ) ? esc_attr( $field['name'] ) : esc_attr( $key ); ?>" value="<?php echo ( isset( $field['value'] ) ) ? esc_attr( $field['value'] ) : ''; ?>" placeholder="<?php echo ( isset( $field['placeholder'] ) ) ? esc_attr( $field['placeholder'] ) : ''; ?>" >
<?php
}else
{
?>
<input <?php echo trim($readonly); ?> data-rule-required="<?php echo esc_attr($required); ?>" data-msg-required="<?php echo esc_attr($validation_message); ?>" type="text" class="form-control" name="<?php echo ( isset( $field['name'] ) ) ? esc_attr( $field['name'] ) : esc_attr( $key ); ?>" value="<?php echo ( isset( $field['value'] ) ) ? esc_attr( $field['value'] ) : ''; ?>" placeholder="<?php echo ( isset( $field['placeholder'] ) ) ? esc_attr( $field['placeholder'] ) : ''; ?>" >

<?php
}
?>

<?php if ( ! empty( $field['description'] ) ) { ?><small class="description"><?php echo wp_kses($field['description'],Appointy_Misc_Helper::get_allowed_tags()); ?></small><?php } ?>