<?php
if ( ! defined( 'ABSPATH' ) ) {
exit;
}

wp_enqueue_script( 'plupload' );
wp_enqueue_script( 'appointy-image-manager' );
wp_enqueue_script( 'appointy-upload-files' );

$user_id = get_current_user_id();
?>

<div class="content-admin-main">
	<div class="aon-admin-heading">
		<h3><?php echo esc_html__( 'View/Edit Profile', 'appointy' ) ?></h3>
	</div>
	<form name="staff__account" id="staff__account">
		<div class="card aon-card">
			<div class="card-body aon-card-body">
				<div class="cus-pai-regis-form row">
					<div class="cus-pai-regis-left col">
						<div class="aon-pro-avtar-pic">
							<?php echo do_shortcode('[appointy-upload field_id="useravatar" user_id="'.$user_id.'"]'); ?>
						</div>
					</div>
					<div class="cus-pai-regis-right col">
						<div class="row">
							<?php
							$staffinfo = get_userdata( $user_id );
							$staff_fields = Appointy_Staff_Helper::staff_account_fields( $user_id );
							if( !empty( $staff_fields ) ) {
								foreach( $staff_fields as $key => $field ){
									
									if($key === 'username') {
										$field['value'] = Appointy_Router_Helper::get_request_data( $staffinfo, 'user_login' );
									}elseif($key === 'email'){
										$field['value'] = Appointy_Router_Helper::get_request_data( $staffinfo, 'user_email' );
									}else{
										$field['value'] = get_user_meta( $user_id, $key, true );
									}
									
									Appointy_Form_Helper::get_form_structure($key,$field);
								}
							}
							?>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="ap-admin-footer d-flex justify-content-between align-items-center">
			<div class="aon-admin-footer-right">
				<button type="submit" class="admin-button">
				<?php _e('Save', 'appointy'); ?>
				</button>
			</div>
		</div>
		<input name="staffid" type="hidden" value="<?php echo esc_attr($user_id); ?>">
	</form>
</div>
