<?php
if ( ! defined( 'ABSPATH' ) ) {
exit;
}
?>

<div class="content-admin-main">
	<div class="aon-admin-heading">
		<h3><?php echo esc_html__( 'Appointments', 'appointy' ) ?></h3>
	</div>
	<?php
	$user_id = get_current_user_id();
	$post_per_page = Appointy_Appointments_Helper::get_appointment_per_page();
	$results = Appointy_Appointments_Helper::get_staff_appointments( $user_id, $post_per_page);
	
	$total_results = Appointy_Appointments_Helper::get_staff_total_appointments( $user_id);
	
	$total_post = count($total_results);
	$post_count = count($results);
	
	$bookingurl = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-booking-form' );
	$staff_dashboard_url = Appointy_Misc_Helper::get_url_by_shortcode( '[appointy-staff-dashboard' );
	
	if ( $results ) {
		echo '<div class="pagination_container" id="appointy_appointments_table">';
		foreach($results as $row){
			$appointment_id = Appointy_Router_Helper::get_sanitize_data( $row, 'appointment_id' );
			$service_id = Appointy_Router_Helper::get_sanitize_data( $row, 'id' );
			$appointment_date = Appointy_Router_Helper::get_sanitize_data( $row, 'booking_date' );
			$appointment_time = Appointy_Router_Helper::get_sanitize_data( $row, 'booking_start_time' );
			$multidate_service = Appointy_Router_Helper::get_sanitize_data($row,'multidate_service');
			$service_post_id = Appointy_Router_Helper::get_request_data($row,'service_id');
			
			$customer_id = get_post_meta($appointment_id,'booking_customer_id',true);
			$customer_id = ( $customer_id != '' ) ? $customer_id : 0;
			
			$viewbooking = add_query_arg( array( 'navitem' => 'view-appointment','appointment_id' => $appointment_id,'service_id' => $service_id ), $staff_dashboard_url );
			?>
			<div class="sf-appoi-row">
				<div class="d-flex justify-content-between align-items-center">
					<div class="sf-appoi-first d-flex align-items-center">
						<div class="aon-date-box"> <strong><?php echo wp_date('d',strtotime($appointment_date)); ?></strong> <span><?php echo wp_date('M',strtotime($appointment_date)); ?></span> </div>
						<div class="sf-appoi-user"> <img src="<?php echo Appointy_Staff_Helper::get_user_avatar($customer_id,'appointy-300x300'); ?>" alt=""> </div>
						<div class="sf-appoi-info">
							<h4><?php echo Appointy_Appointments_Helper::get_appointment_customername( $appointment_id ); ?></h4>
						</div>
					</div>
					<div class="sf-appoi-second">
						<?php if($multidate_service === 'yes') { 
						$multidatedates = Appointy_Appointments_Helper::get_multidate_booking_dates($appointment_id,$service_post_id);
						?>
						<i class="fa fa-calendar-o"></i> <a href="javascript:;" class="ap-multidate-dates viewmultidatedates" data-multidatedates="<?php echo esc_attr( $multidatedates ); ?>"><?php echo esc_html__('View Dates','appointy'); ?></a>, <i class="fa fa-clock-o"></i> <?php echo Appointy_Misc_Helper::get_time_format($appointment_time); ?>
						<?php }else{ ?>
						<i class="fa fa-calendar-o"></i> <?php echo wp_date('l',strtotime($appointment_date)); ?>, <i class="fa fa-clock-o"></i> <?php echo Appointy_Misc_Helper::get_time_format($appointment_time); ?>
						<?php } ?>
					</div>
					<div class="sf-appoi-second"> <span class="btn-pending"><?php echo Appointy_Appointments_Helper::get_appointment_payment_method($appointment_id); ?></span> </div>
					<div class="sf-appoi-third">
						<div class="dropdown action-dropdown dropdown-left">
							<button  type="button" class="action-button btn btn-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false"> <i class="fa fa-ellipsis-v"></i> </button>
							<ul class="dropdown-menu" >
								<li><a class="dropdown-item" href="<?php echo esc_url($bookingurl); ?>"><i class="feather-calendar"></i> <?php echo esc_html__( 'Book Agian', 'appointy' ) ?></a></li>
								<li><a class="dropdown-item" href="<?php echo esc_url($viewbooking); ?>"><i class="feather-eye"></i> <?php echo esc_html__( 'View Detail', 'appointy' ) ?></a></li>
							</ul>
						</div>
					</div>
				</div>
			</div>
			<?php
		}
		Appointy_Appointments_Helper::ajax_pagination( 'appointments', $total_post, $post_count, $post_per_page, 1 );
		echo '</div>';
		wp_reset_postdata();
	}else{
		echo '<div class="no-data">';
		echo esc_html__( 'There is no appointment.', 'healthify' );
		echo '</div>';
	}
	?>
</div>

<?php
Appointy_Template_Loader::get_template_part( 'admin/appointments/multidate-dates' );
?>
